// SysNames.h, names exported from TurkFrame.h -- 2014 June 3

#ifndef MOS_SysNames // for private library functions & data.. extern CAST_
#define MOS_SysNames
#define _0_RevDate_                                  0x20140603

#include <stdlib.h>
#include <string.h>
#include <typeinfo>
#include <cstdio>
#include <new>

#ifdef __MSL__ // so we can test-compile it in CodeWarrior on the Mac
#include "Windoze.h"
#else
#define STRICT
#include <windows.h>
// #include <commctrl.h> // DLL not available on Win95
#endif // __MSL__

#define _Is_In_C_ true

#define _Strings_Log_ 256 // =256 if using MonitorStrings(), else =1
#define _log_these_arrays_ 0xFFFF // arrays larger than this get monitored
#define _fS_ 1 // # ints to reserve at front of Object for VS dTab (thot =0)

#ifndef Debug_Trace // omit these three lines to disable log file..
#define Debug_Trace "C:\\AllDocs\\DebugLog.txt" // enables DebugLogFile
#endif // Debug_Trace

#define _Log_Destructors_ 0 // 0 omit, 1 logs objs, 2 also arys of arys, 3 all
#define _Crash_and_Burn_ true // div/0 in Array_Bounds_Fail and elsewhere
#define _Sync_Debug_ false // apparently unneed
#define SigWait_Trace 0 // C++ doesn't like: true; =2 to div/0

#define Drag_Trace true
#define Clik_Trace true
// #define Draw_Trace false // traces image items in DrawImag (unused)
#define Sys_Trace 0 // turns message traffic on/off
#define Post_Trace 1 // logs Post_Ev (Send/Async) only
#define Panic_Log 0 // 1024; =2^n; >0 logs recent stuff (evts only)
#define Event_Log 2048 // =2^n; >1 logs recent Win32 evts

using namespace std; // should apply everywhere

////////////////////////////////////////////////////////////////////////

// My Own Memory Allocation Manager (removed)..

#if (SigWait_Trace)
#define Debug_Res_Tracer(ss) _FrameWork_::CameForWho(ss) // used in Cstuff
#else
#define Debug_Res_Tracer(ss) {}
#endif // (SigWait_Trace)

////////////////////////////////////////////////////////////////////////

// Names defined in package SysDefs (but removed by T2C)..

#define _Mac_OS_ 0
#define _Wintel_ 1
#define FileDelimiter '\\'

extern int _my_Global_Inits_; // used by _Object_() to init globals early
extern int* _tmp_0_; // temp widely used in pointer allocation
extern int* _tmp_00_;
extern int __aix__, __aiy__, __aiz__;

// Types & variables & constants used in TurkFrame.h ..

extern int* Object__type; // base of hierarchy used for DownCast()
extern int* Throwable__type;
extern int* Event__type;
extern int* WindowOps__type;
extern int* RectAngle__type;
extern int* Widgit__type;
extern int* WindInfo__type;

extern int _See_Look_; // used by _Look_See_

typedef int X1NT;
typedef int* IntArray;
#define Win_Window HWND
#define WinFile HANDLE
#define Sem_32 HANDLE

#define C_string char*

class _Look_inside_C_ {
#ifdef HANDLE
  int HANDLE_is_defined;
#ifdef WinFile
  WinFile WinFile_is_defined;
#endif // WinFile
#endif // HANDLE
  int no_more;};

// typedef int* DraCliPkg; // def'd in C_Turk.h, #incl'd from there

struct _Event_; // typedef _Event_* Event;
#define Event _Event_*
class _T2F_Process_;
typedef _T2F_Process_* Process;
typedef _T2F_Process_* T2F_Process;
class _File_;  typedef _File_* File;

typedef int* int_star;

struct _Widgit_; typedef _Widgit_* Widgit;
struct _WindInfo_; typedef _WindInfo_* WindInfo;
typedef _WindInfo_* Window;
typedef _WindInfo_* MenuBar; // type MenuBar; // see class WindInfo for contents

typedef int Point;
#define Nowhere 0x80008000   // final Point Nowhere = &0x80008000;

#define HiBit (1<<31)
#define boolean int
#define null NULL

#define TabKey '\t'
#define EnterKey '\n'
#define BSkey ((char)8)
#define DelKey ((char)127)
#define EscKey ((char)27)
#define LfArKy ((char)28)
#define RtArKy ((char)29)
#define UpArKy ((char)30)
#define DnArKy ((char)31)

#define CapsLockKey 0x10000 // in the "KeyI" message datum
#define ShiftKey 0x20000
#define ControlKey 0x40000
#define AppMenuKey 0x80000 // = Cmd
#define WinKey 0x100000 // = Opt
#define AltKey 0x100000

// Constants for file access..
#define Fi_Find_32 WIN32_FIND_DATA
#define ReadWrite 0
#define ReadOnly 1
#define WriteOnly 2
#define Append 3 // =WriteOnly, but starts at end
#define CreateFi 0
#define ExistingFi 4
#define TextFile 0
#define BinaryFile 8
#define Directory 16 // otherwise (create/open) a file
#define ResFileTy (BinaryFile+Directory)
#define DirecOnly ResFileTy // mask for separating Dir from ResFi
#define Executable 32
#define MacResFi 56
#define MakeFiRef 64
#define SharedFile 128
#define SharedResFile 152
#define InvisiFile 128
#define FlagMask 0xFFF // ref count is above that in dirs
#define FileErr (-256) // default, others +
#define FileEOF (FileErr+1) // only in InfoFil
#define NoSuchFile (FileErr+2)

// Selector constants for posting window manager events to foreground thread
#define Windo_Event (WM_USER*2) // WM_USER=0x0400
#define WEV_HidenShoWgt (Windo_Event+2)
#define WEV_Delay     (Windo_Event+27)
#define WEV_MsgBx     (Windo_Event+28)
#define WEV_AskTx     (Windo_Event+29)
#define WEV_CheckMenu (Windo_Event+43)
#define WEV_AddMenu   (Windo_Event+44)
#define WEV_UndoMenu  (Windo_Event+45)
#define WEV_NewMenBar (Windo_Event+46)
#define WEV_PopMenu   (Windo_Event+47)
#define WEV_NewWindow (Windo_Event+48)
#define WEV_CloseWind (Windo_Event+49) // CloseWindow
#define WEV_ShowWind  (Windo_Event+50) // Win2Behind/ShowWindow
#define WEV_WindowAcc (Windo_Event+51) // WindowAccess
#define WEV_HideWind  (Windo_Event+53)
#define WEV_InvalRect (Windo_Event+54)
#define WEV_DocScroll (Windo_Event+59) // Get-/SetDocScroll
#define WEV_WigitDraw (Windo_Event+60) // WidgitDraw
#define WEV_IniWidgit (Windo_Event+62)
#define WEV_PkgDunn   (Windo_Event+85)
#define WEV_DragonDrop (Windo_Event+87)
#define WEV_Splsh     (Windo_Event+88)
#define WEV_NoHigher  (Windo_Event+99) // protect from spurious WinXP garbage

// field names for Win_Set/Get:
#define _rTop 0
#define _rLeft 1
#define _rBotm 2
#define _rRite 3
#define _wKind 4
#define _wName 5
#define _wFlags 6
#define _wLink 7
#define _wParent 8
#define _wChild 9
#define _wWindo 10
#define _FoBgColo 11
#define _theText 12
#define _MoInfo 13
#define _HostInfo 14
#define _wOwner 15
#define _wNxID 16
#define _wFocus 17
#define _wTextVH 18
#define _wUserData 19
#define _wMoreInfo 20
#define _wCoverR 21
#define WinFlagsOffs _wFlags

////////////////////////////////////////////////////////////////////////

// Constants added to style to choose wigit type
#define Wgt_None 0
#define Wgt_Butn 1
#define Wgt_Comb 2
#define Wgt_Labl 3
#define Wgt_Edit 4

// wFlags bit masks used in TurkFrame, the rest are defined in WinWgMgr..
#define wiVisble 1
#define wiClikIn 64 // window shows Trsh icon
#define wiDragble 1024 // dragable
#define wiDropble 2048 // takes drops
#define wManaged 0x20000000 // window manager handles clicks/updates
// #define wUpdating 0x10000000 // (win) busy, refuse update evts (C: NOT temp hid)

// Globals to support windows and widgits..
//  HBRUSH StockWhiteBrush;  HBRUSH StockBlackPen;
//  HBRUSH PreProgBrush;     HBRUSH ProgressBrush;

#define Menu_LineHeight 20
#define Menu_Comm_base 3333
#define Max_Menus 256
// #define BaseM_LineHgt 17 // ad hoc as observed, to be adjusted (NOT)
// int Menu_Hi_Chek = 2222, Menu_Preselect = -1, Menu_LineHeight = BaseM_LineHgt;

// These colors -- white black red brown -- are not used

int set_ary_size(void* aptr, int siz, int clss); // used in classes

////////////////////////////////////////////////////////////////////////

// Global declarations used in WinMain/InitializeAll..

/// 4-character-as-int (Char4) type, intrinsic to Turk/2..

typedef int Char4;

#define CHR4_4_4c(a,b,c,d) ((Char4)((((((((int)a)<<8)+((int)b))<<8) +((int)c))<<8)+((int)d)))

/// ref-counted String type, intrinsic to Turk/2..

//  String is a 1-word reference to the string value, =0 is ""  _Str_()
//  String compare in T2 is not case-sensitive in the ASCII range

typedef int* String; // +1: ref-cnt, +2: int len, +3: str len, +4: text

////////////////////////////////////////////////////////////////////////

struct _Object_ {int _00_,_000_; // ref-count, object size
  String errMsg;
  int* My__Type;
  _Object_(); // we get first shot, subclass const'rs act later
  virtual String getMessage() {return errMsg;}
  virtual String getLocalizedMessage() {return getMessage();}
  void _dn_ptr_();}; //~Object

typedef _Object_* Object;

struct O__object__ {O__object__* link; int kin;
  virtual void Zero_Refs(Object ox);
  virtual void InstallMe(O__object__* whom);
  // friend void _Do_Zero_(Object ox, int info);
  O__object__() {kin = 0; link = NULL;}};

void _Do_Zero_(Object ox, int info);

struct _Throwable_: _Object_ {_Throwable_() {}}; //~Throwable
typedef _Throwable_* Throwable;

struct O__Throwable__ : O__object__ {
  void Zero_Refs(Object ox);
  O__Throwable__();}; //~ O__Throwable__

Throwable new__Throwable_();

namespace  _FrameWork_ { // for private library functions & data..

extern HINSTANCE Main_Context; // context passed to main from Win32
// extern Char4 Next_Win_ID; // now unused

extern char null_char;
extern char* Program_Name;
extern String One_Dot, Two_Dots; // some string "constants"
extern String ClipDragStr, Res_Str, Xfer_Str;
extern Char4 ClipDragOwn;
extern int* theClipDrag;

#define ClpDrgPkSz 44
extern int ClipDragPkg[_fS_+2+ClpDrgPkSz+1]; // pkg positions:
  //  +0 length = 44 // ClipDragPkg[2] = 44;
  // 3+0 length (dupe); -> pkg if Signature<0
  // 3+1 Signature "Drag" or "Drop"
  // 3+2 current size
  // 3+3 Sender's procID
  // 3+4 LENGTH(theDrag.DrDataStr), for validation
  // 3+5 Chr4Str(theDrag.DrDataStr), ditto
  // 3+6 current (potential) drop loc, -1 if trash can
  // 3+7 modifiers
  // 3+8 start of real data

// MsgBox constants and fwds..
// extern Char4 DocX4, Imag4, PrgB4, TxtD4, Next_ProcID, Typ4; // obsolete..
#define DocX4 CHR4_4_4c('D','o','c','X') // ((Char4)0x446F6358) // "DocX"
#define Imag4 CHR4_4_4c('I','m','a','g') // ((Char4)0x496D6167) // "Imag"
#define PrgB4 CHR4_4_4c('P','r','g','B') // ((Char4)0x50726742) // "PrgB"
#define TxtD4 CHR4_4_4c('T','x','t','D') // ((Char4)0x54787444) // "TxtD"
#define Typ4 CHR4_4_4c('T','y','p','e') // ((Char4)0x54797065) // "Type"

extern Char4 Next_ProcID;
extern Process MainProgram, Ready_List;

extern Window PIB_wins, Free_Wins; // master window list, closed spares
extern Window Progress_o; // cached progress bar win, cuz deleting it bombs
extern Window Pacify_wins; // window(s) being redrawn
extern Window Cursor_Win; // last known window showing cursor
extern Window SendingWin; // where I started this drag (if so)
// extern const Window theDrag; // now in Csystem

// struct Menu_Com_ {Process whose; Char4 say;};
extern Char4 Menu_Comms[Max_Menus+2];
extern int Num_Menus, Tix_Now, Tix_100ms, n_Timers; // PIBsysErr,
extern int Mouse_Buttons, Modifier_Keys, Window_Count;
extern HWND DoxClik_Win; // the window clicked in for Mouse_Button
extern int FlushClix; // >0 to flush spurious clicks from file dlg
extern Point ClikPt, ScroRefLoc, Mouse_Locn;
extern Event Pending_Event;
extern boolean Fresh_Mods, Menu_Is_Open, Drag_Is_Busy, FlushDBlog;
extern File PIBfiles;
extern unsigned char* theScreen;
extern unsigned char* myScreen;
extern int Sys_State_Bits, myScrnTall, myScrnWide, ScreenTall, ScreenWide;

extern File Using_ResFi, PIBwDir;
extern File DebugLogFileOpen;
extern Fi_Find_32 FindInfo;

extern HWND GooeyWin, HasSplash, FrontedWin, theFrontWin; // used in Csystem..
extern Sem_32 ResFi_Lok; extern Sem_32 Strn_Lok; extern Sem_32 Goo_Lok;
extern Sem_32 Even_Lok; extern Sem_32 User_Lok; extern Sem_32 Panic_Lok;
extern int PkgPending, my_Cursor, Tenth_Seconds; // used to blink caret

extern HCURSOR HourGlass;   extern HCURSOR OldCursor;  extern HCURSOR CrossHair;
extern HCURSOR PlainArrow;  extern HCURSOR Ibeam;
extern HCURSOR DiagonalAro; extern HCURSOR NorthSouth; extern HCURSOR EastWest;

extern int SemRefLockt, SemRefCount, SemRefHisto;
// extern boolean No_Valid_Check;

extern int _String_Log_Count_;
extern int the_String_Log[_Strings_Log_+4]; // used in C_Turk

} // (temply) end namespace  _FrameWork_

// #ifdef MOS_System
// #define Next_WinID NxtWinID
// #else
// #define Next_WinID _FrameWork_::Next_Win_ID
// #endif // MOS_System

#define Null_Str (String)00

#define Null4 ((Char4)0000)
#define NoName CHR4_4_4c(' ',' ',' ',' ') // ((Char4)0x20202020)
#define QuestIcon CHR4_4_4c('Q','s','t','n') // ((Char4)0x5173746E) // "Qstn"
#define InfoIcon CHR4_4_4c('B','a','n','g') // ((Char4)0x42616E67) // "Bang"
#define StopIcon CHR4_4_4c('S','t','o','p') // ((Char4)0x53746F70) // "Stop"

extern RECT _W32_Rect_; extern POINT _W32_Pint_;

////////////////////////////////////////////////////////////////////////

/// Opaque File type, implemented as a pointer to a _File_ class..

// class _File_;  typedef _File_* File; // def'd, used above
class _File_ { // mostly same subfields as MOS record..
  String FilNamLnk, DirPath;
  File FileLink;
  WinFile FileInodN;
  File ParDirLnk;
  int FiFlagCnt, FilePosnO, FileRefNum, OwnerPro;
  HANDLE Find_Hand;
public:
  void flush_(); // don't use, interminable delays!
  virtual int GetRefNum();
  File GetLink();
  void LinkMe2(File whom);
  WinFile GetWn32_File();
  void File_w32_Zap(WinFile wfi);
  String myFileName();
  String myFullPath();
  int GetFlagz();
  void SetFlagz(int flagz);
  int GetFpos();
  void SetFpos(int here);
  HANDLE GetFiHand();
  void SetFiHand(HANDLE theH);
  void SetFiOwn(int whom);
  _File_(String pth, WinFile wfi, int flg);
  _File_();
  friend File File_4int(int whom);
  friend boolean IsValidFile(File aFile);
  friend File Find_Directry(String path, boolean Sharon, int whom);
  friend File Find_UnusedFi();
  friend File OpenInDir(String name, int opt, File dir);
  friend File Close2Ref(File aFile);
  friend int Read_Data(File aFile, int* ary, int nby);
  friend int Write_Data(File aFile, int* ary, int nby);
  friend String ReadLine(File aFile);
  friend void Seek(File aFile, int offs);
  friend void SetFiNames(File aFile, String thePath);
// #ifdef MOS_System // unimplemented, unused..
//   friend void GetFileInfo(File aFile, int* ary);
//   friend void SetFileInfo(File aFile, int* ary);
// #endif // MOS_System
  friend File FileFromID(int fi);
  ~_File_();}; // ~_File_

////////////////////////////////////////////////////////////////////////

/// Process management stuff..

class _T2F_Process_ {public: // base class for processes
  int _00_,_000_,_0_0_,_0__0_; // reference count, memory block length, null msg+ty
  Char4 PIBprocID; // was: _my_ID_, the process name we use to identify them
  Process ParentPro, PIBlink; // was: _link_ (used only in C_Turk)
  Sem_32 _wait_event_; // was: PIBeventQ = where we wait for events
  Sem_32 _reply_wait_; // was: EvWaits, wait for reply when send msg to other proc
  Event _event_list_;
  String _my_name_;   // was: myName
  int _Delay_Time_; // see also PkgPending
  DWORD WinThread_ID; // was: WinThreadID;
  HANDLE Thread_32;   // was: theThread;
  int* PIBundo; // undo package for this process; sb DraCliPkg but undef'd
  Window PIBactWin;
  int PIBfilErr, PendBitz; // see also Pkg_Pending in Csystem
  int* CameFromStk;
  virtual void T2F_Quit();
  virtual Process Resume(); // returns next link in sem_Q
  // ~_T2F_Process_();
  _T2F_Process_();
  _T2F_Process_(String pname, Char4 pnam4);}; //~T2F_Process

/// Predefined Event class, implemented as a pointer to class _Event_

// struct _Event_; typedef _Event_* Event; // ---------- from T2C-compiled T2..
struct _Event_: _Object_ {
  Char4 EventNo;
  int EvInfo;       // EvInfo is size or click time
  int EvLocn;       // EvLocn is mem addr or mouse loc
  int EvDatum;
  Process EvSend; Event _ev_link_;
  int _ev_state_; // 0 no reply; 1 queued; 2 seen, waiting reply; 3 removed
  virtual int GetState();
  virtual void EnQueue(Process whom, boolean state);
  friend Event De_Queue(Process whom);
  friend void Valid8_Event(Event theEv);
  _Event_() {set_ary_size((void*)this,9,9);  My__Type = Event__type;}}; //~Event

struct O__Event__ : O__object__ {
  void Zero_Refs(Object ox) {
    Event whom = NULL;
    if (typeid(*ox) == typeid(_Event_)) whom = (Event)ox;
    if (whom != NULL) delete whom;}
  O__Event__();}; //~ O__Event__;

Event new__Event_();

/// Predefined Rectangle class (base class for all widgits)

struct _RectAngle_; typedef _RectAngle_* RectAngle;
struct _RectAngle_: _Object_ {
  int rTop; // this is at +16 (assuming _fS_=1)
  int rLeft;
  int rBotm;
  int rRite;
  _RectAngle_() {
    set_ary_size((void*)this,6,13);
    My__Type = RectAngle__type;}}; //~RectAngle

struct O__RectAngle__ : O__object__ {
  void Zero_Refs(Object ox);
  O__RectAngle__();}; //~ O__RectAngle__

RectAngle new__RectAngle_();

/// Opaque Window type, implemented as a pointer to WindInfo class (from T2C)..

struct _WindowOps_; typedef _WindowOps_* WindowOps;
struct _WindowOps_: _Object_ {
  virtual int WhoMeQ();
  virtual void DoWinOp(int whom, int theWin, int pram1, int pram2, int pram3);
  virtual void DoWgtOp(int whom, int theWin, int pram1, int pram2, int pram3);
  _WindowOps_() {
    set_ary_size((void*)this,2,12);
    My__Type = WindowOps__type;}}; //~WindowOps

struct O__WindowOps__ : O__object__ {
  void Zero_Refs(Object ox);
  O__WindowOps__();}; //~ O__WindowOps__

WindowOps new__WindowOps_();

// struct _Widgit_; typedef _Widgit_* Widgit; // defined and used above
struct _Widgit_: _RectAngle_ {
  Char4 wKind;
  Char4 wName;
  int wFlags;
  Widgit wLink;
  Widgit wParent;
  Widgit wChild;
  Window wWindo;
  int FoBgColo;
  String theText;
  int MoInfo;
  int HostInfo;
  _Widgit_() {set_ary_size((void*)this,17,14);  My__Type = Widgit__type;}
public: // added methods..
  Win_Window Win32Win() {return (Win_Window)((void*)HostInfo);}
  void Win32set(Win_Window w32) {HostInfo = (int)w32;}
  _Widgit_(Window inW, Widgit par, String tx, Char4 kin,
      RectAngle rc, Win_Window aWin);
  ~_Widgit_();}; //~Widgit

struct O__Widgit__ : O__object__ {
  void Zero_Refs(Object ox);
  O__Widgit__();}; //~ O__Widgit__

Widgit new__Widgit_();

// struct _WindInfo_; typedef _WindInfo_* WindInfo; // defined and used above
struct _WindInfo_: _Widgit_ {
  Char4 wOwner;
  Char4 wNxID;
  Widgit wFocus;
  Point wTextVH;
  int wUserData;
  int wCursor;
  int wMoreInfo;
  int wCoverR;
  WindowOps WinOps;
public: // added methods..
  _WindInfo_(String tx, Char4 kin, Char4 owner, Win_Window aWin, RectAngle rc);
  void Link_Me_In(Char4 kin);
  void Un_Link_Me(boolean Add2Free);
  Widgit Get_Wgt(int parm);
  int Win_Get(int parm);
  void Set_Wgt(Widgit datum, int parm);
  void Set_Title(String title);
  void Win_Set(int datum, int parm);
  _WindInfo_(); // additional code in TurkFrame
  ~_WindInfo_();}; //~WindInfo

struct O__WindInfo__ : O__object__ {
  void Zero_Refs(Object ox);
  O__WindInfo__();}; //~ O__WindInfo__

// WindInfo new__WindInfo_(); // unused

////////////////////////////////////////////////////////////////////////

// Forwards defined in TurkFrame.h ..

// Standard type conversions and other built-ins..

inline int LoWord(int x) {return (x&0x7FFF)-(x&0x8000);}
// inline int HiWord(int x) {return x >> 16;}
// inline int LoHalf(int x) {return x&0xFFFF;}
// inline int Pack2ints(int V, int H) {return (H&0xFFFF)+(V<<16);}
// inline int MaskInts(int a, int b, int m) {return (a&~m)+(b&m);}

inline int MAX(int x, int y) {if ((x)>(y)) return x; else return y;}
inline int MIN(int x, int y) {if ((x)<(y)) return x; else return y;}
inline int ABS(int x) {if (x<0) return -x; else return x;}

// #define LoWord(xx) (((xx)&0x7FFF)-((xx)&0x8000))
#define HiWord(xx) ((xx)>>16)
#define LoHalf(xx) ((xx)&0xFFFF)
#define Pack2ints(a,b) (((b)&0xFFFF)+((a)<<16))
#define MaskInts(a,b,m) ((a)&~(m)|(b)&(m))

#define SysDebugLogging() (_FrameWork_::DebugLogFileOpen)

// #define MAX(a,b) ((a)<(b)?(b):(a))
// #define MIN(a,b) ((a)>(b)?(b):(a))
// #define ABS(xx) ((xx)<0?-(xx):(xx))

#define Capitize(xx) (((xx)<'a')?(xx):(((xx)>'z')?(xx):(char)(((int)(xx))-32)))
#define IgnoreBool(xx) xx
#define IgnoreInt(xx) xx
#define Int_CAST(xx) (int)xx
#define BoundsNullError()

// ORD() returns an integer cast of its parameter
inline int ORD_B(boolean b) {if (b) return 1; else return 0;}
inline int ORD_4(Char4 c) {return (int)c;}
inline int ORD_C(char c) {return (((int)c)&255);}
inline int ORD(char c) {return (((int)c)&255);}
inline int ORD(int i) {return i;}
inline int ORD(const char* st) { // nominally Big-Endian, like Char4
  int n = strlen(st);
  if (n==0) return 0;
  if (n==1) return ((int)st[0])<<24;
  if (n==2) return ((((int)st[0])<<8)+((int)st[1]))<<16;
  if (n==3) return ((((int)st[0])<<16)+(((int)st[1])<<8)+((int)st[2]))<<8;
  return (((int)st[0])<<24)+(((int)st[1])<<16)+(((int)st[2])<<8)+((int)st[3]);}
inline char CHR(int c) {return (char)(c&255);}
inline boolean ODD(int valu) {return (boolean)(valu&1);}

//inline char Capitize(char ch) { // POST: result is not lower-case letter
//  if (ch<'a') return ch;
//  if (ch>'z') return ch;
//  return CHR(ORD(ch)-32);}

inline int _PEEK_(int iPtr) { // Dangerous.PEEK()
  int* xptr = (int*)iPtr;
  return *xptr;}
inline void _POKE_(int iPtr, int val) { // Dangerous.POKE()
  int* xptr = (int*)iPtr;
  *xptr = val;}
inline void _2POKE0_(int* xptr) {*(++xptr) = 0; *(++xptr) = 0;} // StringArrayZap

// Some type-casts for sending complex events..
#define int_2_ptr(i) (int*)((long)(i))
#define ptr_2_int(p) (int)((long)((void*)(p)))

inline RECT* W_32(RectAngle rx) { // copy rx to (temp) _W32_Rect_ (in Gooey)
  _W32_Rect_.top = rx->rTop;
  _W32_Rect_.left = rx->rLeft;
  _W32_Rect_.bottom = rx->rBotm;
  _W32_Rect_.right = rx->rRite;
  return &_W32_Rect_;}

inline void T_32(RectAngle rx) { // restore rx from (temp) _W32_Rect_
  rx->rTop = _W32_Rect_.top;
  rx->rLeft = _W32_Rect_.left;
  rx->rBotm = _W32_Rect_.bottom;
  rx->rRite = _W32_Rect_.right;}

inline POINT* W_31(int pt) { // ditto for _W32_Pint_..
  _W32_Pint_.x = LoWord(pt);
  _W32_Pint_.y = HiWord(pt);
  return &_W32_Pint_;}

inline int T_31() {return Pack2ints(_W32_Pint_.y,_W32_Pint_.x);}

/// array/pointer management routines..

void my_free(int* ary, int whom);
void Log_Res_Info(int rez, int rty, int FiNo);

namespace  _FrameWork_ { // resume name space protection..

void copy_bytes(const char* frm, char* too, int nby);
void Fill_Block(int valu, int* addr, int nwds);
int Str__Order(char* Ap, char* Bp, char* Cp);
boolean Fetch_Event(Event evp, Process whom);
void Refresh_Modifiers();
void Log_This_Evt(int msg);
void FILL0(int* ary, int offs, int nwds);
boolean PendEx(int why, int bitz, Process whom);
void Asyn_Msg(Char4 EvNo, int eInfo, int EvLoc, int EvDat, Process toPro);

} // end namespace  _FrameWork_

inline void BlockMove(int frm, int too, int nby) {
  _FrameWork_::copy_bytes((char*)frm,(char*)too,nby);}
inline void PokeByte(int cPtr, int val) {
  char* xptr = (char*)cPtr;
  *xptr = (char)(val&255);}
inline int Peek_Byte(int cPtr) {
  char* xptr = (char*)cPtr;
  return ((int)*xptr)&255;}
#define PeekChar(x) ((char)Peek_Byte(x))

// int set_ary_size(void* aptr, int siz, int clss); // def'd, used above
int* my_int_ary(int lnx, int why, int whom); // new_int_ary(lnx,why);
#define new_int_ary(lnx,why) my_int_ary(lnx,why,_BASE_+__LINE__)
#define coming_from(why) Coming__From(why,_BASE_+__LINE__)

int* up__ptr(void* aptr);
int* dn__ptr(void* aptr, int whom);

#if _Log_Destructors_
#define _Destructo_Log_(s) SystemDebugLog(_cat__(_BASE_+__LINE__,"_Destructo_ ",s))
#else
#define _Destructo_Log_(s) down__ptr(s) // alternate: no log
#endif // _Log_Destructors_

// inline int LENGTH(int* ary) {return (ary?ary[_fS_+1]:0);}
inline int _Array_LENGTH_(int* ary) {return (ary?ary[_fS_+1]:0);}

#define FILL_0(ary,offs,nwds) _FrameWork_::FILL0((int*)ary,offs,nwds)
#define DeadPointerCheck(xx) // _FrameWork_::ViewArrayInDebugger(xx)

#define down__ptr(ary) dn__ptr((void*)ary,_BASE_+__LINE__)
// void DoneWith(int* aPtr);
// #define DoneWith(ary) {} // _System_::Cache_Done(ary,_BASE_+__LINE__)
// #define Done_With(ary,whom) dn__ptr(ary)
// #define Done_With(x) {}

#define SameArray(a,b) (a==b)

#define _Bnds_ChkL_(ary,aix) if(((__aiy__=(aix))<0)||(((__aiz__=(int)(ary[_fS_+1]))>0)&&(__aiy__>=__aiz__))) _Array_Bounds_Fail_(__aiy__,__aiz__); else ary[_fS_+2+__aiy__]

#define _Bnds_ChkR_(typ,ary,aix) ((((__aix__=(aix))>=0)&&((__aiz__= (int)(ary[_fS_+1])) >__aix__)) ? ary[_fS_+2+__aix__] : (typ)_Array_Bounds_Fail_(__aix__,__aiz__))

// Thread synchronization, implemented as a Win32 semaphore object

namespace  _FrameWork_ { // resume name space protection..

void Log_Sig_(Sem_32& s, int whom, int lino);
void Log_Wait_(Sem_32& s, int whom, int lino);

#if Panic_Log
#define See_Panic(x) Panic_See(x)
#else
#define See_Panic(x)
#endif // Panic_Log

int Tokenize(int kin, int orn, String st, int* theLn);
String NewStrText(const char* stc, int lxx, int whom);
String UpDownStr(String st, int upby, int whom);
int Find_Text(char* xPtr, int xLen, char* aPtr, int aLen);
boolean SetActualStrLen(char* sptr);

// void Set_File_Flagz(File aFile, int flagz); // now in C_Turk

void Log_Panic(String aLine);

} // (temply) end namespace  _FrameWork_

#define NewSem32(sem,pre,snam) sem = CreateSemaphore(NULL,pre,0xFFFFF,snam)
#define Signal32(sem) ReleaseSemaphore(sem,1,NULL)
#define Wait32(sem) WaitForSingleObject(sem,INFINITE)
#define Log_Wait(sem,who) _FrameWork_::Log_Wait_(sem,who,_BASE_+__LINE__)
#define Log_Signal(sem,who) _FrameWork_::Log_Sig_(sem,who,_BASE_+__LINE__)

// #define Str_Signal(sem) Signal32(sem) // could also try it without these..
// #define Str_Wait(sem) Wait32(sem) // (insignificantly faster)

#define DebugLogFile _FrameWork_::DebugLogFileOpen // used as a boolean
// #define SysDebugLogging() (_FrameWork_::DebugLogFileOpen)

boolean I_am_Gooey();

////////////////////////////////////////////////////////////////////////

// Opaque Point type, implemented as an int..

// typedef int Point; // (see above)
// #define Nowhere 0x80008000   // final Point Nowhere = &0x80008000;

inline int Point2int(Point x) {return (int)x;}
inline Point Point4int(int x) {return (Point)x;}
inline Point MakePoint(int V, int H) {return Point4int(Pack2ints(V,H));}
inline int PointV(Point pt) {return HiWord(Point2int(pt));}
inline int PointH(Point pt) {return LoWord(Point2int(pt));}

inline Point AddPt(Point a, Point b) { // PRE: a+b not outside 32K range
  return (Point)MaskInts((((int)a)&~0xFFFF)+(int)b,((int)a)+(int)b,0xFFFF);}

inline Point NegPt(Point pt) {
  return (Point)MaskInts(-(((int)pt)&~0xFFFF),-((int)pt),0xFFFF);}

inline boolean EqPt(Point a, Point b) {return (a==b);}

////////////////////////////////////////////////////////////////////////

/// ref-counted String type, intrinsic to Turk/2..

// String Manager Operations..
inline int Get_Ref_Count(String st) {return st?LoWord(((int*)st)[1]):0;}
// inline int LENGTH(String st) {return st?((int*)st)[_fS_+2]:0;}
inline int _len_(String st) {return st?((int*)st)[_fS_+2]:0;}
inline char* Text_Of(String st) {return st?((char*)&(((int*)st)[_fS_+3])):
  &_FrameWork_::null_char;}
// Note: Get_Ref_Count(st), _len_(st), Text_Of(st) do not dn-ref st

char CharAt(int i, String st);
String Substring(int offs, int len, String st);
String TxtBlok2Str(int offs, int nch, int* ary);
void Str2TxtBlok(String st, int offs, int mxln, int* ary);
int FindStTxBlk(String st, int offs, int mxln, int* ary);
int* Text_Ary_Str(String st);
// int Offs2ItemOf(char sep, int ordn, String theSt); // now in C_Turk

#define Str_2_int(st) ((int)(st)) // no up-dn count..
#define Str4intZ(st) ((String)(st)) // was: Str_4_int

// Turk/2 compiled code access..
#define _Str_(sta) _Str__(_BASE_+__LINE__,sta)
// #define _Str_(sta,stb) _Str__(_BASE_+__LINE__,sta,stb)
// inline String _Str__(int whom, char* st, int lxx)
//   {return _FrameWork_::NewStrText(st,lxx,whom);}
inline String _Str__(int whom, char* st)
  {return _FrameWork_::NewStrText(st,0,whom);}
inline String _Str__(int whom, char x)
  {return _FrameWork_::NewStrText((char*)(&x),1,whom);}
String _Str__(int whom, int i);
#define Bool_2_Str(whom) FormDateTime((int)whom,CHR4_4_4c('B','o','o','l'))
int _compare_(String sta, String stb);
String _cat__(int whom, String sta, String stb);
String _cat__(int whom, char* sta, char* stb, int lxa, int lxb);
inline String _cat__(int whom, char* sta, char* stb)
  {return _cat__(whom,sta,stb,0,0);}
String _cat__(int whom, String sta, char* stb);
String _cat__(int whom, char* sta, String stb);
#define _cat_(sta,stb) _cat__(_BASE_+__LINE__,sta,stb)

/// 4-character-as-int (Char4) type, intrinsic to Turk/2..

Char4 CHR4(char* st);
String _Str4_(Char4 x);
Char4 CHR4(String st);
inline Char4 Chr4Str(String st) {return CHR4(st);} // unused?
inline Char4 CHR4(int x) {return ((Char4)(x));}
// #define Chr4(a,b,c,d) CHR4_4_4c(a,b,c,d) // now in T2C
Char4 Up4Char(Char4 Num4);
// boolean Is4chars(int val);

////////////////////////////////////////////////////////////////////////

/// Opaque File type, implemented as a pointer to a _File_ class..

#define File_Destructor(f) delete f
#define Zap_File_w32(aFile,wfi) aFile->File_w32_Zap(wfi)

// WinFile Get_File_w32(File aFile); // now in C_Turk
void SystemDebugLog(String theSt);
int GetFileFlags(File aFile);
String GetFileName(File aFile);
String FullPath(File aFile);
void SetFiNames(File aFile, String thePath);
int GetFiRefNum(File aFile);
int ReadData(File aFile, int* ary);
String ReadText(File aFile, int nby);
String ReadLine(File aFile);
int WriteData(File aFile, int* ary);
void WriteBytes(File aFile, int* ary, int bgn, int ln); // defined, unused
void WriteChar(File aFile, char ch);
void WriteLn(File aFile);
void WriteText(File aFile, String theSt);
void WriteChr4(File aFile, Char4 cx);
String GetCurWinDirName(void);
String ProgFileName(void);

// File OpenInDir(String name, int opt, File dir);
boolean IsValidFile(File aFile);
File Find_Directry(String path, boolean Sharon, int whom);
File Find_UnusedFi();
int GetFilePosn(File aFile);
int GetSizeFile(File aFile); // used in Ftest
// int GetFileErr(); // now in C_Turk
boolean FileAtEOF(File aFile);
void Seek(File aFile, int offs);
File Close2Ref(File aFile);
int ReadByte(File aFile);
// void SetEOF(File fi); // not defined, unused
File File_4int(int whom);

int _Array_Bounds_Fail_(int aix, int aiz);

String GetWinTitle(Window theWin);
void SetWinTitle(Window theWin, String theTx);
Char4 GetWindID(Window theWin);
#define Get_WindID(w) GetWindID((Window)w)

#define Cstring_CAST(s) (char*)(s)
#define String4_Cstr(s) _Str_(s)
#define Chr4Cstr(s) CHR4(s)
#define EXTRACT_Cstr(s) Text_Of(s)
#define Literal_Cstr(s) s
#define Windo_CAST(w) (WindInfo)(w)
#define Windo_4int(w) (WindInfo)(w)
#define CAST_Windo(w) (Window)(w)
#define LONG_CAST(x) (LONG)(x)
#define File_2int(f) (int)(f)
#define Rect4ptr(r) (RectAngle)(r)
#define Wigit_2int(w) (int)(w)
#define Wigit_CAST(w) (Widgit)(w)
#define CAST_Win32(w) (Win_Window)(w)
#define Win32_4int(w) (Win_Window)(w)
#define Win32_2int(w) (int)(w)
#define WindowShow(x,y) ShowWindow(x,y)
#define UINT_Cast(x) (UINT)(x)
#define UINP_CAST(x) (UINT_PTR)(x)
#define CAST_MCT(x) (HMENU)(x)
#define MCT_2int(x) (int)(x)
#define Pend_Ex _FrameWork_::PendEx
#define Cast_T2F_Process(p) (p)
#define T2F_Cast_Process(p) (p)

#define Screen_Check(i) if (_FrameWork_::theScreen==NULL) return
#define Get_theScreen(i) (int)_FrameWork_::theScreen
// #define Set_theScreen(a) _FrameWork_::theScreen = (unsigned char*)a // in C_Turk
#define Poke_Screen_Byte(h,i,c) _FrameWork_::theScreen[_fS_*4+8+24+i] = (unsigned char)c
#define Peek_Screen_Byte(h,i) (((int)_FrameWork_::theScreen[_fS_*4+8+24+i])&255)

#define GetResource(fi,ty,id) _System_::Cache_GetRes(fi,ty,id,_BASE_+__LINE__)

#define Stx(theStr) theStr // unneeded: gets around T2/68 comp'r bug

/// Utility Functions not elsewhere defined..

Process NewProgram(String prName, File dir, Char4 pnm4, IntArray stkF);
Char4 Unique_ProcessID(Char4 pnam4);
Char4 ProcID(Process whom);
boolean Valid_Process(Process pnam);
String GetProgName(Process whom);
Process ProcByName(String st);
Char4 WhoAmI(void);
Process Proc4ch(Char4 pnam);
int GetTime(void);
int GetMilliSecs(void);

// low-level functions used by Sortit etc..

inline void _XCH_(void* Ap, void* Bp) { // _XCH_(&a,&b) to trade scalar vars
  int med = *((int*)Ap);  *((int*)Ap) = *((int*)Bp);  *((int*)Bp) = med;}

// void Byte_Store(int* ary, int Ap, char xCh);
// boolean Dis_Order(int* ary, int Ap, int Bp);

/// Win32 Registry Access.. -- these are #ifdef'd out in TurkFrame.h if no System

String GetRegistryItem(String RegName, String ItemName);
void SaveRegistryItem(String datum, String RegName, String ItemName);
String AskText(String msg, String txt, int opt);
int MsgBox(String msg, Char4 icn, int opt);
void SetCursor(int whom, Window win, RectAngle rc);

void Quit();
Process MySelf();

boolean Valid_LN(int ix, int nx);
boolean Verify_Valid_Ptr(void* ptr);

#define Do_Gooey(ms,evn,inf,loc,dat) _FrameWork_::DoGooey(ms,evn,inf,loc,dat)
#define Gooey_Do(ms,evn,inf,loc,dat) _FrameWork_::DoGooey(ms,evn,inf,loc,dat)

#define FindTxAry(theStr,here,thar,thePtr) FindStTxBlk(theStr,here,thar,up__ptr(thePtr))

namespace  _FrameWork_ { // resume name space protection..

void SysCacheInv(int rno); // fwd
void FlipFlopPixels(int* ptr, int iTall, int iWide);

void RegisterDropWindow(HWND theWin, IDropTarget** ppDropTarget);
void UnregisterDropWindow(HWND theWin, IDropTarget* pDropTarget);

void Byte_Store(int* ary, int Ap, char xCh);
boolean Dis_Order(int* ary, int Ap, int Bp);

void Post_Event(Event evp, Process toProc, Process fromm, boolean wait4);

// void Draw_Picture(IntArray img, int offs, int scro, RectAngle rc, int isiz);
Window Next_Windo(Window theWin);
int Valid_Window(int theWin);
void Up_Win_Cnt(void);
void Down_Win_Cnt(void);
void StartDragon(int flgs);
void Zap_Cursor();
char WinKey2ascii(char theKey);
void Do_Global_Inits();
void StartGooey();
int DoGooey(int msg, Char4 EvNo, int eInfo, int EvLoc, int EvDat);
Win_Window GetWgtWinWin(Widgit wgt);
Window FindWin_by32(Win_Window w32);
// Widgit FindWgt_by32(Window theWin, Win_Window w32, Widgit sot = NULL);
// File Next_File(File aFile); // (unused)
// File Open_Fail(String msg, String name);

File OpenFileDialog(String Prompt, File iDir, String finam, String filter,
      String ext3, boolean newly); // called from Csystem

} // end namespace  _FrameWork_

DWORD StartNewProg(void* whom); // proto for funct in main prog (obsolete)
PTHREAD_START_ROUTINE _New_Thread_(String prName); // proto for main prog funct
void _Look_See_();

#ifdef Bible_Trans // #def'd in TurkFrame.h before here:
// #include "CommonBT.h" // can't, it gets things out of order, so..
// These two names defined in CommonBT, are used in TurkFrame.h:
extern int LNdomains[]; // copy of original in CommonBT.h
String FormBiRef(String pre, int theRef, String post); // ditto
#endif // Bible_Trans

#endif // MOS_SysNames

////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
