// TurkFrame.h, hand-coded C++ for T2C in Win32 -- 2014 June 3

#ifndef MOS_FrameWork  // _FrameWork_::xxx // _0_RevDate_

#define MOS_FrameWork

// This symbol needs to be defined exactly once before this header is #included:
//  #define ProgramName "IttyBittyComputer" // or whatever
//
// StartNewProg needs to be defined somewhere in that same file's header:
//  DWORD StartNewProg(void* whom); // whom is really a Process

#ifdef ProgramName // only in main program of main thread
#define FrameWork_Body // #include'd by all, but generate code exactly once
int _my_Global_Inits_ = 0; // zero this now, so obj const'rs can see it
#endif // ProgramName

#ifdef _System__H_ // #def'd in System.h by T2C
#ifndef MOS_System // should be #def'd in System.h, but happens too late
#define MOS_System // so do it here & now, before looking at SysNames.h
#endif // MOS_System
#endif // _System__H_

#ifdef _BibleTrans__H_ // #def'd by T2C if BibleTrans is comp'd..
#define Bible_Trans
#else
#ifdef _DocPrep__H_ // #def'd by T2C if DocPrep is comp'd (really want CommonBT)
#define Bible_Trans
#endif // _DocPrep__H_
#endif // _BibleTrans__H_

#include "SysNames.h" // most all TurkFrame prototypes, other #includes

#ifdef FrameWork_Body // only in main program of main thread
#ifdef MOS_System
#include "Csystem.h" // compiled from T2, but only incl'd if System is imp'd
#else                // cuz C_Turk.h is #inc'd by Csystem.h
#include "C_Turk.h"  // compiled from T2 (so I can write less actual C :-)
#endif // MOS_System
#endif // FrameWork_Body

////////////////////////////////////////////////////////////////////////

// Global definitions..
// Object stuff..
// Utility functions..
/// array/pointer management routines..
/// 4-character-as-int (Char4) type, intrinsic to Turk/2..
// Global declarations used in WinMain/InitializeAl..
// Opaque File type, implemented as a pointer to a _File_ class (data)..
// DragonDrop data (still inside _FrameWork_ namespace)..
/// ref-counted String type, intrinsic to Turk/2..
/// Opaque File type, implemented as a pointer to a _File_ class..
/// Predefined Rectangle class (base class for all widgits)
/// Process management stuff..
/// Predefined Event class, implemented as a pointer to class _Event_
// DragonDrop functions (still inside _FrameWork_ namespace)..
/// Opaque Window type, implemented as a pointer to WindInfo class (from T2C)..
/// Utility Functions not elsewhere defined..
// [Part 2] D&D code adapted from <http://www.catch22.net/tuts/dragdrop.asp>
/// Win32 Registry Access.. -- note: this is #ifdef'd out if no System
// MsgBox and AskText..
// Win32 event support..
// Initialization (InitializeAl)..
// WinMain..
// now undefine everything we #def'd..

////////////////////////////////////////////////////////////////////////

// Global definitions used here only (#undef'd at end)..

#define CR_LF "\r\n" // "\r" for Mac, "\n" for eunuchs, "\r\n" for Windoze
#define CRLF_LEN 2 // 1 for Mac/eunuchs, 2 for Windoze -- 2010 January 14

#define _BASE_ 0x10000 // used with C's __LINE__ to identify caller

#define PathSize (MAX_PATH*4)

#define App_Icon 1001
#define Ask_Text 129
#define IDC_EdLn 1000
#define IDC_AskLabel 1002

// Win32 structs..
#define wPOINT POINT*
#define w32RECT RECT*

////////////////////////////////////////////////////////////////////////

#ifdef FrameWork_Body // only if generating code (1st #incl from main)
// this data (& code) is compiled within the main program

int _RevDate_ = _0_RevDate_; // SysNames.h date is visible after preprocess

RECT _W32_Rect_; POINT _W32_Pint_;
DWORD Gooey_Thread_ID;

int* _tmp_0_; int* _tmp_00_;
int __aix__; int __aiy__; int __aiz__;

int* Object__type = NULL; // base of hierarchy used for DownCast()
int* Throwable__type = (int*)(&Object__type);
int* Event__type = (int*)(&Object__type);
int* WindowOps__type = (int*)(&Object__type);
int* RectAngle__type = (int*)(&Object__type);
int* Widgit__type = (int*)(&RectAngle__type);
int* WindInfo__type = (int*)(&Widgit__type);

int _See_Look_ = 0; // used by _Look_See_

// String literals...
int _S_0001[] = {-1,0xF000,2,1,0x20}; // " "
int _S_0002[] = {-1,0xF000,2,2,0x2020}; // "  "
int _S_0003[] = {-1,0xF000,2,1,0x2E}; // "."
int _S_0004[] = {-1,0xF000,2,2,0x2E2E}; // ".."
int _S_0005[] = {-1,0xF000,2,2,0x2B2B}; // "++"
int _S_0006[] = {-1,0xF000,3,4,0x202D2D20,0}; // " -- "
int _S_0007[] = {-1,0xF000,2,2,0x3F3F}; // "??"
int _S_0008[] = {-1,0xF000,3,6,0x2D20200A,0x202D}; // "\  -- "
int _S_0009[] = {-1,0xF000,4,8,0x30202D2D,0x206E6957,0}; // "-- 0Win "
int _S_0010[] = {-1,0xF000,2,1,0x0D}; // ""
int _S_0011[] = {-1,0xF000,2,1,0x0A}; // "\"
int _S_0012[] = {// "WM_INITMENU"
    -1,0xF000,4,11,0x495F4D57,0x4D54494E,0x554E45};
int _S_0013[] = {-1,0xF000,4,8,0x2B202D2D,0x206E6957,0}; // "-- +Win "
int _S_0014[] = {-1,0xF000,4,9,0x69537E7E,0x6C616E67,0x20}; // "~~Signal "
int _S_0015[] = {-1,0xF000,4,9,0x6953207E,0x6C616E67,0x20}; // "~ Signal "
int _S_0016[] = {-1,0xF000,4,9,0x6157207E,0x6D537469,0x20}; // "~ WaitSm "
int _S_0017[] = {-1,0xF000,2,1,0x40}; // "@"
int _S_0018[] = {-1,0xF000,2,1,0x2B}; // "+"
int _S_0019[] = {-1,0xF000,3,7,0x7272615F,0x5F7961}; // "_array_"
int _S_0020[] = {-1,0xF000,4,8,0x7272615F,0x2B5F7961,0}; // "_array_+"
int _S_0021[] = {-1,0xF000,3,4,0x7478742E,0}; // ".txt"
int _S_0022[] = {// " (PndEx) "
    -1,0xF000,4,9,0x6E502820,0x29784564,0x20};
int _S_0023[] = {-1,0xF000,2,2,0x2320}; // " #"
int _S_0024[] = {// "--GetEv "
    -1,0xF000,4,8,0x65472D2D,0x20764574,0};
int _S_0025[] = {-1,0xF000,2,3,0x203C20}; // " < "
int _S_0026[] = {-1,0xF000,2,2,0x202C}; // ", "
int _S_0027[] = {// " (StopDrag) #"
    -1,0xF000,5,13,0x74532820,0x7244706F,0x20296761,0x23};
int _S_0028[] = {// "StartDrag #"
    -1,0xF000,4,11,0x72617453,0x61724474,0x232067};
int _S_0029[] = {-1,0xF000,2,3,0x203E20}; // " > "
int _S_0030[] = {-1,0xF000,3,7,0x6F502D2D,0x207473}; // "--Post "
int _S_0031[] = {-1,0xF000,2,3,0x205720}; // " W "

////////////////////////////////////////////////////////////////////////

namespace  _FrameWork_ { // for private library functions & data..

String One_Dot = _S_0003 /*.*/, Two_Dots = _S_0004 /*..*/; // string "constants"

int Mouse_Buttons = 0; // captured from recent button messages; see ControlKey
int Modifier_Keys = 0; // lock:0, shft:1, ctrl:2, cmd:3, opt:4; here: <<16
HWND DoxClik_Win = NULL; // the window clicked in for Mouse_Button
char* Program_Name;
char null_char = '\0';

File DebugLogFileOpen = NULL;
// int PIBsysErr = 0; // now T2F_Process.PIBfilErr

Process MainProgram = NULL, Ready_List = NULL; // we need this soon
boolean LogTextWrites = false; // initially disabled

int Logged_Events[Event_Log];
int Ev_Log_Ix = 0;

Sem_32 User_Lok = NULL; Sem_32 Goo_Lok = NULL; Sem_32 DebugLok = NULL;
Sem_32 Strn_Lok = NULL; Sem_32 Even_Lok = NULL; Sem_32 ResFi_Lok = NULL;
Sem_32 MoveOK = NULL; Sem_32 Panic_Lok = NULL;
  // MoveOK protects my_mallok's Chunk_List
  // ResFiLok protects PIBfiles in _File_ constructor/destructor,
  //   also in System.h, Buf_Root and ResCache in resource manager
  // DebugLok protects DebugLogFile in SystemDebugLog
  // Strn_Lok protects String ref count in UpDownStr, also the_String_Log
  // GooLok protects Xfer_xx through DoGooey
  // EvenLok protects T2F_Process _event_list_ and n_Timers
  // PanicLok protects Panic_Log trace data (if enabled)

int SemRefLockt = 0, SemRefCount = 0, SemRefHisto = 0; // used only here..

int _String_Log_Count_ = -1; // initially disabled
int the_String_Log[_Strings_Log_+4]; // init'd, used in C_Turk

////////////////////////////////////////////////////////////////////////

// Global declarations used in WinMain/InitializeAl..

Char4 Next_ProcID = CHR4("@000"); // Char4 TxtD4 = "TxtD";  Char4 Typ4 = "Type";
// Char4 DocX4 = "DocX";  Char4 Imag4 = "Imag";  Char4 PrgB4 = "PrgB";

// Process MainProgram = NULL, Ready_List = NULL; // was: AllProgP
HINSTANCE Main_Context = NULL; // context passed to main from Win32
HWND GooeyWin = NULL; HWND HasSplash = NULL; // something to send messages to
HWND FrontedWin = NULL; // force this to the front if not NULL
HWND theFrontWin = NULL; // this win is on top (sometimes we care)
HBRUSH StockWhiteBrush;  HBRUSH StockBlackPen;
HBRUSH PreProgBrush;     HBRUSH ProgressBrush;
HCURSOR HourGlass = NULL; HCURSOR OldCursor = NULL; // used in win redraw delays
HCURSOR CrossHair = NULL; HCURSOR Ibeam = NULL; HCURSOR PlainArrow = NULL;
HCURSOR EastWest = NULL; HCURSOR NorthSouth = NULL; HCURSOR DiagonalAro = NULL;
int my_Cursor = 0; int Tenth_Seconds = 0; // used to blink caret
unsigned char eTrsCan[384]; unsigned char FullCan[384]; // 256,+128 bytes o'head
boolean Drag_Is_Busy = false, FlushDBlog = false;

struct {
  BITMAPINFOHEADER BitMapStuff;
  int ColorTbl[216];} MyBitMap; // RGBQUAD
BITMAPINFO* theBitMap = (BITMAPINFO*)(&MyBitMap);

int myScrnTall; int myScrnWide; // used in BitMapStuff, NOT for pixelating
int ScreenTall; int ScreenWide; // used for pixelating
unsigned char* theScreen = NULL; // 24 bytes of (IntArray) o'hed at front
unsigned char* myScreen = NULL; // ditto, used in BitMapStuff

WNDCLASS Wind_type;

int Sys_State_Bits; int FlushClix = 0; // >0: flush spurious clix frm file dlg
Point ClikPt; Point ScroRefLoc; // used to reconstruct over-range scroll thumb
Point Mouse_Locn = Nowhere; // captured from recent WM_MOUSEMOVE
boolean Fresh_Mods = false; // true if might be stale
boolean New_MsgBx = false; // true when open MsgBx, to set FrontedWin
boolean Menu_Is_Open = false; // to override mouse in win cursor display
int Window_Count = 0; // quit when it reaches 0 again // Popup_Result = 0,
// Char4 Next_Win_ID = CHR4("#000"); // now unused

// Some timers and stuff..
int Tix_Now = 0; int Tix_100ms = 0; // <0 while splash win is visible
int n_Timers = 0; // number of processes in Delay
int Zap_Time = 0; // zap drag when decrements to 0 (ref'd but unused)

Window PIB_wins = NULL; Window Free_Wins = NULL; // master win list, clo'd spares
Window Progress_o = NULL; // cached progress bar win, cuz deleting it bombs
Window Pacify_wins = NULL; // window(s) being redrawn
Window Cursor_Win = NULL; // last known window showing cursor
Window SendingWin = NULL; // where I started this drag (if so)

// #define Menu_LineHeight 20 // in SysNames.h ..
// #define Menu_Comm_base 3333
// #define Max_Menus 256
// struct Menu_Com_ {Process whose; Char4 say;};
Char4 Menu_Comms[Max_Menus+2];
int Num_Menus = 0;
// #define BaseM_LineHgt 17 // ad hoc as observed, to be adjusted (NOT)
// int Menu_Hi_Chek = 2222, Menu_Preselect = -1, Menu_LineHeight = BaseM_LineHgt;

Event Pending_Event = NULL;

int PkgPending = 0; // see also Process->PendBit, Pend_Ex()
// 0=idle, 1=WM_MOUSEMOVE, 3=Analyze_DragSt, 4=Drop_Her.
//  [-3: "AcTk" sent NOT], -2: Hotclick sent, -1: Fetch_Ev after -2/-3
// Five busy states for PkgPendin/PendBit:            -- 5=DragClipEvent
// 1. Start drag, reserved for "Drag" evt, in which TrakDrag builds "Drag"
// 2. Drag event accepted, upgrades PkgPendin from 1 to 2, sets PendBit
//   and sends it off by PkgDone->StartDrago, which releases (or else
//   Drag evt exit releases) if not taken by #4.
// 3. Drag enter keeps #2, or else AnalDragStr makes new "Drop" pkg #3
//   which is released on drag leave.
// 4. Drop takes over #2 or #3 for "Drop" evt as #4, to release on exit.
// 5. Drop event accepted, upgrades PkgPendin from 4 to 5.
// 7. DroPastEv makes "Past" from system clip, or NewClip builds "Clip",
//   both released on exit.

////////////////////////////////////////////////////////////////////////

// Opaque File type, implemented as a pointer to a _File_ class (data)..

int FilnIx = 511;
File PIBfiles = NULL;  File PIBwDir = NULL;
File Using_ResFi = NULL; // used in Turk,Csystem, but checked by Close2Ref
Fi_Find_32 FindInfo; // DWORD dwFileAttributes (1st 16-bit):
 // #define FILE_ATTRIBUTE_HIDDEN 128
 // #define FILE_ATTRIBUTE_NORMAL 64
 // #define FILE_ATTRIBUTE_SYSTEM 32
 // #define FILE_ATTRIBUTE_DIRECTORY 16
 // #define FILE_ATTRIBUTE_READONLY 1  // time: 64-bit L-End, 100ns >1601/01/01
 // then: FILETIME ftCreationTime, ftLastAccessTime, ftLastWriteTime;

////////////////////////////////////////////////////////////////////////

unsigned char vKeyStates[256];
// UINT OEMscanCode; // not needed (VS DB broken)

// MsgBox and AskText data..

String Res_Str = Null_Str;  String Xfer_Str = Null_Str;

char MsgBoxTitle[sizeof(ProgramName)+16];

// DragonDrop data (still inside _FrameWork_ namespace)..

#ifdef MOS_System // not needed otherwise

// Drag stuff..
int* theClipDrag = NULL;
Char4 ClipDragOwn = Null4;
String ClipDragStr = Null_Str;

// #define ClpDrgPkSz 44 // now in SysNames.h
int ClipDragPkg[_fS_+2+ClpDrgPkSz+1]; // pkg positions:
  //  +0 length = 44 // ClipDragPkg[_fS_+1] = 44;
  // +0 length (dupe); -> pkg if Signature<0
  // +1 Signature "Drag" or "Drop"
  // +2 current size
  // +3 Sender's procID
  // +4 LENGTH(theDrag.DrDataStr), for validation
  // +5 Chr4Str(theDrag.DrDataStr), ditto
  // +6 current (potential) drop loc, -1 if trash can
  // +7 modifiers; +1 if over wiDropble (set in DidDocDropHi)
  // +8 start of real data

#endif // MOS_System

////////////////////////////////////////////////////////////////////////

// Object stuff..

 } // (temply) end namespace  _FrameWork_

O__object__* O__obj_list = NULL;
void O__object__::Zero_Refs(Object ox) {delete ox;}
void O__object__::InstallMe(O__object__* whom) { // slow version..
  whom->link = O__obj_list;
  O__obj_list = whom;}

void _Do_Zero_(Object ox, int info) {
  O__object__* theList = O__obj_list;
  int whom = (ox->_00_)>>16;
  _Destructo_Log_(Int2Log(Null_Str,whom,Int2Log(_S_0017 /*@*/,info,Null_Str)));
  while (theList != NULL) {
    if (theList->kin == whom) {theList->Zero_Refs(ox); break;}
    theList = theList->link;}}

_Object_::_Object_() {
  _00_ = 0x40001; // we get first shot, subclass const'rs later update these..
  _000_ = 2;
  errMsg = 00;
  My__Type = Object__type;
  if (_my_Global_Inits_ == 0) _FrameWork_::Do_Global_Inits();}

void _Object_::_dn_ptr_() {
  if ((_00_&0xFF00) !=0) return;
  if (((--_00_)&0xFFFF) !=0) return;
  _Do_Zero_(this,-1);}

Object new__Object_() {Object ptr; try {ptr = new _Object_;}
  catch(bad_alloc xx) {ptr = NULL;}  return ptr;} //~new__Object_

O__Throwable__ i__Throwable__;
O__Throwable__::O__Throwable__() {InstallMe(this);}

void O__Throwable__::Zero_Refs(Object ox) {
  Throwable whom = NULL;
  if (typeid(*ox) == typeid(_Throwable_)) whom = (Throwable)ox;
  if (whom != NULL) delete whom;}

Throwable new__Throwable_() {
  Throwable ptr = NULL; try {ptr = new _Throwable_;}
  catch(bad_alloc xx) {return NULL;}  return ptr;} //~new__Throwable_

////////////////////////////////////////////////////////////////////////

// My Own Memory Allocation Manager (removed)..

inline void my_free(int* ary, int whom) {free(ary);}
// inline int* my_mallok(int lnx, int whom) {return (int*)malloc(lnx);} // unused
// boolean Die__Politely(int why, int* ary, int whom) {return false;} // unused
void Log_Res_Info(int rez, int rty, int FiNo) {} // called from Cache_GetRes

inline int ORD_(Char4 x) {return x;} // local only

////////////////////////////////////////////////////////////////////////

/// array/pointer management routines..

#if _Strings_Log_>1 // enable string log for unit tests..
// void Log_Str_Cash(int whom, bool doWhat); // in Csystem.t2/.h
#define _Str_Logit_(whom) _FrameWork_::Log_Str_Cash(whom,true)
#define _Str_unLog_(whom) _FrameWork_::Log_Str_Cash(whom,false)
#else
#define _Str_Logit_(whom)
#define _Str_unLog_(whom)
#endif // _Strings_Log_>1

////////////////////////////////////////////////////////////////////////

int* my_int_ary(int lnx, int why, int whom) { // #def'd as new_int_ary(lnx,why)
  // int* ptr = (int*)_FrameWork_::my_mallok((_fS_+2+lnx)*sizeof(int),whom);
  int* ptr;                                     // whom = caller _BASE_+__LINE__
  // try {ptr = new int[_fS_+2+lnx];} catch(bad_alloc xx) {return NULL;} // fails
  ptr = (int*)malloc((_fS_+2+lnx)*sizeof(int));
  if (ptr) {
    if (whom==0) whom = 0xFEEDC0DE;
    _FrameWork_::FILL0(ptr,0,lnx);
    if (_fS_) ptr[0] = whom; // (unused, aligned w/C++ disp.tbl)
    ptr[_fS_+0] = (why<<16)+1; // always precounted;
    ptr[_fS_+1] = lnx;
    if ((lnx>_log_these_arrays_) || (_FrameWork_::_String_Log_Count_ >= 0))
      _Str_Logit_((int)ptr);}
  return ptr;}

int set_ary_size(void* aptr, int siz, int clss) {
  int isiz = ABS(siz); // siz<0 for static alloc (uncounted), incl errMsg
  int skipt = clss>>16; // skip[t] over superclass vars (already init'd)
  int* ptr = (int*)aptr; // data siz[e] in int's (not including ref-count,size)
  _Look_See_();           // clss: 0=strs, 1=ints, +2=ary of arys; >3=obj
  if (ptr==NULL) return 0; // array of objects is coded same as ary of int arys
  if (isiz==0) return 0;
  if (clss<0) clss = -clss; // clss<0 omits zeroing
    else _FrameWork_::FILL0(ptr,skipt,isiz-skipt); // skips over 1st 3 +skipt
  _Look_See_();
  clss = clss<<16;
  if (_fS_) ptr++;
  if (siz<0) clss = clss+0xFF00;
  else if (clss<0x30000) clss++;
    else clss = ((*ptr)&0xFFFF)+clss;
  *(ptr++) = clss;
  *ptr = isiz;
  _Look_See_();
  return isiz;} //~set_ary_size // rtn value used in static alloc

boolean Verify_Valid_Ptr(void* ptr) {return false;} // also from Csystem

int* up__ptr(void* aptr) { // also does strings
  int* ptr = (int*)aptr;
  _Look_See_();
  if ((((int)ptr)&-32) !=0) if ((ptr[_fS_]&0xFF00) ==0) { // not if frame-alloc'd
    Verify_Valid_Ptr(aptr);
    ptr[_fS_]++;}
  return ptr;} //~up__ptr

int* dn__ptr(void* aptr, int whom) { // normally called as void, except in expn
  int* ptx = (int*)aptr;  int ix, info, datum; // whom = caller _BASE_+__LINE__
  _Look_See_();
  if ((((int)ptx)&-32)==0) return (int*)0; // could be null, but sometimes ++?
  info = ptx[_fS_]; // content-type,ref-cnt
  if ((info&0xFF00) !=0) return ptx; // stack allocated: do nothing
  Verify_Valid_Ptr(aptr);
  ix = info&0xFF;
  if (ix !=0) ix--;         // 2 threads could look at same ptr if res,
  if (ix==0) while (true) { // but cache holds a copy, so never hits 0
    // info = ptx[_fS_];
    if (info==1) { // String, cuz T2C calls thru here..
      _FrameWork_::UpDownStr((String)aptr,-1,whom);
      ptx = NULL; // aptr = NULL;
      break;}
    if (info<0) // only if hand-patched at run-time
      ix--; // <<==================== break here to catch whoever disposed it
    ptx[_fS_]--;
    ix = ptx[_fS_+1]; // logical size in ints
    if ((ix>_log_these_arrays_) || ((_FrameWork_::_String_Log_Count_&0x1000) ==0))
      _Str_unLog_((int)ptx);
    info = info>>16;
    if (info>3) _Do_Zero_((Object)aptr,whom);
    else if (info>1) {
      if (_Log_Destructors_>1)
        _Destructo_Log_(Int2Log(_S_0019 /*_array_*/,info,
            Int2Log(_S_0018 /*+*/,ix,Int2Log(_S_0017 /*@*/,whom,Null_Str))));
      for (ix=ix+_fS_+2-1; ix>_fS_+1; ix--) { // info=2/3..
        datum = ptx[ix];
        if (datum==0) continue;
        if (info==2) _FrameWork_::UpDownStr((String)datum,-1,whom);
          else dn__ptr((void*)datum,whom);} // if (info==3)
      // delete[] ptx;}
      free(ptx);}
    else {
      if (_Log_Destructors_>2) _Destructo_Log_(Int2Log(_S_0020, /*_array_+*/
          ix,Int2Log(_S_0017 /*@*/,whom,Null_Str)));
      free(ptx);} // _FrameWork_::my_free(ptx,whom);
    ptx = NULL; // aptr = NULL; // caller needs something to compare to
    break;}
  if (aptr) if (ptx) ptx[_fS_]--;
  return (int*)aptr;} //~dn__ptr

// array bounds check..

int _Array_Bounds_Fail_(int aix, int aiz) { // never returns
  int aiy = 0;
  coming_from("Array_Bounds_Fail");
  MsgBox(Dec2Log(_Str_("Array bounds check "),aix,Dec2Log(_Str_("<"),aiz,
      _cat_(_cat_(" {",_Str4_(ProcID(NULL))),"}"))),ORD_(StopIcon),0);
  // Asyn_Msg("AB_Q",aix,aiz,0,_FrameWork_::MainProgram);
  if (_Crash_and_Burn_) {aiy = 0; aiy = aix/aiy;}
  _FrameWork_::Asyn_Msg(CHR4("Died"),aix,aiz,0,_FrameWork_::MainProgram);
  ExitProcess(0); // Quit();
  retnd_from();
  return 0;} // ~_Array_Bounds_Fail_

void Valid8_Event(Event theEv) { // all calls commented out
  int az = 0;
  if (theEv->_00_ == 9) if ((theEv->_ev_state_&-4)==0) return;
  if (_Crash_and_Burn_) az = (++az)/az; // div/0: I want to know about this
  // _FrameWork_::FILL0((int*)theEv,0,7); // set_ary_siz does it
  set_ary_size((void*)theEv,9,9);
  // My__Type = Event__type;
  theEv->_ev_link_ = NULL;}

////////////////////////////////////////////////////////////////////////

// Utility functions..

namespace  _FrameWork_ { // resume name space protection..

void FILL0(int* ary, int offs, int nwds) {
  if (nwds>0) {++offs; if (_fS_) ++offs;} // adjusts for array size+cnt words
    else nwds = nwds&0x7FFFFFFF; // +HiBit omits adjust
  while (nwds-- >0) ary[++offs] = 0;} // offs in words

void copy_bytes(const char* frm, char* too, int nby) {
  while (nby-- >0) *too++ = *frm++;}

void Fill_Block(int valu, int* addr, int nwds) { // skips over size,ref wrds
  if (nwds>0) {addr++;  addr++;  if (_fS_) addr++;} // ..except if +HiBit
    else nwds = nwds&0xFFFFFF;
  *addr = valu;
  char* thar = (char*)addr;
  _FrameWork_::copy_bytes(thar,thar+4,nwds*4-4);}

int Str__Order(char* Ap, char* Bp, char* Cp) {int D0 = 0, D7;
  do {D7 = Cp[((int)(*Bp++))&0xFF]&0xFF;
      D0 = (Cp[((int)(*Ap++))&0xFF]&0xFF)-D7;}
    while ((D0==0)&&(D7!=0)); return D0;}

inline w32RECT Win32Rect(RectAngle rx) { // trims off _fS_,size,ref-count,msg,ty
  int* rw = (int*)rx; if (_fS_) ++rw; ++rw; ++rw; ++rw;
  return (w32RECT)(++rw);} // Win32 "left" is in rTop; "top" is in rLeft..

////////////////////////////////////////////////////////////////////////

void DebugTracer(String str, int whom, int lino) { // logs process ID
  if (DebugLogFile) // only from Log_Sig/Log_Wai if SigWait_Tr=true
    SystemDebugLog(Int2Log(str,whom,Int2Log(_S_0001,lino,
        _cat_(" ",_Str4_(WhoAmI())))));}

void Log_Sig_(Sem_32& s, int whom, int lino) {
  SemRefLockt--;                  // only used by C_Turk,Csystem; whom: 1..7
  if (SigWait_Trace) { // enable logging, to help find mismatches..
    SemRefCount = SemRefCount+100; // was odd 10 if locked
    if (SemRefLockt<0) { // lost Wait or excess Signal..
      if (DebugLogFile) DebugTracer(_S_0014 /*~~Signal */,
          SemRefCount+whom+(SemRefLockt&7)*10,lino);
      if (_Crash_and_Burn_) if (SigWait_Trace>1) whom = whom/(whom>>4);} // div/0
    else if (DebugLogFile) DebugTracer(_S_0015 /*~ Signal */,
        SemRefCount+whom+(SemRefLockt&7)*10,lino);}
  SemRefHisto = (SemRefHisto<<4)+whom; // recent calls, even if not logging
  Signal32(s);}
void Log_Wait_(Sem_32& s, int whom, int lino) {
  if (SigWait_Trace) {              // only used by C_Turk,Csystem; whom: 1..7
    SemRefCount = SemRefCount+100; // lost Signal just hangs
    if (DebugLogFile) DebugTracer(_S_0016 /*~ WaitSm */,
        SemRefCount+whom+(SemRefLockt&7)*10,lino);}
  SemRefHisto = (SemRefHisto<<4)+whom+8;
  Wait32(s);
  SemRefLockt++;}

////////////////////////////////////////////////////////////////////////

/// ref-counted String type, intrinsic to Turk/2..

//  String is a 1-word reference to the string value, =0 is ""
//  String compare in T2 is not case-sensitive in the ASCII range

// private library functions needed for String..

int Find_Text(char* xPtr, int xLen, char* aPtr, int aLen) { // find xPtr in aPtr
  int ix; int xCh; int offs = 0; // rtns offset from aPtr
  while (aLen >= xLen) {
    xCh = 0;
    for (ix=0;ix<xLen;ix++) {
      xCh = ((int)xPtr[ix])&255;
      if (xCh==0) break; // end of lookfor, must be =
      xCh = (((int)Capitize(aPtr[offs+ix]))&255)-((int)Capitize((char)xCh));
      if (xCh !=0) break;} // not equal here
    if (xCh==0) return offs;
    offs++;
    aLen--;}
  return -1;} // ~Find_Text

int CompareText(char* xPtr, int xLen, const char* aPtr, int aLen) { // xPtr:aPtr
  int ix; int offs = MIN(xLen,aLen); int xCh = 0;
  for (ix=0;ix<offs;ix++) {
    xCh = ((int)aPtr[ix])&255;
    if (xCh==0) return ((int)xPtr[ix])&255;
    xCh = (((int)Capitize(xPtr[ix]))&255)-((int)Capitize((char)xCh));
    if (xCh !=0) return xCh;} // not equal
  if (xLen>offs) return ((int)xPtr[ix])&255;
  if (aLen>offs) return -(((int)aPtr[ix])&255);
  return 0;} // ~CompareText

char* AllocStr(int len, int whom) { // rtns ptr to 1st char
  int nby = (len+8)&-4; // header: [unuse,]ref-cnt,int-ary-siz,str-siz;text..,0
  // int* ipt = my_mallok(nby,0); // retns ptr to ref-cnt =1
  int* ipt = new_int_ary(nby>>2,0); // retns ptr to [unused int B4] ref-cnt =1
  if (ipt==NULL) return NULL;
  ///*ipt = -1; // temp ref count
  ///ipt[1] = len; // string len
  nby = nby>>2;
  if (whom==0) whom = 0xDEADBEEF;
  if (_fS_) ipt[0] = whom; // (unused, align w/C++ disp.tbl)
  ipt[_fS_+0] = 1; // string ref count
  ipt[_fS_+1] = nby; // int array size
  ipt[_fS_+2] = len; // logical string length
  ipt[_fS_+3] = 0; // initialize null
  _Str_Logit_((int)ipt); // ref-count no longer in wrong place
  ipt[_fS_+1+nby] = 0;
  ipt++;  ipt++;  ipt++;  if (_fS_) ipt++;
  return (char*)ipt;} //~AllocStr

String NewStrText(const char* stc, int lxx, int whom) {
  char* sptr = NULL;  char* tptr = NULL;
  int* stx = NULL;
  _Look_See_();
  if (stc) if (*stc) {
    if (whom == 0x16280DDB) { // may need hack 16->8 bit packing..
      sptr = (char*)stc;
      if (sptr[1] == '\0') if (sptr[2] != '\0') while (true) {
        if (((int)sptr)&1) sptr++;
        if (*sptr++) lxx++;  else break;}
      if (lxx==0) whom = 0;}
    if (lxx==0) lxx = strlen(stc);}
  if (lxx>0) {
    sptr = AllocStr(lxx,whom);
    if (sptr) {
      tptr = sptr;
      if (whom == 0x16280DDB) while (lxx>0) {
        if (((int)stc)&1) stc++;
        *tptr++ = *stc++;
        lxx--;}
      else if (stc) copy_bytes(stc,sptr,lxx); // strcpy(sptr,stc);
      stx = (String)sptr;}}
  if (stx) {stx--; stx--; stx--; if (_fS_) stx--;}
  return (String)stx;} //~NewStrText

String UpDownStr(String st, int upby, int whom) {
  int* ipt = (int*)st;
  int cnt;
  _Look_See_();
  if (((int)ipt)&-32) if ((ipt[_fS_]&-256)==0) {
    Wait32(Strn_Lok);
    cnt = ipt[_fS_]+upby;
    ipt[_fS_] = cnt;
    Signal32(Strn_Lok);
    if ((cnt&255) !=0) return st; // no other threads have a ref if =0
    _Str_unLog_((int)ipt);
    if (whom==0) whom = _BASE_+__LINE__;
    my_free(ipt,whom);}
  return NULL;} //~UpDownStr

boolean SetActualStrLen(char* sptr) { // used only by GetRegistryItem
  int lxx = 0;
  int* ipt = (int*)sptr;
  if (((int)ipt)&-32) {
    lxx = strlen(sptr);
    ipt--; // ipt--;  ipt--;
    ipt[0] = lxx;}
  return lxx==0;} //~SetActualStrLen

 } // (temporarily) end namespace  _FrameWork_

String _Str__(int whom, int i) {
  int dg = -1; int ix = 0;
  char cxi[16]; char cxs[16];
  char* cp = (char*)(14+((int)cxi));
  if (i<0) {
    cxs[ix++] = '-';
    i = -i;
    if (i<0) {
      cxs[ix++] = '2';
      i = i-2000000000;}
    dg = 0;}
  cxs[ix] = '\0';
  *cp = '\0';
  while (i>0) {
    dg = i%10;
    i = (i-dg)/10;
    *(--cp) = (char)(dg+48);}
  if (dg<0) *(--cp) = '0';
  strcat(cxs,cp);
  return _FrameWork_::NewStrText(cxs,0,whom);} //~_Str_

String _Str4_(Char4 x) {
  int chx[5];
  int bitz = (int)x;
  char* sptr = (char*)chx;
  while (true) {
    *sptr++ = (char)((bitz>>24)&255);
    if ((bitz&-0x1000000) ==0) break;
    bitz = bitz<<8;}
  return _FrameWork_::NewStrText((char*)chx,0,_BASE_+__LINE__);} //~_Str4_

int _compare_(String sta, String stb) {
  int res = 0, lxa = _len_(sta), lxb = _len_(stb);
  if (lxa+lxb !=0) {
    if (lxa==0) res = 1;
    else if (lxb>0)
      res = _FrameWork_::CompareText(Text_Of(sta),lxa,Text_Of(stb),lxb);
    else res = -1;}
  if (sta) _FrameWork_::UpDownStr(sta,-1,_BASE_+__LINE__);
  if (stb) _FrameWork_::UpDownStr(stb,-1,_BASE_+__LINE__);
  return res;} //~_compare_

String _cat__(int whom, char* sta, char* stb, int lxa, int lxb) {
  String res;
  if (sta) {if (lxa==0) lxa = strlen(sta);}
  else if (stb==NULL) return Null_Str;
  if (stb) if (lxb==0) lxb = strlen(stb);
  if (lxa+lxb == 0) return Null_Str;
  if (lxa == 0) return _FrameWork_::NewStrText(stb,lxb,whom);
  if (lxb == 0) return _FrameWork_::NewStrText(sta,lxa,whom);
  res = _FrameWork_::NewStrText(NULL,lxa+lxb,whom);
  if (res==Null_Str) return Null_Str;
  _FrameWork_::copy_bytes(sta,Text_Of(res),lxa);
  sta = (char*)(((int)Text_Of(res))+lxa);
  _FrameWork_::copy_bytes(stb,sta,lxb);
  return res;} //~_cat_

String _cat__(int whom, String sta, String stb) {
  String res;
  int lxa = _len_(sta), lxb = _len_(stb);
  if (lxa+lxb ==0) return Null_Str;
  if (lxa==0) return stb;
  if (lxb==0) return sta;
  res = _cat__(whom,Text_Of(sta),Text_Of(stb),lxa,lxb);
  _FrameWork_::UpDownStr(sta,-1,whom);
  _FrameWork_::UpDownStr(stb,-1,whom);
  return res;}

String _cat__(int whom, char* sta, String stb) {
  String res;
  int lxa = 0, lxb = _len_(stb);
  if (sta) lxa = strlen(sta);
  if (lxa+lxb ==0) return Null_Str;
  if (lxa==0) return stb;
  if (lxb==0) return _FrameWork_::NewStrText(sta,lxa,whom); // _Str_(sta,lxa);
  res = _cat__(whom,sta,Text_Of(stb),lxa,lxb);
  _FrameWork_::UpDownStr(stb,-1,whom);
  return res;}

String _cat__(int whom, String sta, char* stb) {
  String res;
  int lxa = _len_(sta), lxb = 0;
  if (stb) lxb = strlen(stb);
  if (lxa+lxb ==0) return Null_Str;
  if (lxa==0) return _FrameWork_::NewStrText(stb,lxb,whom);
  if (lxb==0) return sta;
  res = _cat__(whom,Text_Of(sta),stb,lxa,lxb);
  _FrameWork_::UpDownStr(sta,-1,whom);
  return res;}

// String Manager Operations..

char CharAt(int i, String st) {
  char* here = Text_Of(st);
  char xCh = '\0';
  if (st) while (true) { // break to dn-cnt
    if (i<0) break;
    if (_len_(st) <= i) break;
    xCh = here[i];
    break;}
  _FrameWork_::UpDownStr(st,-1,_BASE_+__LINE__);
  return xCh;} //~CharAt

String Substring(int offs, int len, String st) {
  int lxx = _len_(st);
  String nu = Null_Str;
  while (true) { // break to dn-cnt
    if (offs<0) break;
    if (lxx <= 0) break;
    if (offs==0) if (lxx==len) return st; // transfer ref-cnt to rtn
    len = MIN(lxx-offs,len);
    if (len<=0) break;
    nu = _FrameWork_::NewStrText((char*)(((int)Text_Of(st))+offs),len,0);
    break;}
  _FrameWork_::UpDownStr(st,-1,_BASE_+__LINE__);
  return nu;} //~Substring

String TxtBlok2Str(int offs, int nch, int* ary) { // nch<0 omits copy
  // PRE: offs >=0, nch >=0, offs+nch <= ary.len  // nch=0 takes all
  String res = NULL;
  char* sptr;  char* chad;
  if (ary==NULL) return Null_Str;
  if (offs<0) offs = 0;
  chad = (char*)(((char*)ary)+offs+sizeof(int)*(_fS_+2));
  offs = ary[_fS_+1]*sizeof(int)-offs;
  if (offs>0) {
    if (nch<0) { // don't copy (nor even look at) array contents..
      offs = MIN(offs,-nch);
      chad = NULL;}
    else {
      offs = MIN((int)strlen(chad),offs);
      if (nch>0) offs = MIN(offs,nch);}}
  if (offs>0) res = _FrameWork_::NewStrText(chad,offs,0); // maybe no end 00, OK
  if ((ary[_fS_]&0xFF00)==0) if ((ary[_fS_]&0xFF)>0) ary[_fS_]--;
  return (String)res;} //~TxtBlok2Str

void Str2TxtBlok(String st, int offs, int mxln, int* ary) {
  int nby; // PRE: offs >=0, offs+MIN(st.len,mxln-1) < ary.len (both checked)
  char* chad;
  if (ary) if (offs >= 0) while (true) { // all exits thru down-ref..
    nby = ary[_fS_+1]*sizeof(int)-offs; // avail bytes from offs to end
    if (nby <= 0) break;
    chad = (char*)(((char*)ary)+offs+sizeof(int)*(_fS_+2)); // points to 1st
    if (mxln>0) nby = MIN(nby,mxln); // mxln>0 truncates or fills to mxln
    offs = _len_(st);
    if (offs >= nby) {
      _FrameWork_::copy_bytes(Text_Of(st),chad,nby);
      break;}
    if (offs>0) strcpy(chad,Text_Of(st));
    if (mxln==0) break; // mxln<0 fills to end of array with nulls
    nby = nby-1-offs; // if length is given, fill it out with nulls..
    chad = (char*)(((int)chad)+offs);
    if (nby>0) _FrameWork_::copy_bytes(chad,(char*)(chad+1),nby);
    break;}
  if (st) _FrameWork_::UpDownStr(st,-1,_BASE_+__LINE__);
  if (ary) if ((ary[_fS_]&0xFF00)==0) if ((ary[_fS_]&0xFF)>0)
    ary[_fS_]--;} //~Str2TxtBlok

int FindStTxBlk(String st, int offs, int mxln, int* ary) { // rtns new offs
  char* here; // PRE: offs >=0, offs < MIN(ary.len,mxln)
  int aoff = ABS(offs), nby = -1;
  if (st) if (ary) { // we add array overhead, but caller must offs+4 if String..
    nby = ary[_fS_+1]*sizeof(int)-aoff;  // ..(String only from C_Turk/ReplacAll)
    here = (char*)(((int)((char*)ary))+aoff+sizeof(int)*(_fS_+2));
    if (mxln>0) nby = MIN(nby,mxln);
    mxln = _len_(st);
    if (mxln==0) nby = 0; // shouldn't, we tested it above
    else if (nby <= 0) nby = -1;
    else if (offs >= 0) {
      nby = _FrameWork_::Find_Text(Text_Of(st),mxln,here,nby);
      if (nby<0) nby = -1;
        else nby = nby+aoff;}           // special case, must =
    else nby = -ABS(_FrameWork_::CompareText(Text_Of(st),mxln,here,nby));}
  if (st) _FrameWork_::UpDownStr(st,-1,_BASE_+__LINE__);
  if (ary) if ((ary[_fS_]&0xFF00)==0) if ((ary[_fS_]&0xFF)>0) ary[_fS_]--;
  return nby;} //~FindStTxBlk

int* Text_Ary_Str(String st) { // note that string starts in ary[1], len in [0]
  if (st) return (int*)st; // transfers ref-cnt (caller ++'d) to rtn
  return NULL;}

/// 4-character-as-int (Char4) type, intrinsic to Turk/2..

// inline int ORD_(Char4 x) {return x;} // local only
// Char4 CHR4(int x) {return (x);} // inlined in SysNames.h
// Char4 Null4 = CHR4(0); // Char4 NoName = "    "; // now #def'd in SysNames

Char4 CHR4(char* st) {
  int bitz = 0, inx = 0;
  if (st) while (inx++<4) {
    bitz = bitz<<8;
    if (*st) bitz = bitz+((*st++)&255);
      else bitz = bitz+32;}
  return CHR4(bitz);}

Char4 CHR4(String st) {
  Char4 bitz = CHR4(Text_Of(st));
  if (st) _FrameWork_::UpDownStr(st,-1,_BASE_+__LINE__);
  return bitz;}

namespace  _FrameWork_ { // resume

boolean IsAlphaNum(char ch) { // used only by Tokeniz
  if (ch<'0') return false;
  if (ch <= '9') return true;
  if (ch>'z') return false;
  if (ch<'A') return false;
  if (ch == '_') return true;
  return (Capitize(ch) <= 'Z');}

int Conver_Time(SYSTEMTIME* now) { // convert Win32 time to MOS
  int secs; int days = (now->wYear-2001);
  char* mo = " 01/001123344"; // cumulative, relative to '0' (not leap year)
    // assuming a 30-day month model, each character of mo[] encodes
    // the number of days it differs from the model; '0' exactly matches
  days = (days+1)*365+(days>>2); // days since Y2K to Jan this year
  days = days+((int)mo[now->wMonth])+now->wMonth*30-78+now->wDay;
    // add +30 for each prior month in year, + current day + diff in mo[],
    // -48 [which is (int)'0'] -30 because wMonth is 1-based
    // -1 because wDay is 1-based, +1 after 2000 for Y2K leap day
  if (now->wMonth>2) if ((now->wYear&3)==0) days++; // correcting for leap year
  secs = days*86400+now->wHour*3600+now->wMinute*60+now->wSecond;
  _Look_See_();
  return secs;} //~Conver_Time

int Tokenize(int kin, int orn, String stx, int* ptLn) { // rtns offset or #
  char ch, sep; // orn=0 (unuse, invalid in K68) counts items (but -1 from orn=-1)
  int ordn = MAX(orn,-1); // 1-base ordinal: -1 counts, -2 includes final delim
  int here = _len_(stx), myLen = 0, offs = 0; // kin: 0:word, -1:tok, >0:delim
  char* xStr = Text_Of(stx); // does not dn-ref stx
  if (here>0) while (true) {
    if (ordn>orn) orn = 0; // (was -2) the algorithm was designed for 0 here
    if (kin == -2) kin = ORD('\n'); // special case line-delimiter
    sep = (char)(kin&127);
    here = 0; // byte offset into whole string
    ch = *xStr;
    while (true) { // once through for each chunk (tok/word/line/..)..
      if (kin<=0) while (ch <= ' ') { // skip to 1st/next word/tok..
        if (ch == '\0') break;
        ch = xStr[++here];}
      if (ch == '\0') { // got end of string
        if (ordn<0) return MIN(orn-ordn,here); // the number we saw
        offs = here; // off the end
        break;}
      ordn--;
      // sets up offset+length for immediately following Substring call..
      if (ordn==0) offs = here; // got front of requested tok
      if (kin==0) while (ch>' ') ch = xStr[++here]; // skip to end of word
      else if (kin<0) { // skip to end of tok = word or other non-blank
        if (IsAlphaNum(ch)) while (IsAlphaNum(ch)) ch = xStr[++here]; // word
          else ch = xStr[++here];} // any other non-blank counts as a single tok
      else while (ch != sep) { // or else skip to next delimiter..
        ch = xStr[++here];
        if (ch == '\0') break;}
      if (ordn==0) { // found back of requested tok, record length..
        myLen = here-offs;
        break;}
      if (ch == '\0') { // no final delimiter to count..
        if (ordn<0) if (orn==0) orn = -1;
        continue;}
      if (kin<0) continue;
      ch = xStr[++here];} // skip over delimiter
    break;}
  // if (stx) _FrameWork_::UpDownStr(stx,-1,_BASE_+__LINE__); // caller not ++
  if (ptLn) *ptLn = myLen;
  return offs;} // ~Tokenize

////////////////////////////////////////////////////////////////////////

/// Opaque File type, implemented as a pointer to a _File_ class..

// void Set_File_Flagz(File aFile, int flagz) { // now in C_Turk
//   if (IsValidFile(aFile)) aFile->SetFlagz(flagz);}

// WinFile Get_File_w32(File aFile) {return aFile->GetWn32_File();} // in C_Turk

// File Next_File(File aFile) { // PRE: aFile is valid or null (unused)
//   if (aFile==NULL) return PIBfiles;
//   return aFile->GetLink();}

// File Open_Fail(String msg, String name) { // _cat_ dn-refs msg, name
//   SystemDebugLog(_cat_(_cat_(_cat_(">>>>> FileFail ",msg)," "),name));
//   // down__ptr(thePath); // a coutesy to caller
//   return NULL;}

// void Win32FindClose(File aFile) { // unused
//   if (aFile->GetFiHand() != null) FindClose(aFile->GetFiHand());
//   aFile->SetFiHand(NULL);}

int Write_Data(File aFile, char* ary, int nby) {
  // write nby bytes of data from ary to open file fi, return actual # written
  DWORD got = 0;
  int bitz = aFile->GetFlagz(); // =0 if invalid
  _Look_See_();
  if (bitz==0) return 0;
#ifndef __MSL__ // so we can test-compile it on the Mac (non-functional)
  if (nby>0) if ((bitz&FlagMask) != 0) if ((bitz&DirecOnly) != Directory)
    if (((bitz&(MakeFiRef+Append))^WriteOnly) < Append)
      // return (int)fwrite(ary,1,nby,aFile->GetWn32_File());
      if (WriteFile(aFile->GetWn32_File(),ary,nby,LPDWORD(&got),NULL))
        return (int)got;
#endif // __MSL__
  return 0;} //~Write_Data

int Read_Data(File aFile, char* ary, int nby) {
  // read up to nby bytes of data into ary from open file fi, return actual #
  DWORD got = 0;
  int bitz = aFile->GetFlagz(); // =0 if invalid
  _Look_See_();
  if (bitz==0) return 0;
#ifndef __MSL__ // so we can test-compile it on the Mac (non-functional)
  if (nby>0) if ((bitz&FlagMask) != 0) if ((bitz&DirecOnly) != Directory)
    if ((bitz&(MakeFiRef+WriteOnly)) ==0)
      // return (int)fread(ary,1,nby,aFile->GetWn32_File());
      if (ReadFile(aFile->GetWn32_File(),ary,nby,LPDWORD(&got),NULL))
        return (int)got;
#endif // __MSL__
  return 0;} //~Read_Data

File OpenFileDialog(String Prompt, File iDir, String finam, String filter,
      String ext3, boolean newly) { // called from Csystem
  OPENFILENAME theData;
  DWORD bitz;
  char flt[256];
  char* fixx = flt;
  char cbf[PathSize+1];
  String Dir_Path = Null_Str;
  flt[0] = '\0';
  cbf[0] = '\0';
  if (iDir != NULL) Dir_Path = iDir->myFullPath();
  if (finam) strcpy(cbf,Text_Of(finam));
  if (filter) strcpy(flt,Text_Of(filter));
  while (true) {
    if (*fixx == '\t') *fixx++ = '\0';
    else if (*fixx++ == '\0') break;}
  theData.lStructSize = sizeof(OPENFILENAME);
  theData.hwndOwner = theFrontWin;
  theData.hInstance = NULL;
  theData.lpstrFilter = flt;
  theData.lpstrCustomFilter = NULL;
  theData.nMaxCustFilter = 0;
  theData.nFilterIndex = 0;
  theData.lpstrFile = cbf;
  theData.nMaxFile = PathSize;
  theData.lpstrFileTitle = NULL;
  theData.nMaxFileTitle = 0;
  if (_len_(Dir_Path)==0) theData.lpstrInitialDir = NULL;
    else theData.lpstrInitialDir = Text_Of(Dir_Path);
  if (Prompt) theData.lpstrTitle = Text_Of(Prompt);
    else theData.lpstrTitle = ProgramName;
  theData.nFileOffset = 0;
  theData.nFileExtension = 0;
  theData.lpstrDefExt = Text_Of(ext3);
  theData.lCustData = 0;
  theData.lpfnHook = NULL;
  theData.lpTemplateName = NULL;
  if (ext3) _FrameWork_::UpDownStr(ext3,-1,_BASE_+__LINE__);
  if (finam) _FrameWork_::UpDownStr(finam,-1,_BASE_+__LINE__);
  if (filter) _FrameWork_::UpDownStr(filter,-1,_BASE_+__LINE__);
  iDir = NULL;
  if (newly) {
    theData.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY
        | OFN_NOREADONLYRETURN;
    newly = (GetSaveFileName(&theData) !=0);}
  else {
    theData.Flags = OFN_FILEMUSTEXIST;
    newly = (GetOpenFileName(&theData) !=0);}
  Fresh_Mods = true;
  if (DebugLogFile) {
    if (newly) SystemDebugLog(_cat_(_cat_(_cat_(_cat_("OpFiDlg '",
      Prompt),"' = '"),cbf),"'")); // uses up Prompt's ref-cnt
    else SystemDebugLog(_cat_(_cat_("OpFiDlg '",Prompt),"' -"));}
  else if (Prompt) _FrameWork_::UpDownStr(Prompt,-1,_BASE_+__LINE__);
  if (newly) {
    bitz = GetFileAttributes(cbf);
    if (bitz<0) return NULL; // no such file
    Dir_Path = _Str_(cbf);
    if (bitz&FILE_ATTRIBUTE_DIRECTORY)
      iDir = OpenInDir(Dir_Path,Directory+MakeFiRef,NULL);
    else iDir = OpenInDir(Dir_Path,MakeFiRef,NULL);}
  else if (Dir_Path) _FrameWork_::UpDownStr(Dir_Path,-1,_BASE_+__LINE__);
  return iDir;} // ~OpenFileDialog

 } // (temporarily) end namespace  _FrameWork_

void _File_::flush_() {FlushFileBuffers(FileInodN);} // don't use, long delays!
int _File_::GetRefNum() {return FileRefNum;}
File _File_::GetLink() {return FileLink;}
WinFile _File_::GetWn32_File() {return FileInodN;}
void _File_::File_w32_Zap(WinFile wfi) {FileInodN = wfi;}
String _File_::myFileName() {return up__ptr(FilNamLnk);}
String _File_::myFullPath() {return up__ptr(DirPath);}
HANDLE _File_::GetFiHand() {return Find_Hand;}
void _File_::SetFiHand(HANDLE theH) {Find_Hand = theH;}
void _File_::SetFiOwn(int whom) {OwnerPro = whom;}
int _File_::GetFpos() {return FilePosnO;}
void _File_::SetFpos(int here) {FilePosnO = here;}
int _File_::GetFlagz() {return FiFlagCnt;}
void _File_::SetFlagz(int flagz) {
  FiFlagCnt = flagz;
  if (flagz==0) {if (FileRefNum>0) FileRefNum = -FileRefNum;}
  else if (flagz<0) if (FileRefNum <= 0)
    FileRefNum = ++_FrameWork_::FilnIx;}

void _File_::LinkMe2(File whom) {
  FileLink = whom->FileLink;
  whom->FileLink = this;}

void SetFiNames(File aFile, String thePath) {
  if (aFile) {
    down__ptr(aFile->FilNamLnk);
    aFile->FilNamLnk = LastItem(up__ptr(thePath),'\\');
    down__ptr(aFile->DirPath);
    aFile->DirPath = thePath;}
  else down__ptr(thePath);}

_File_::~_File_() { // Note: #define File_Destructor(f) delete f
  File lnk; File prior = NULL;                            // now unused
  if (DebugLogFile) if (DebugLogFile != this)
    SystemDebugLog(_cat_("FiDestruct -",_Str_(FileRefNum)));
  if (Find_Hand != NULL) FindClose(Find_Hand);
  Find_Hand = NULL;
  OwnerPro = 0;
  down__ptr(DirPath);
  down__ptr(FilNamLnk);
  Wait32(_FrameWork_::ResFi_Lok);
  lnk = _FrameWork_::PIBfiles;
  while (lnk != NULL) {
    if (lnk==this) {
      if (prior == NULL) _FrameWork_::PIBfiles = lnk->FileLink;
        else prior->FileLink = lnk->FileLink;
      break;}
    prior = lnk;
    lnk = lnk->FileLink;}
  Signal32(_FrameWork_::ResFi_Lok);
  _Look_See_();}

_File_::_File_() { // all calls from Csystem
  FileRefNum = ++_FrameWork_::FilnIx;
  Find_Hand = NULL;
  FileLink = NULL;
  FileInodN = NULL;
  ParDirLnk = NULL;
  DirPath = Null_Str;
  FilNamLnk = Null_Str;
  FiFlagCnt = 0;
  FilePosnO = 0;
  OwnerPro = 0;
  _Look_See_();}

_File_::_File_(String pth, WinFile wfi, int flg) { // unused
  // _File_();
  FileRefNum = ++_FrameWork_::FilnIx;
  Find_Hand = NULL;
  FileLink = NULL;
  ParDirLnk = NULL;
  FilePosnO = 0;
  OwnerPro = 0; // should be ProcID of owner
  Wait32(_FrameWork_::ResFi_Lok);
  if (_FrameWork_::PIBfiles != NULL) {
    FileLink = _FrameWork_::PIBfiles->FileLink;
    _FrameWork_::PIBfiles->FileLink = this;}
  else _FrameWork_::PIBfiles = this;
  Signal32(_FrameWork_::ResFi_Lok);
  FileInodN = wfi;
  FiFlagCnt = flg&FlagMask;
  DirPath = pth; // takes over its ref-cnt
  FilNamLnk = LastItem(up__ptr(pth),'\\');
  _Look_See_();}

boolean IsValidFile(File aFile) {
  File here = _FrameWork_::PIBfiles;
  _Look_See_();
  if (aFile==NULL) return false;
  while (here != NULL) {
    if (here==aFile) return (here->FileRefNum>0);
    here = here->FileLink;}
  return false;}

File File_4int(int whom) { // only returns valid File
  File here = _FrameWork_::PIBfiles;
  while (here != NULL) {
    if (whom == (int)here) break;
    here = here->FileLink;}
  return here;}

File Find_Directry(String path, boolean Sharon, int whom) {
  File aFile = _FrameWork_::PIBfiles; // Sharon: also shared files
  while (aFile != NULL) {
    if ((Sharon && ((aFile->GetFlagz() & SharedResFile) == SharedResFile)
        || ((aFile->GetFlagz() & DirecOnly) == Directory)))
      if (_compare_(up__ptr(aFile->DirPath),up__ptr(path))==0)
        if (whom==0 || aFile->OwnerPro==0 || aFile->OwnerPro==whom) break;
    aFile = aFile->FileLink;}
  down__ptr(path);
  return aFile;}

File Find_UnusedFi() {
  File aFile = _FrameWork_::PIBfiles;
  while (aFile != NULL) {
    if (aFile->GetFlagz() ==0) break;
    aFile = aFile->FileLink;}
  return aFile;}

int GetFilePosn(File aFile) { // use returned value for later Seek()
  int here;
  if (IsValidFile(aFile)) while (true) {
    here = aFile->GetFlagz();
    if ((here&MakeFiRef) !=0) break;
    if ((aFile->GetFlagz()&DirecOnly) != Directory)
      return (int)SetFilePointer(aFile->GetWn32_File(),0,NULL,FILE_CURRENT);
    here = aFile->GetFpos();
    if (here<0) return ~here;
    return here;}
  return -1;}

int GetSizeFile(File aFile) { // Seek() to here sets EOF true
  if (IsValidFile(aFile))
    if ((aFile->GetFlagz()&DirecOnly) != Directory)
      if ((aFile->GetFlagz()&MakeFiRef)==0) 
    return (int)GetFileSize(aFile->GetWn32_File(),NULL); // Win32 call
  return -1;}

int GetFileFlags(File aFile) { // see bits above
  if (!IsValidFile(aFile)) return 0;
  return aFile->GetFlagz();}
String GetFileName(File aFile) {
  if (!IsValidFile(aFile)) return Null_Str;
  return aFile->myFileName();}
String FullPath(File aFile) {
  if (!IsValidFile(aFile)) return Null_Str;
  return aFile->myFullPath();}
int GetFiRefNum(File aFile) {
  if (!IsValidFile(aFile)) return 0;
  return aFile->GetRefNum();}
boolean FileAtEOF(File aFile) { // true if at EOF
  if (!IsValidFile(aFile)) return false;
  return (GetFilePosn(aFile)==GetSizeFile(aFile));}

void SystemDebugLog(String theSt) { // adds \r\n at end
  char* here = Text_Of(theSt);
  char* crlf = CR_LF; // char* crlf = "\r\n";
  int ix = _len_(theSt);
  if (DebugLogFile) {
    if (_Sync_Debug_) Wait32(_FrameWork_::DebugLok);
    if (ix>0) _FrameWork_::Write_Data(DebugLogFile,here,ix);
    _FrameWork_::Write_Data(DebugLogFile,crlf,CRLF_LEN);
    if (_FrameWork_::FlushDBlog) DebugLogFile->flush_(); // incredibly slow!!
    if (_Sync_Debug_) Signal32(_FrameWork_::DebugLok);}
  if (theSt)
    _FrameWork_::UpDownStr(theSt,-1,_BASE_+__LINE__);} //~SystemDebugLog

int Read_Dir_Info(File aFile, int* ary) { // result in # full ints
  int lxx, nwd = _Array_LENGTH_(ary), cre = 0, bitz = 0;
  String name = Null_Str;
  SYSTEMTIME YMDT;
  if (nwd<2) return 0;
  if ((GetFileFlags(aFile)&DirecOnly) != Directory) return 0;
  name = ReadLine(aFile); // also sets up FindInfo
  if (name == Null_Str) return 0;
  for (lxx=nwd+_fS_+1; lxx>_fS_+2; lxx--) ary[lxx] = 0;
  lxx = _len_(name);
  if ((_FrameWork_::FindInfo.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) ==0) {
    if (Offset(_S_0021 /*.txt*/,up__ptr(name))+4 == lxx) bitz = ORD("TEXT");
      else bitz = ORD("Data");}
  ary[_fS_+2] = bitz;
  FileTimeToSystemTime(&_FrameWork_::FindInfo.ftLastWriteTime,&YMDT);
  ary[_fS_+3] = _FrameWork_::Conver_Time(&YMDT);
  if (nwd<3) return 2;
  FileTimeToSystemTime(&_FrameWork_::FindInfo.ftCreationTime,&YMDT);
  ary[_fS_+4] = _FrameWork_::Conver_Time(&YMDT);
  return 3;}

int ReadData(File aFile, int* ary) { // result in # full ints
  int nby;
  if (ary==NULL) return 0;
  if ((GetFileFlags(aFile)&DirecOnly) == Directory)
    return Read_Dir_Info(aFile,ary);
  if ((ary[_fS_]&0xFF00)==0) if ((ary[_fS_]&0xFF)>0) ary[_fS_]--; // not dispose
  ary++;  if (_fS_) ary++;
  nby = *ary++;
  return _FrameWork_::Read_Data(aFile,(char*)ary,nby<<2)>>2;}

int FiSize_If_0(File aFile, int nby) {
  if (nby <= 0) nby = MAX(GetSizeFile(aFile)-GetFilePosn(aFile),0);
  return nby;}

String ReadText(File aFile, int nby) { // read nby bytes of text, dele \0,\r
  int ix = 0; int sz = FiSize_If_0(aFile,nby); // nby=0 gets all; never: sz<0
  int* res;
  char* here;
  char xCh;
  if (sz==0) return Null_Str;
  here = _FrameWork_::AllocStr(sz,0);
  if (here==NULL) return Null_Str;
  res = (int*)here;
  sz = _FrameWork_::Read_Data(aFile,here,sz);
  if (sz==0) return Null_Str;
  nby = 0;
  while (ix<sz) {
    xCh = here[ix++];
    if (xCh == '\r') {
      if (here[ix] == '\n') ix++;
      here[nby++] = '\n';}
    else if (xCh != '\0') here[nby++] = xCh;}
  here[nby] = '\0';
  *(--res) = nby;
  sz = *(--res);
  res--; res--;
  if ((nby<<3)<sz-9999) { // recover unused space, if huge..
    here = (char*)_FrameWork_::NewStrText(here,nby,_BASE_+__LINE__);
    if (here) {
      _FrameWork_::UpDownStr(res,-1,0);
      res = (int*)here;}}
  return (String)res;} //~ReadText

String ReadLine(File aFile) { // read text to end of line
  int nby = 0;
  char ch; char bf[260];
  String stx = Null_Str;
  if (!IsValidFile(aFile)) return Null_Str;
  if (aFile->GetFiHand() != NULL) { // directory search already open..
    nby = aFile->GetFpos();
    if (nby<0) { // "reread" previous entry
      aFile->SetFpos(-nby);
      nby = strlen(_FrameWork_::FindInfo.cFileName);
      if (((nby-1)&-256)==0) strcpy(bf,_FrameWork_::FindInfo.cFileName);
        else nby = 0;}
    else if (FindNextFile(aFile->GetFiHand(),&_FrameWork_::FindInfo)) {
      aFile->SetFpos(ABS(aFile->GetFpos())+1);
      nby = strlen(_FrameWork_::FindInfo.cFileName);
      if (((nby-1)&-256)==0) strcpy(bf,_FrameWork_::FindInfo.cFileName);
        else nby = 0;}
    else nby = 0;}
  else if ((aFile->GetFlagz()&DirecOnly) == Directory) {
    aFile->SetFpos(0);
    stx = _cat_(aFile->myFullPath(),"\\*");
    aFile->SetFiHand(FindFirstFile(Text_Of(stx),&_FrameWork_::FindInfo));
    down__ptr(stx);
    if (aFile->GetFiHand() != INVALID_HANDLE_VALUE) {
      aFile->SetFiOwn(ORD_4(WhoAmI()));
      aFile->SetFpos(1);
      nby = strlen(_FrameWork_::FindInfo.cFileName);
      if (((nby-1)&-256)==0) strcpy(bf,_FrameWork_::FindInfo.cFileName);
        else nby = 0;}
    else aFile->SetFiHand(NULL);}
  else while (_FrameWork_::Read_Data(aFile,&ch,1)>0) {
    if (ch == '\0') break;
    if (ch == '\r') break;
    if (ch == '\n') {
      if (nby==0) continue;
      break;}
    bf[nby++] = ch;
    if (nby>255) break;}
  if (nby==0) return Null_Str;
  bf[nby] = '\0';
  return _FrameWork_::NewStrText(bf,nby,_BASE_+__LINE__);} // ~ReadLine

int ReadByte(File aFile) {
  char ch = 0;
  if (_FrameWork_::Read_Data(aFile,(char*)(&ch),1) <= 0) ch = 0;
  return ch&255;}

int WriteData(File aFile, int* ary) { // rtns # ints (was: byte count)
  if (ary==NULL) return 0;
  int nby = ary[_fS_+1];
  if (nby>0) nby = _FrameWork_::Write_Data(aFile,
      (char*)(((int)ary)+sizeof(int)*(_fS_+2)),nby<<2)>>2;
  down__ptr(ary); // dispose if done
  return nby;}

void WriteBytes(File aFile, int* ary, int bgn, int ln) {
  int nby;
  if (ary==NULL) return;
  nby = MAX(MIN((ary[_fS_+1]<<2)-bgn,ln),0);
  if (bgn >= 0) if (nby>0) nby = _FrameWork_::Write_Data(aFile,
      (char*)(((int)ary)+bgn+sizeof(int)*(_fS_+2)),nby);
  down__ptr(ary);} // disposes if done

void WriteChar(File aFile, char ch) {
  _FrameWork_::Write_Data(aFile,&ch,1);}
void WriteLn(File aFile) {
  char* crlf = CR_LF;
  _FrameWork_::Write_Data(aFile,crlf,CRLF_LEN);}

void WriteText(File aFile, String theSt) { // write text w/ line breaks..
  char* here = Text_Of(theSt);
  char* crlf = CR_LF;
  int ix = 0; int mx = _len_(theSt); int zx = -1;
  if (mx==0) return;
  if (DebugLogFile) if (_FrameWork_::LogTextWrites) if (aFile != DebugLogFile) {
    WriteChar(DebugLogFile,'\'');
    zx = 80;}
  while (ix<mx) {
    if (here[ix] == '\n') {
      if (ix>0) {
        if (zx>0) {
          _FrameWork_::Write_Data(DebugLogFile,here,MIN(ix,zx));
          if (ix <= zx) WriteChar(DebugLogFile,'\\');
          zx = MAX(zx-1-ix,0);}
        if (_FrameWork_::Write_Data(aFile,here,ix)<ix) break;}
      if (_FrameWork_::Write_Data(aFile,crlf,CRLF_LEN)<CRLF_LEN) break;
      here = (char*)(((int)here)+ix+1);
      mx = mx-1-ix;
      ix = 0;}
    else ix++;}
  if (ix>0) {
    if (zx>0) _FrameWork_::Write_Data(DebugLogFile,here,MIN(ix,zx));
    _FrameWork_::Write_Data(aFile,here,ix);}
  _FrameWork_::UpDownStr(theSt,-1,_BASE_+__LINE__);
  if (zx<0) return;
  WriteChar(DebugLogFile,'\'');
  WriteLn(DebugLogFile);} //~WriteText
  // DebugLogFile->flush_(); // incredibly slow!!

void WriteChr4(File aFile, Char4 cx) {WriteText(aFile,_Str4_(cx));} //~WriteText

String GetCurWinDirName(void) {
  char cbf[PathSize+1];
  int nn = GetCurrentDirectory(PathSize,cbf);
  String theName = _FrameWork_::NewStrText(cbf,nn,_BASE_+__LINE__);
  if (nn >= PathSize)
    nn = GetCurrentDirectory(nn+1,Text_Of(theName));
  return theName;}

String ProgFileName(void) { // returns full path name
  char thename[2222]; // plenty big
  if (GetModuleFileName(NULL,thename,2220)<2222) return _Str_(thename);
  return Null_Str;} //~ProgFileName

void Seek(File aFile, int offs) { // reposition disk file
  if (!IsValidFile(aFile)) FileErrorOff(NoSuchFile);
  else if (offs<0) FileErrorOff(CantAccess);
  else if ((aFile->GetFlagz()&MakeFiRef) !=0) FileErrorOff(CantAccess);
  else if ((aFile->GetFlagz()&DirecOnly) == Directory) {
    int here = aFile->GetFpos();
    if (offs==0) {
      if (aFile->Find_Hand != NULL) FindClose(aFile->Find_Hand);
      aFile->Find_Hand = NULL;
      aFile->OwnerPro = 0;
      aFile->SetFpos(0);}
    else if (here==offs) FileErrorOff(0);
    else if (here==offs+1) {
      aFile->SetFpos(-here);
      FileErrorOff(0);}
    else if (here+offs+1 ==0) FileErrorOff(0);
      else FileErrorOff(CantAccess);}
  else if (SetFilePointer(aFile->GetWn32_File(),offs,NULL,FILE_BEGIN)<0)
    FileErrorOff(CantAccess);
  else FileErrorOff(0);} //~Seek

File Close2Ref(File aFile) { // close it (return a re-openable file ref)
  int why = 0x80000001;
  if (!IsValidFile(aFile)) return NULL;
  if (_FrameWork_::Using_ResFi == aFile) _FrameWork_::Using_ResFi = NULL;
  if (aFile->Find_Hand != NULL) FindClose(aFile->Find_Hand);
  aFile->Find_Hand = NULL;
  // aFile->OwnerPro = 0;
  aFile->SetFpos(0);
  if ((aFile->GetFlagz()&ResFileTy) == ResFileTy)
    _FrameWork_::SysCacheInv(GetFiRefNum(aFile)<<16);
  if ((aFile->GetFlagz()&DirecOnly) == Directory) why++;
  else if ((aFile->GetFlagz()&MakeFiRef) !=0) why--;
  else if (aFile->GetWn32_File()==0) why = 0;
  else if (!CloseHandle(aFile->GetWn32_File()))
    why = GetLastError();
  else why = 0;
  aFile->File_w32_Zap(0);
  if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_("ClosFi +*",
      _Str_(aFile->GetRefNum()))," = "),FormInt(why)));
  aFile->SetFlagz(aFile->GetFlagz()|MakeFiRef);
  _Look_See_();
  return aFile;} //~Close2Ref

////////////////////////////////////////////////////////////////////////

// Widgit definitions (from T2C, more Widgit/WindInfo code later)..

int _WindowOps_::WhoMeQ() {return 0x6E4F7073;}
void _WindowOps_::DoWinOp(int whom, int theWin, int pram1, int pram2,
  int pram3) {}
void _WindowOps_::DoWgtOp(int whom, int theWin, int pram1, int pram2,
  int pram3) {}

O__WindowOps__ i__WindowOps__;
O__WindowOps__::O__WindowOps__() {InstallMe(this);}

void O__WindowOps__::Zero_Refs(Object ox) {
  WindowOps whom = NULL;
  if (typeid(*ox) == typeid(_WindowOps_)) whom = (WindowOps)ox;
  if (whom != NULL) delete whom;}

WindowOps new__WindowOps_() {
  WindowOps ptr = NULL; try {ptr = new _WindowOps_;}
  catch(bad_alloc xx) {return NULL;}  return ptr;} //~new__WindowOps_

/// Predefined Rectangle class (base class for all widgits)

O__RectAngle__ i__RectAngle__;
O__RectAngle__::O__RectAngle__() {InstallMe(this);}

void O__RectAngle__::Zero_Refs(Object ox) {
  RectAngle whom = NULL;
  if (typeid(*ox) == typeid(_RectAngle_)) whom = (RectAngle)ox;
  if (whom != NULL) delete whom;}

RectAngle new__RectAngle_() {
  RectAngle ptr = NULL; try {ptr = new _RectAngle_;}
  catch(bad_alloc xx) {return NULL;}  return ptr;} //~new__RectAngle_

O__Widgit__ i__Widgit__;
O__Widgit__::O__Widgit__() {InstallMe(this);}

void O__Widgit__::Zero_Refs(Object ox) {
  Widgit whom = NULL;
  if (typeid(*ox) == typeid(_Widgit_)) whom = (Widgit)ox;
  if (whom != NULL) delete whom;}

Widgit new__Widgit_() {
  Widgit ptr = NULL; try {ptr = new _Widgit_;}
  catch(bad_alloc xx) {return NULL;}  return ptr;} //~new__Widgit_

O__WindInfo__ i__WindInfo__;
O__WindInfo__::O__WindInfo__() {InstallMe(this);}

void O__WindInfo__::Zero_Refs(Object ox) {
  WindInfo whom = NULL;
  if (typeid(*ox) == typeid(_WindInfo_)) whom = (WindInfo)ox;
  if (whom != NULL) delete whom;}

WindInfo new__WindInfo_() { // nobody calls this
  WindInfo ptr = NULL; try {ptr = new _WindInfo_;}
  catch(bad_alloc xx) {return NULL;}  return ptr;} //~new__WindInfo_

////////////////////////////////////////////////////////////////////////

// Forward function declarations, mostly linked to Csystem.h ..

namespace  _FrameWork_ { // resume

#ifdef MOS_System

void Asyn_Msg(Char4 EvNo, int eInfo, int EvLoc, int EvDat, Process toPro) {
  _System_::Async_Msg(true,EvNo,eInfo,EvLoc,EvDat,toPro);}
void Hiden_Die(Window aWin) {_System_::HidenDie(0,aWin);}
void Do_Menu_Comm(Char4 EvNo, Window myWin, Process toPro) {
  _System_::Do_Menu_Comm(EvNo,myWin,toPro);}
boolean Do_KeyDown(Win_Window theWin, char theKey) {
  return _System_::Do_KeyDown(theWin,theKey);} // true if we took it
boolean Mouse_InDocX(Win_Window theWin, int mov) {
  return _System_::Mouse_InDocX(theWin,mov);}
boolean Scroll_Some(Win_Window theWin, int whom, int whar) {
  return _System_::Scroll_Some(theWin,whom,whar);}
Window Rectify_MyWin(Win_Window theWin, int fixt) {
  return _System_::Rectify_MyWin(theWin,fixt);}
boolean Windo_Resized(Win_Window theWin) {
  return _System_::Windo_Resized(theWin);}
boolean Windo_Painting(Win_Window theWin, RectAngle wnRect) {
  return _System_::Windo_Painting(theWin,wnRect);}
void Windo_Activ8(Window theWin, int ax) {_System_::Windo_Activ8(theWin,ax);}
int Do_WinEvent(int msg, Event ev) {return _System_::Do_WinEvent(msg,ev);}
boolean Get_HotRect(Win_Window theWin, Widgit theWg, RectAngle wnRect) {
  return _System_::Get_HotRect(0,theWin,theWg,wnRect);}
void unPacifyWin(Window theWn) {_System_::unPacifyWin(theWn);}
int Get_Progress_Pix(Window theWin, int wide) {
  return _System_::Get_Progress_Pix(theWin,wide);}
void Clean_Un_pend(Process whom) {_System_::Clean_Unpend(whom);}
void PopRelease(int zap) {_System_::PopRelease(zap);}
void Menu_Logger(HMENU whom, int deep, String aLine) {
  _System_::Menu_Logger(whom,deep,aLine);}
void Quit_Proc(Process whom) {_System_::Quit_Process(whom);}

#else // if no MOS_System, no '#include Csystem.h'..

void Asyn_Msg(Char4 EvNo, int eInfo, int EvLoc, int EvDat, Process toPro) {}
void Hiden_Die(Window aWin) {}
void Do_Menu_Comm(Char4 EvNo, Window myWin, Process toPro) {}
boolean Do_KeyDown(Win_Window theWin, char theKey) {return false;}
boolean Mouse_InDocX(Win_Window theWin, int mov) {return false;}
boolean Scroll_Some(Win_Window theWin, int whom, int whar) {return false;}
Window Rectify_MyWin(Win_Window theWin, int fixt) {return NULL;}
boolean Windo_Resized(Win_Window theWin) {return false;}
boolean Windo_Painting(Win_Window theWin, RectAngle wnRect) {return false;}
int Do_WinEvent(int msg, Event ev) {return 0;}
boolean Get_HotRect(Win_Window theWin, Widgit theWg, RectAngle wnRect)
  {return false;}
void unPacifyWin(Window theWn) {}
int Get_Progress_Pix(Window theWin, int wide) {return 0;}
boolean TrakDrag(Win_Window theWin, Point Locn, Widgit TrkWig, int taker)
  {return false;}
void Clean_Un_pend(Process whom) {}
void PopRelease(int zap) {}
void Menu_Logger(HMENU whom, int deep, String aLine) {}
void Quit_Proc(Process whom) {
  if (whom==NULL) ExitProcess(0); // if (Ready_List=MainProgram)
    else whom->T2F_Quit();}

void Windo_Activ8(Window theWin, int ax) {
  if (LoHalf(ax) == WA_ACTIVE) theFrontWin = GetWgtWinWin(theWin);
    else theFrontWin = NULL;}

#endif // (not) MOS_System

 } // (temply) end namespace  _FrameWork_

////////////////////////////////////////////////////////////////////////

/// Process management stuff..

_T2F_Process_::_T2F_Process_(String pname = Null_Str, Char4 pnam4 = Null4) {
  Char4 pn4 = pnam4; // should be already valid & unique, from NewProgr
  char* Qname = NULL; char* Wname = NULL;
  _00_ = 1; // s_a_s preserves this ref-count
  set_ary_size((void*)this,-17,27); // disallow up-dn counting
  // _0__0_ = NULL;
  _event_list_ = NULL;
  ParentPro = NULL;
  Thread_32 = NULL;
  CameFromStk = NULL;
  WinThread_ID = 0;
  if (pn4 <= NoName) if (pname != Null_Str) pn4 = CHR4(up__ptr(pname));
  if (pn4 > NoName) if (Proc4ch(pn4) != NULL) pn4 = NoName;
  if (pn4 <= NoName) {
    _FrameWork_::Next_ProcID = Up4Char(_FrameWork_::Next_ProcID);
    pn4 = _FrameWork_::Next_ProcID;}
  if (pname) { // always..
    if (ProcByName(up__ptr(pname)) != NULL)
      pname = _cat_(_cat_(pname," "),_Str4_(pn4));}
  else pname = _S_0007 /*??*/; // so it's never Null_Str until quit
  _my_name_ = _cat_(up__ptr(pname)," +");
  Wname = Text_Of(_my_name_);
  Qname = Text_Of(pname);
  NewSem32(_wait_event_,0,Qname);
  NewSem32(_reply_wait_,0,Wname);
  _my_name_ = up__ptr(pname);
  PIBprocID = pn4;
  PIBfilErr = 0;
  PendBitz = 0;
  _Delay_Time_ = 0;
  Wait32(_FrameWork_::Even_Lok);
  PIBlink = _FrameWork_::Ready_List;
  _FrameWork_::Ready_List = this;
  Signal32(_FrameWork_::Even_Lok);
  if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_(_cat_("*** NEW ",
      up__ptr(pname))," = "),_Str4_(pnam4)),FormTimeMS()));} //~T2F_Process

Process MySelf() {
  int az = 0;
  DWORD myID = GetCurrentThreadId();
  Process here = _FrameWork_::Ready_List;
  while (here != NULL)
    if (here->WinThread_ID == myID) return here;
      else here = here->PIBlink;
  if (_Crash_and_Burn_) az = (++az)/az; // div/0
  return NULL;} //~MySelf

Process NewProgram(String pname, File dir, Char4 pnam4, IntArray stkF) {
  // open program file pname in dir, give it (suggested) process ID pnam4
  Process whom;                                         // ignore stkF
  DWORD aThreadID = GetCurrentThreadId();
  PTHREAD_START_ROUTINE starter = _New_Thread_(up__ptr(pname));
  // PTHREAD_START_ROUTINE starter = (PTHREAD_START_ROUTINE)StartNewProg;
  if (_FrameWork_::Ready_List != NULL) {
    if (pname == Null_Str) return NULL;
    if (CharAt(0,up__ptr(pname)) <= ' ') return NULL;}
  if (pnam4 <= NoName) {
    do {_FrameWork_::Next_ProcID = Up4Char(_FrameWork_::Next_ProcID);}
      while (Proc4ch(_FrameWork_::Next_ProcID) != NULL);
    pnam4 = _FrameWork_::Next_ProcID;}
  else while (Proc4ch(pnam4) != NULL) pnam4 = Up4Char(pnam4);
  // if (DebugLogFile) SystemDebugLog(_Str_("+ NewProg ")+pnam4+" "+pname);
  try {whom = new _T2F_Process_(up__ptr(pname),pnam4);}
    catch (...) {whom = NULL;}
  if (whom==NULL) return NULL;
  if (pname == Null_Str) return whom; // System process is Gooey thread
  if (CharAt(0,up__ptr(pname)) > ' ') {
    whom->ParentPro = MySelf();
    whom->Thread_32 = CreateThread(NULL,0,starter,whom,
        CREATE_SUSPENDED,&aThreadID);
    whom->WinThread_ID = aThreadID;
    ResumeThread(whom->Thread_32);}
  else whom->WinThread_ID = aThreadID;
  if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_("  = ",
      _Str4_(ProcID(whom)))," "),_Str_((int)aThreadID)));
  return whom;} // ~NewProgram

boolean Valid_Process(Process pnam) {
  Process here = _FrameWork_::Ready_List;
  if (pnam == NULL) return false;
  while (here != NULL) {
    if (here == pnam) return true;
    here = here->PIBlink;}
  return false;}
String GetProgName(Process whom) { // returns program name
  if (whom==NULL) return Null_Str;
  return up__ptr(whom->_my_name_);}
Char4 ProcID(Process whom) {
  if (whom==NULL) return NoName;
  return whom->PIBprocID;}
Process ProcByName(String st) { // returns process ID
  Process here = _FrameWork_::Ready_List;
  while (here != NULL) {
    if (_compare_(up__ptr(here->_my_name_),up__ptr(st))==0) break;
    here = here->PIBlink;}
  if (st) _FrameWork_::UpDownStr(st,-1,_BASE_+__LINE__);
  return here;}
Char4 WhoAmI(void) { // returns (Char4) process ID
  DWORD myThreadID = GetCurrentThreadId();
  if (Gooey_Thread_ID==myThreadID) return CHR4("Sys!");
  Process here = _FrameWork_::Ready_List;
  while (here != NULL) {
    if (here->WinThread_ID == myThreadID) return here->PIBprocID;
    here = here->PIBlink;}
  return NoName;}
Process Proc4ch(Char4 pnam) {
  Process here = _FrameWork_::Ready_List;
  // if (pnam==MySelf) pnam = WhoAmI();
  while (here != NULL) {
    if (here->PIBprocID == pnam) break;
    here = here->PIBlink;}
  return here;}

void Quit() {_FrameWork_::Quit_Proc(NULL);} // => _System_::Quit_Process()

////////////////////////////////////////////////////////////////////////

/// Predefined Event class, implemented as a pointer to class _Event_

int Evp_cnt_Chk = 0;
Event Evp_Chk(Event evp) {
  int az = 0;
  if (((int)evp) == 0xcccccccc) { // formal, can't happen as coded
    _FrameWork_::Log_Panic(_cat_("*** Evp-Chk *** ",_Str_(Evp_cnt_Chk)));
    if (_Crash_and_Burn_) az = (++az)/az; // div/0
    evp = NULL;}
  Evp_cnt_Chk++;
  return evp;}

int _Event_::GetState() {return _ev_state_;}

void _Event_::EnQueue(Process whom, boolean state) {
  Event here;
  if (!Valid_Process(whom)) return;
  Wait32(_FrameWork_::Even_Lok);
  here = Evp_Chk(whom->_event_list_);
  _ev_link_ = NULL;
  _ev_state_ = ORD(state)&1;
  if (here != NULL) {
    // Valid8_Event(here);
    while (here->_ev_link_ != NULL) {
      here = Evp_Chk(here->_ev_link_);
      if (here==NULL) break;}
      // Valid8_Event(here);}
    if (here != NULL) here->_ev_link_ = this;}
  else whom->_event_list_ = this;
  Signal32(_FrameWork_::Even_Lok);
  Signal32(whom->_wait_event_);} //~EnQueue

Event De_Queue(Process whom) { // leaves it there if state=1 (now 2)
  Event here;
  if (!Valid_Process(whom)) return NULL;
  Wait32(_FrameWork_::Even_Lok);
  here = Evp_Chk(whom->_event_list_);
  if (here != NULL) {
    // Valid8_Event(here);
    if (here->_ev_state_ != 1) {
      whom->_event_list_ = here->_ev_link_;
      here->_ev_link_ = NULL;}
    if (here->_ev_state_ > 0) here->_ev_state_++;}
  Signal32(_FrameWork_::Even_Lok);
  return here;} //~De_Queue

O__Event__::O__Event__() {InstallMe(this);}
O__Event__ i__Event__;

Event new__Event_() {
  Event ptr = NULL; try {ptr = new _Event_;}
  catch(bad_alloc xx) {return NULL;}  return ptr;} //~new__Event_

// Event processing functions..

boolean I_am_Gooey() {return GetCurrentThreadId() == Gooey_Thread_ID;}

namespace  _FrameWork_ { // more

// int PkgPending = 0; // see also Process->PendBit, Pend_Ex()
// 0=idle, 1=WM_MOUSEMOVE, 3=Analyze_DragSt, 4=Drop_Her.
//  [-3: "AcTk" sent NOT], -2: Hotclick sent, -1: Fetch_Ev after -2/-3
// Five busy states for PkgPendin/PendBit:            -- 5=DragClipEvent
// 1. Start drag, reserved for "Drag" evt, in which TrakDrag builds "Drag"
// 2. Drag event accepted, upgrades PkgPendin from 1 to 2, sets PendBit
//   and sends it off by PkgDone->StartDrago, which releases (or else
//   Drag evt exit releases) if not taken by #4.
// 3. Drag enter keeps #2, or else AnalDragStr makes new "Drop" pkg #3
//   which is released on drag leave.
// 4. Drop takes over #2 or #3 for "Drop" evt as #4, to release on exit.
// 5. Drop event accepted, upgrades PkgPendin from 4 to 5.
// 7. DroPastEv makes "Past" from system clip, or NewClip builds "Clip",
//   both released on exit.

boolean PendEx(int why, int bitz, Process whom) {
  Char4 me2 = ProcID(whom); // FlushDBlog=(Sys_State_Bits&0x00100000..
  if (DebugLogFile) if (Drag_Trace|FlushDBlog) // D_T=T: always logs
    SystemDebugLog(Int2Log(_S_0022 /* (PndEx) */,why,
        Int2Log(_S_0001 /* */,ORD_4(me2),Int2Log(_S_0001 /* */,bitz,
        Int2Log(_S_0023 /* #*/,PkgPending,FormTimeMS())) )));
  Wait32(MoveOK); // protects BitzPend
  if (PkgPending>bitz) {
    Signal32(MoveOK);
    return false;}
  PkgPending = bitz; // =1/3 TrakDrag, =3 Analyze_DragSt, =4 Drop_Her,
  if (whom != NULL) {                                // .. =7 DragClipEvent
    if (bitz==4) bitz = 5;
    else if (bitz==1) bitz = 2; // doesn't happen
    whom->PendBitz = bitz&255; // nobody sets/looks at hi: |whom->PendBitz&-256
    ClipDragOwn = me2;}
  Signal32(MoveOK);
  return true;} // ~PendEx

inline void Copy_Event(Event too, Event frm) {
  too->EventNo = frm->EventNo;
  too->EvInfo = frm->EvInfo;
  too->EvLocn = frm->EvLocn;
  too->EvDatum = frm->EvDatum;
  too->EvSend = frm->EvSend;}

void Post_Event(Event evp, Process toProc, Process fromm, boolean wait4) {
  Event evx;
  if (evp==NULL) return;
  if (!Valid_Process(toProc)) return;
  if (toProc->_my_name_ == Null_Str) return; // it's quitting
  // Valid8_Event(evp);
  if (fromm==NULL) fromm = MySelf();
  else if (!Valid_Process(fromm)) return;
  else if (wait4) if (fromm != MySelf()) return;
  if (!wait4) { // if wait4=false, evp will be disposed after delivery..
    evx = evp;
    evp = new__Event_(); // evp = (Event)new_int_ary(7); // so make a copy
    if (evp==NULL) return;
    // Valid8_Event(evp);
    Copy_Event(evp,evx);} // evp = evx
    // evp->_ev_state_ = 0; // EnQueue does it
  else if (toProc==fromm) return;
  See_Panic(ORD("+Ev+"));
  See_Panic(ORD_(evp->EventNo));
  See_Panic(ORD_(ProcID(toProc)));
  if (DebugLogFile) if (Sys_Trace|FlushDBlog|Post_Trace)
    if ((Sys_State_Bits&8) ==0) SystemDebugLog(Int2Log(_S_0030 /*--Post */,
          ORD_4(ProcID(fromm)),Int2Log(_S_0029 /* > */,ORD_4(ProcID(toProc)),
        Int2Log(IffyStr(wait4,_S_0031 /* W */,_S_0002),ORD_4(evp->EventNo),
        Int2Log(_S_0026 /*, */,evp->EvInfo,Int2Log(_S_0026 /*, */,evp->EvLocn,
        Int2Log(_S_0026 /*, */,evp->EvDatum,_cat_(_cat_(_cat_(
        LogCameFrom(_S_0008 /*\n  -- */,19),LogCameFrom(_S_0001,18)),
        LogCameFrom(_S_0001,17)),LogCameFrom(_S_0001 /* */,-16))))) ))));
  evp->EvSend = fromm;
  evp->EnQueue(toProc,wait4);
  // Signal_Sem(&toProc->_wait_event_); // no, EnQue did
  if (!wait4) return;
  DWORD why = Wait32(fromm->_reply_wait_);
  if (why==WAIT_OBJECT_0) return;
  evx = evp;} //~Post_Event

boolean Fetch_Event(Event evp, Process whom) { // false if flushit && NULL
  Event evx;
  boolean flushit = false, noWait = false;
  Process fromm;
  if (evp==NULL) {if (whom==NULL) return false;} // caller checks
  else if (evp->EventNo == CHR4("    ")) if (evp->EvSend == NULL)
    noWait = true; // caller unwants block
  if (whom==NULL) whom = MySelf(); // now assumed
  else if (!Valid_Process(whom)) return false;
    else flushit = true;
  if ((PkgPending|(whom->PendBitz)) !=0) Clean_Un_pend(whom); // dispose drag
  evx = Evp_Chk(whom->_event_list_);
  if (flushit||noWait) if (evx==NULL) {
    if (noWait) evp->EvSend = MySelf(); // so can't get stuck in loop
    return false;}
  if (evx != NULL) {
    // Valid8_Event(evx);
    if (evx->GetState() == 2) { // we have a reply to send..
      fromm = evx->EvSend;
      evx = De_Queue(whom);
      if (evx != NULL) if (Valid_Process(fromm)) {
        if (evp != NULL) Copy_Event(evx,evp); // *evx = *evp;
        evx->EvSend = fromm;
        Signal32(fromm->_reply_wait_);}}}
  while (true) {
    if (!flushit) Wait32(whom->_wait_event_);
    else if (whom->_event_list_ == NULL) return false;
    evx = De_Queue(whom);
    if (evx==NULL) { // huh??
      if (flushit) return false;
      continue;}
    See_Panic(ORD("-Ev-"));
    See_Panic(ORD_(evx->EventNo));
    See_Panic(ORD_(ProcID(whom)));
    if (evp != NULL) Copy_Event(evp,evx); // *evp = *evx;
    flushit = Sys_Trace|FlushDBlog; // S_T=0, FlushDBlog=SyBits#20
    if (!flushit) {
      if (PkgPending !=0) flushit = true;
      else if (whom->PendBitz !=0) flushit = true;}
    if (DebugLogFile) if (flushit)
      SystemDebugLog(Int2Log(_S_0024 /*--GetEv */,ORD_4(ProcID(whom)),
          Int2Log(_S_0025 /* < */,ORD_4(ProcID(evx->EvSend)),
          Int2Log(_S_0001 /* */,ORD_4(evx->EventNo),
          Int2Log(_S_0001 /* */,evx->EvInfo,Int2Log(_S_0026 /*, */,evx->EvLocn,
          Int2Log(_S_0026 /*, */,evx->EvDatum,
          Int2Log(_S_0006 /* -- */,evx->GetState(),
          Int2Log(_S_0018 /*+*/,whom->PendBitz,
          Int2Log(_S_0023 /* #*/,PkgPending,FormTimeMS())))) ))))) );
    if (evx->GetState() ==0) {
      if (whom->PendBitz ==2) if (evx->EventNo == CHR4("Drag"))
        if (PkgPending==1) PkgPending = 2; // make drag disposable
      if (whom->PendBitz ==5) if (PkgPending==4)
        if (((ORD_4(evx->EventNo)|0x20202020) == CHR4("drtr"))
            || (evx->EventNo == CHR4("Drop"))) PkgPending = 5; // ditto
      down__ptr((int*)Evp_Chk(evx));} // delete evx;}
    return true;}} // ~Fetch_Event

void CameForWho(String str) { // logs process ID # \n; unused unless SigWait=true
  if (DebugLogFile) SystemDebugLog(_cat_(_cat_(str," "),_Str4_(WhoAmI())));}

/////////////////////////////////////////////// J.Brown's 2004 www.catch22.net

// DragonDrop functions (still inside _FrameWork_ namespace)..

#ifdef MOS_System // not needed otherwise

// D&D code adapted from <http://www.catch22.net/tuts/dragdrop.asp> [Part 1]

// Implementation of the IDropSource COM interface

class CDropSource : public IDropSource {
public: // IUnknown members
  HRESULT __stdcall QueryInterface(REFIID iid, void ** ppvObject);
  ULONG   __stdcall AddRef(void);
  ULONG   __stdcall Release(void);
// IDropSource members
  HRESULT __stdcall QueryContinueDrag(BOOL fEscapePressed, DWORD grfKeyState);
  HRESULT __stdcall GiveFeedback(DWORD dwEffect);
// Constructor / Destructor
  CDropSource();
  ~CDropSource();
private: LONG DS_RefCount;}; // ~CDropSource

CDropSource::CDropSource() {DS_RefCount = 1;}
CDropSource::~CDropSource() {}
ULONG __stdcall CDropSource::AddRef(void) {
  return InterlockedIncrement(&DS_RefCount);} // increment object ref count
ULONG __stdcall CDropSource::Release(void) {
  LONG count = InterlockedDecrement(&DS_RefCount); // decr object ref count
  if (count == 0) {
    delete this;
    return 0;}
  else return count;}

HRESULT __stdcall CDropSource::QueryInterface(REFIID iid, void **ppvObject) {
  // check to see what interface has been requested
  if ((iid == IID_IDropSource) || (iid == IID_IUnknown)) {
    AddRef();
    *ppvObject = this;
    return S_OK;}
  else {
    *ppvObject = 0;
    return E_NOINTERFACE;}}

// CDropSource::QueryContinueDrag
//   Called by OLE whenever Escape/Control/Shift/Mouse buttons have changed
HRESULT __stdcall CDropSource::QueryContinueDrag(
    BOOL fEscapePressed, DWORD grfKeyState) {
  // if the <Escape> key has been pressed since the last call, cancel the drop
  if (fEscapePressed == TRUE) return DRAGDROP_S_CANCEL;  
  // if the <LeftMouse> button has been released, then do the drop!
  if ((grfKeyState & MK_LBUTTON) == 0) return DRAGDROP_S_DROP;
  return S_OK;} // continue with the drag-drop

// CDropSource::GiveFeedback
//   Return either S_OK, or DRAGDROP_S_USEDEFAULTCURSORS to instruct OLE
//     to use the default mouse cursor images
HRESULT __stdcall CDropSource::GiveFeedback(DWORD dwEffect) {
  return DRAGDROP_S_USEDEFAULTCURSORS;}

//  Helper routine to create an IDropSource object
HRESULT CreateDropSource(IDropSource** ppDropSource) {
  if (ppDropSource == 0) return E_INVALIDARG;
  *ppDropSource = new CDropSource();
  return (*ppDropSource) ? S_OK : E_OUTOFMEMORY;}

// Implementation of the IEnumFORMATETC interface
 // For Win2K and above look at the SHCreateStdEnumFmtEtc API call!!
 //  Apparently the order of formats in an IEnumFORMATETC object must be
 //  the same as those that were stored in the clipboard

class CEnumFormatEtc : public IEnumFORMATETC {
public:
  // IUnknown members
  HRESULT __stdcall QueryInterface (REFIID iid, void** ppvObject);
  ULONG __stdcall AddRef (void);
  ULONG __stdcall Release (void);

  // IEnumFormatEtc members
  HRESULT __stdcall Next (ULONG celt, FORMATETC* rgelt, ULONG* pceltFetched);
  HRESULT __stdcall Skip (ULONG celt); 
  HRESULT __stdcall Reset (void);
  HRESULT __stdcall Clone (IEnumFORMATETC** ppEnumFormatEtc);

  CEnumFormatEtc(FORMATETC* pFormatEtc, int nNumFormats);
  ~CEnumFormatEtc();

private:
  LONG EF_RefCount;           // Reference count for this COM interface
  ULONG EF_nIndex;            // current enumerator index
  ULONG EF_nNumFormats;       // number of FORMATETC members
  FORMATETC* EF_pFormatEtc;}; // array of FORMATETC objects

HRESULT CreateEnumFormatEtc(UINT nNumFormats, FORMATETC* pFormatEtc,
      IEnumFORMATETC** ppEnumFormatEtc) {
  // "Drop-in" replacement for SHCreateStdEnumFmtEtc. Called by EnumFormatEtc
  if ((nNumFormats == 0) || (pFormatEtc == 0) || (ppEnumFormatEtc == 0))
    return E_INVALIDARG;
  *ppEnumFormatEtc = new CEnumFormatEtc(pFormatEtc, nNumFormats);
  return (*ppEnumFormatEtc) ? S_OK : E_OUTOFMEMORY;}

static void DeepCopyFormatEtc(FORMATETC* dest, FORMATETC* source) {
  // Helper function to perform a "deep" copy of a FORMATETC
  *dest = *source; // copy the source FORMATETC into dest
  if (source->ptd) {
    // allocate memory for the DVTARGETDEVICE if necessary
    dest->ptd = (DVTARGETDEVICE*)CoTaskMemAlloc(sizeof(DVTARGETDEVICE));
    // copy the contents of the source DVTARGETDEVICE into dest->ptd
    *(dest->ptd) = *(source->ptd);}}

CEnumFormatEtc::CEnumFormatEtc(FORMATETC *pFormatEtc, int nNumFormats) {
  EF_RefCount = 1;
  EF_nIndex = 0;
  EF_nNumFormats = nNumFormats;
  EF_pFormatEtc = new FORMATETC[nNumFormats];
  for (int i = 0; i < nNumFormats; i++) // copy the FORMATETC structures
    DeepCopyFormatEtc(&EF_pFormatEtc[i], &pFormatEtc[i]);}

CEnumFormatEtc::~CEnumFormatEtc() { // Destructor
  if (EF_pFormatEtc) {
    for (ULONG i = 0; i < EF_nNumFormats; i++)
      if (EF_pFormatEtc[i].ptd) CoTaskMemFree(EF_pFormatEtc[i].ptd);
    delete[] EF_pFormatEtc;}}

ULONG __stdcall CEnumFormatEtc::AddRef(void) {
  return InterlockedIncrement(&EF_RefCount);} // increment object ref count

ULONG __stdcall CEnumFormatEtc::Release(void) {
  LONG count = InterlockedDecrement(&EF_RefCount); // decrement object ref count
  if (count == 0) {
    delete this;
    return 0;}
  else return count;}

HRESULT __stdcall CEnumFormatEtc::QueryInterface(REFIID iid, void** ppvObject) {
  // check to see what interface has been requested
  if ((iid == IID_IEnumFORMATETC) || (iid == IID_IUnknown)) {
    AddRef();
    *ppvObject = this;
    return S_OK;}
  else {
    *ppvObject = 0;
    return E_NOINTERFACE;}}

HRESULT __stdcall CEnumFormatEtc::Next(ULONG celt, FORMATETC* pFormatEtc,
      ULONG* pceltFetched) {
  // If the returned FORMATETC structure contains a non-null "ptd" member, then
  // the caller must free this using CoTaskMemFree (stated in the COM doc)
  ULONG copied  = 0;
  if (celt == 0 || pFormatEtc == 0) return E_INVALIDARG; // validate arguments
  // copy FORMATETC structures into caller's buffer
  while (EF_nIndex < EF_nNumFormats && copied < celt) {
    DeepCopyFormatEtc(&pFormatEtc[copied], &EF_pFormatEtc[EF_nIndex]);
    copied++;
    EF_nIndex++;}
  if (pceltFetched != 0) *pceltFetched = copied; // store result
  return (copied == celt) ? S_OK : S_FALSE;} // did we copy all requested?

HRESULT __stdcall CEnumFormatEtc::Skip(ULONG celt) {
  EF_nIndex += celt;
  return (EF_nIndex <= EF_nNumFormats) ? S_OK : S_FALSE;}

HRESULT __stdcall CEnumFormatEtc::Reset(void) {
  EF_nIndex = 0;
  return S_OK;}

HRESULT __stdcall CEnumFormatEtc::Clone(IEnumFORMATETC ** ppEnumFormatEtc) {
  HRESULT hResult // make a duplicate enumerator..
    = CreateEnumFormatEtc(EF_nNumFormats, EF_pFormatEtc, ppEnumFormatEtc);
  if (hResult == S_OK) // manually set the index state
    ((CEnumFormatEtc*) *ppEnumFormatEtc)->EF_nIndex = EF_nIndex;
  return hResult;}

//	Implementation of the IDataObject COM interface

class CDataObject : public IDataObject {
  public: // IUnknown members
    HRESULT __stdcall QueryInterface (REFIID iid, void ** ppvObject);
    ULONG   __stdcall AddRef (void);
    ULONG   __stdcall Release (void);
    // IDataObject members
    HRESULT __stdcall GetData(FORMATETC* pFormatEtc, STGMEDIUM* pMedium);
    HRESULT __stdcall GetDataHere(FORMATETC* pFormatEtc, STGMEDIUM *pMedium);
    HRESULT __stdcall QueryGetData(FORMATETC* pFormatEtc);
    HRESULT __stdcall GetCanonicalFormatEtc (FORMATETC* pFormatEct,
          FORMATETC* pFormatEtcOut);
    HRESULT __stdcall SetData(FORMATETC* pFormatEtc, STGMEDIUM* pMedium,
          BOOL fRelease);
    HRESULT __stdcall EnumFormatEtc(DWORD dwDirection,
          IEnumFORMATETC** ppEnumFormatEtc);
    HRESULT __stdcall DAdvise(FORMATETC* pFormatEtc, DWORD advf,
          IAdviseSink* pAdvSink, DWORD* pdwConnection);
    HRESULT __stdcall DUnadvise(DWORD dwConnection);
    HRESULT __stdcall EnumDAdvise(IEnumSTATDATA** ppEnumAdvise);
    
    CDataObject(FORMATETC* fmt, STGMEDIUM* stgmed, int count); // Constructor
    ~CDataObject();

  private:
    int LookupFormatEtc(FORMATETC* pFormatEtc);
    LONG DO_RefCount;
    FORMATETC* DO_pFormatEtc;
    STGMEDIUM* DO_pStgMedium;
    LONG DO_nNumFormats;}; // ~CDataObject

CDataObject::CDataObject(FORMATETC* fmtetc, STGMEDIUM* stgmed, int count) {
  DO_RefCount = 1;
  DO_nNumFormats = count;
  DO_pFormatEtc = new FORMATETC[count];
  DO_pStgMedium = new STGMEDIUM[count];
  for (int i = 0; i < count; i++) {
    DO_pFormatEtc[i] = fmtetc[i];
    DO_pStgMedium[i] = stgmed[i];}}

CDataObject::~CDataObject() { // Destructor
  if (DO_pFormatEtc) delete[] DO_pFormatEtc; // cleanup..
  if (DO_pStgMedium) delete[] DO_pStgMedium;
  /* OutputDebugString("oof\n"); */}

ULONG __stdcall CDataObject::AddRef(void) {
  return InterlockedIncrement(&DO_RefCount);} // increment object ref count

ULONG __stdcall CDataObject::Release(void) {
  LONG count = InterlockedDecrement(&DO_RefCount); // decrement object ref count
  if (count == 0) {
    delete this;
    return 0;}
  else return count;}

HRESULT __stdcall CDataObject::QueryInterface(REFIID iid, void** ppvObject) {
  // check to see what interface has been requested
  if (iid == IID_IDataObject || iid == IID_IUnknown) {
    AddRef();
    *ppvObject = this;
    return S_OK;}
  else {
    *ppvObject = 0;
    return E_NOINTERFACE;}}

HGLOBAL DupMem(HGLOBAL hMem) {
  // lock the source memory object
  DWORD len = GlobalSize(hMem);
  PVOID source = GlobalLock(hMem);
  PVOID dest = GlobalAlloc(GMEM_FIXED, len); // create a fixed "global" block
  memcpy(dest, source, len);  // i.e. just a regular lump of our process heap
  GlobalUnlock(hMem);
  return (HGLOBAL)dest;}

int CDataObject::LookupFormatEtc(FORMATETC* pFormatEtc) {
  for (int i = 0; i < DO_nNumFormats; i++) 
    if ((pFormatEtc->tymed & DO_pFormatEtc[i].tymed)
      && pFormatEtc->cfFormat == DO_pFormatEtc[i].cfFormat
      && pFormatEtc->dwAspect == DO_pFormatEtc[i].dwAspect) return i;
  return -1;}

HRESULT __stdcall CDataObject::GetData (FORMATETC* pFormatEtc,
      STGMEDIUM* pMedium) {
  int idx = LookupFormatEtc(pFormatEtc);
  // try to match the requested FORMATETC with one of our supported formats
  if (idx == -1) return DV_E_FORMATETC;
  // found a match! transfer the data into the supplied storage-medium
  pMedium->tymed = DO_pFormatEtc[idx].tymed;
  pMedium->pUnkForRelease = 0;
  switch (DO_pFormatEtc[idx].tymed) {
  case TYMED_HGLOBAL:
    pMedium->hGlobal = DupMem(DO_pStgMedium[idx].hGlobal);
    // return S_OK;
    break;
  default: return DV_E_FORMATETC;}
  return S_OK;}

HRESULT __stdcall CDataObject::GetDataHere (FORMATETC* pFormatEtc,
      STGMEDIUM* pMedium) {
  // GetDataHere is only required for IStream and IStorage mediums
  // It is an error to call GetDataHere for things like HGLOBAL
  //  and other clipboard formats
  return DATA_E_FORMATETC;} // OleFlushClipboard

HRESULT __stdcall CDataObject::QueryGetData (FORMATETC* pFormatEtc) {
  // Called to see if the IDataObject supports the specified format of data
  return (LookupFormatEtc(pFormatEtc) == -1) ? DV_E_FORMATETC : S_OK;}

HRESULT __stdcall CDataObject::GetCanonicalFormatEtc (FORMATETC* pFormatEct,
      FORMATETC* pFormatEtcOut) {
  pFormatEtcOut->ptd = NULL; // Apparently we have to set this field to NULL
  return E_NOTIMPL;} // .. even though we don't do anything else

HRESULT __stdcall CDataObject::SetData (FORMATETC* pFormatEtc,
      STGMEDIUM* pMedium,  BOOL fRelease) {
  return E_NOTIMPL;}

HRESULT __stdcall CDataObject::EnumFormatEtc (DWORD dwDirection,
      IEnumFORMATETC** ppEnumFormatEtc) {
  // for Win2k+ you can use the SHCreateStdEnumFmtEtc API call, however
  // to support all Windows platforms we need to implement IEnumFormatEtc
  if (dwDirection == DATADIR_GET) 
    return CreateEnumFormatEtc(DO_nNumFormats, DO_pFormatEtc, ppEnumFormatEtc);
  else return E_NOTIMPL;} // the direction specified is not support for drag+drop

HRESULT __stdcall CDataObject::DAdvise (FORMATETC* pFormatEtc, DWORD advf,
      IAdviseSink* pAdvSink, DWORD *pdwConnection) {
  return OLE_E_ADVISENOTSUPPORTED;}

HRESULT __stdcall CDataObject::DUnadvise (DWORD dwConnection) {
  return OLE_E_ADVISENOTSUPPORTED;}

HRESULT __stdcall CDataObject::EnumDAdvise (IEnumSTATDATA** ppEnumAdvise) {
  return OLE_E_ADVISENOTSUPPORTED;}

HRESULT CreateDataObject (FORMATETC* fmtetc, STGMEDIUM* stgmeds, UINT count,
      IDataObject** ppDataObject) { // Helper function
  if (ppDataObject == 0) return E_INVALIDARG;
  *ppDataObject = new CDataObject(fmtetc, stgmeds, count);
  return (*ppDataObject) ? S_OK : E_OUTOFMEMORY;}

HANDLE StringToHandle(char* szText) {
  void* ptr;
  int nTextLen = lstrlen(szText)+1;
  HGLOBAL ClipData = GlobalAlloc(GHND|GMEM_SHARE,nTextLen);
  // allocate and lock a global memory buffer. Make it fixed
  // data so we don't have to use GlobalLock
  // ptr = (void*)GlobalAlloc(GMEM_FIXED, nTextLen);
  ptr = (void*)GlobalLock(ClipData);
  memcpy(ptr, szText, nTextLen); // copy the str into the buffer
  GlobalUnlock(ClipData);
  return (HANDLE)ClipData;}

#endif // MOS_System

/////////////////////////////////////////// end of J.Brown's D&D code (320 LoC)

// Graphics-related operations..

_Event_ xev;
int DoGooey(int msg, Char4 EvNo, int eInfo, int EvLoc, int EvDat) {
  Process usn = MySelf();
  _Event_ ev;
  set_ary_size((void*)&ev,-9,9);
  // Valid8_Event(&ev);
  // Valid8_Event(&xev);
  ev.EventNo = EvNo;
  ev.EvInfo = eInfo;
  ev.EvLocn = EvLoc;
  ev.EvDatum = EvDat;
  ev.EvSend = usn;
#if Panic_Log
  See_Panic(ORD("Goo+"));
  See_Panic(ORD_(EvNo));
  if (EvNo == CHR4("Wacc")) See_Panic(eInfo);
  See_Panic(ORD_(ProcID(usn)));
#endif // Panic_Log
  if (DebugLogFile) if (Sys_Trace|FlushDBlog)
    SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(
        _cat_(_cat_("-->Gooy ",_Str4_(ProcID(usn)))," "),
        _Str_(msg)),", '"),_Str4_(EvNo)),"' "),FormInt(eInfo)),
        " "),FormInt(EvLoc))," "),FormInt(EvDat)),FormTimeMS()));
  if (msg == WEV_PkgDunn) {
    set_ary_size((void*)&xev,-9,9);
    xev = ev;
    PostMessage(GooeyWin,msg,0,(LPARAM)(&xev));
    return 0;}
  if (I_am_Gooey()) Do_WinEvent(msg,&ev);
    else SendMessage(GooeyWin,msg,0,(LPARAM)(&ev));
  if (msg == WEV_PopMenu) while (ev.EvInfo == HiBit)
    if (Pending_Event == NULL) break; // huh??
      else SendMessage(GooeyWin,WEV_Delay,0,(LPARAM)(&ev));
  if (DebugLogFile) if (Sys_Trace|FlushDBlog)
    SystemDebugLog(_cat_(_cat_(_cat_(_cat_("<--Goox ",
        _Str4_(ProcID(usn)))," "),FormInt(ev.EvInfo)),FormTimeMS()));
  See_Panic(ORD("Goo-"));
  return ev.EvInfo;} // ~DoGooey

 } // (temp'ly) end namespace  _FrameWork_

////////////////////////////////////////////////////////////////////////

/// Opaque Window type, implemented as a pointer to WindInfo class (from T2C)..

Widgit _WindInfo_::Get_Wgt(int parm) { // hopefully inline
  if (parm==_wFocus) return wFocus;
    else return (Widgit)up__ptr(wChild);}
int _WindInfo_::Win_Get(int parm) { // hopefully inline
  //Point pt;
  if (parm>99) return (wFlags>>(parm-100))&1; // get flag bit
  switch (parm) {
  case _rTop: case _rLeft:
    return Pack2ints(rTop,rLeft);
  case _rBotm: case _rRite:
    return Pack2ints(rBotm-rTop,rRite-rLeft);
  case _wKind: return ORD_(wKind);
  case _wName:
    if (Is4chars(ORD_(wName))) return ORD_(wName);
    return ORD("????");
  case _wFlags: return wFlags;
  case _wWindo:
    return 0;
  case _FoBgColo: return FoBgColo;
  case _MoInfo: return MoInfo;
  case _HostInfo: return HostInfo;
  //case _theText:
  //  return (int)theText;
  case _wOwner: return ORD_(wOwner);
  case _wNxID: return ORD_(wNxID);
  case _wTextVH: return (int)wTextVH;
  case _wUserData: return wUserData;
  case _wMoreInfo: return wMoreInfo;
  case _wCoverR: return wCoverR;}
  return 0;} // ~Win_Get

void _WindInfo_::Set_Wgt(Widgit datum, int parm) { // hopefully inline
  if (parm==_wFocus) wFocus = datum;
  else if (parm==_wChild) wChild = datum;}
void _WindInfo_::Set_Title(String title) {
  String old = theText;
  if (title) if (HostInfo != 0) SetWindowText(Win32Win(),Text_Of(title));
  theText = title; // transfers ref-cnt
  if (old) _FrameWork_::UpDownStr(old,-1,_BASE_+__LINE__);}

void _WindInfo_::Win_Set(int datum, int parm) {
  int abit; int vv; int hh;
  POINT wpt;
  _RectAngle_ wnRect; // RECT wnRect;
  set_ary_size((void*)(&wnRect),-6,13);
  if (parm>99) { // set flag bit..
    parm = parm-100;
    datum = datum&1;
    abit = 1<<parm;
    vv = wFlags;
    wFlags = (wFlags&(-1-abit))+(datum<<parm);
    if (parm==0) if ((vv&wiVisble) != datum) { // changed wiVisble
      coming_from("Win_Set");
      if (datum==0) {
        ShowWindow(Win32Win(),SW_HIDE);
        if (_FrameWork_::FrontedWin==Win32Win())
          _FrameWork_::FrontedWin = NULL;
        _FrameWork_::Down_Win_Cnt();}
      else {
        _FrameWork_::Up_Win_Cnt();
        ShowWindow(Win32Win(),SW_SHOW);}
      retnd_from();}
    return;}
  switch (parm) {
  case _rTop: case _rLeft:
    if (HostInfo==0) return;
    abit = wFlags&wiVisble;
    // vv = wFlags&wUpdating; // didn't work, the evt comes after we're done
    // rTop = HiWord(datum); // Rectify_MyW also does it from WM_MOVE
    // rLeft = LoWord(datum);
    wpt.x = 0; // H
    wpt.y = 0; // V
    ClientToScreen(Win32Win(),&wpt); // gets screen coord of content TL
    GetWindowRect(Win32Win(),_FrameWork_::Win32Rect(&wnRect)); // T/L,B/R rev
    if (abit !=0) ShowWindow(Win32Win(),SW_HIDE);
    // coming_from("Win_Set");
    // _FrameWork_::Up_Win_Cnt(); // += 0x10000; // pre-compensate hide msg
    // retnd_from();
    // ShowWindow(Win32Win(),SW_HIDE);}
    MoveWindow(Win32Win(),LoWord(datum)-wpt.x+wnRect.rTop, // Win32 reversed T/L
        HiWord(datum)-wpt.y+wnRect.rLeft, // wanted V -actual V +actual frame V
        wnRect.rBotm-wnRect.rTop, // keep the existing frame width (GWR is coord)
        wnRect.rRite-wnRect.rLeft,false);
    _FrameWork_::Rectify_MyWin(Win32Win(),0);
    if (abit==0) return;
    ShowWindow(Win32Win(),SW_SHOW);
    // if (vv==0) wFlags = wFlags&~wUpdating;
    return;
  case _rBotm: case _rRite:
    if (HostInfo==0) return;
    abit = wFlags&wiVisble;
    wpt.x = 0;
    wpt.y = 0;
    ClientToScreen(Win32Win(),&wpt); // gets screen coord of content TL
    vv = HiWord(datum); // desired height, width
    hh = LoWord(datum);
    // rBotm = vv+wpt.y; // actual (new) coordinates
    // rRite = hh+wpt.x; // NO, Rectify_MyWi does it from WM_SIZE
    // rTop = wpt.y;
    // rLeft = wpt.x;
    GetClientRect(Win32Win(),_FrameWork_::Win32Rect(&wnRect)); // RB = act'l sz
    vv = vv-wnRect.rRite; // how much taller it needs to get..
    hh = hh-wnRect.rBotm; // how much wider (W32 reversed B/R)
    if ((vv|hh) ==0) return;
    GetWindowRect(Win32Win(),_FrameWork_::Win32Rect(&wnRect)); // T/L,B/R rev
    if (abit !=0) ShowWindow(Win32Win(),SW_HIDE);
    // coming_from("Win_Set");
    // _FrameWork_::Up_Win_Cnt(); // += 0x10000; // pre-compensate hide msg
    // retnd_from();
    // ShowWindow(Win32Win(),SW_HIDE);}
    MoveWindow(Win32Win(),wnRect.rTop,wnRect.rLeft, // W32 wnRect rev'd T/L,B/R
        wnRect.rBotm-wnRect.rTop+hh, // existing frame width +wider
        wnRect.rRite-wnRect.rLeft+vv,false); // +taller
    _FrameWork_::Rectify_MyWin(Win32Win(),0);
    if (abit !=0) ShowWindow(Win32Win(),SW_SHOW);
    return;
  case _wKind:
    wKind = CHR4(datum);
    return;
  case _wName:
    wName = CHR4(datum);
    return;
  case _wFlags:
    wFlags = datum;
    return;
  case _FoBgColo:
    FoBgColo = datum;
    return;
  case _MoInfo:
    MoInfo = datum;
    return;
  case _HostInfo:
    HostInfo = datum;
    return;
  case _wOwner:
    wOwner = CHR4(datum);
    return;
  case _wNxID:
    wNxID = CHR4(datum);
    return;
  case _wTextVH:
    wTextVH = datum;
    return;
  case _wUserData:
    wUserData = datum;
    return;
  case _wMoreInfo:
    wMoreInfo = datum;
    return;
  case _wCoverR:
    wCoverR = datum;
    return;}} // ~Win_Set

_WindInfo_::_WindInfo_() {
  set_ary_size((void*)this,26,15);
  My__Type = WindInfo__type;
  // Next_WinID = Up4Char(Next_WinID); // caller did
  wName = NoName; // Next_WinID;
  wNxID = CHR4("0000");
  wTextVH = Nowhere;
  wCoverR = Nowhere;}

_WindInfo_::_WindInfo_(String tx, Char4 kin, Char4 owner,
      Win_Window aWin = NULL, RectAngle rc = NULL) {
  set_ary_size((void*)this,26,15); // zaps underlying wgt, probly OK
  My__Type = WindInfo__type;
  if (kin != CHR4_4_4c('M','B','a','r')) {
#ifndef MOS_System
    wNxID = OpenWinBit(true); // otherwise caller did
#else
    wNxID = NoName;
#endif // MOS_System
    wName = wNxID;}
  else wName = kin;
  wTextVH = Nowhere;
  wKind = kin;
  wOwner = owner;
  wNxID = CHR4("0000");
  wTextVH = Nowhere;
  theText = tx; // transfer ref-cnt
  Win32set(aWin);
  if (rc != NULL) {
    rTop = rc->rTop;
    rLeft = rc->rLeft;
    rBotm = rc->rBotm;
    rRite = rc->rRite;}
  else {
    rTop = 0;
    rLeft = 0;
    rBotm = 0;
    rRite = 0;}
  wWindo = NULL;
  wCoverR = Nowhere;
  if (aWin != NULL) Link_Me_In(kin);}
_WindInfo_::~_WindInfo_() { // never
  Win_Window aWin = Win32Win();
  Un_Link_Me(false);
  if (aWin) if (GetWindowLong(aWin,GWL_USERDATA)==0)
    DestroyWindow(aWin);}

void _WindInfo_::Link_Me_In(Char4 kin) {
  if (_FrameWork_::PIB_wins == NULL) {
    wWindo = NULL;
    _FrameWork_::PIB_wins = (Window)this;}
  else if (kin == CHR4("MBar")) {
    wWindo = (Window)_FrameWork_::PIB_wins;
    _FrameWork_::PIB_wins = (Window)this;}
  else {
    wWindo = (Window)_FrameWork_::PIB_wins->wWindo;
    _FrameWork_::PIB_wins->wWindo = (Window)this;}} // ~Link_Me_In

void _WindInfo_::Un_Link_Me(boolean Add2Free) { // never called
  Window lnk = _FrameWork_::PIB_wins; Window prior = NULL;
  while (lnk != NULL) {
    if (lnk==this) {
      if (prior == NULL) _FrameWork_::PIB_wins = lnk->wWindo;
        else prior->wWindo = lnk->wWindo;
      break;}
    prior = lnk;
    lnk = lnk->wWindo;}
  wWindo = NULL;
  if (Add2Free) {
    wUserData = GetTime()+5;
    prior = _FrameWork_::Free_Wins;
    if (prior != NULL) {
      while (prior->wWindo != NULL) prior = prior->wWindo;
      prior->wWindo = (Window)this;}
    else _FrameWork_::Free_Wins = (Window)this;}
  _FrameWork_::unPacifyWin(this);} // ~Un_Link_Me

namespace  _FrameWork_ { // resume hiding..

void Up_Win_Cnt(void) {
  Window_Count++;
  coming_from("Up_Win_Cnt");
  if (DebugLogFile) // if (!Sys_Trace)
    SystemDebugLog(_cat_(_cat_(_cat_(_S_0013,FormInt(Window_Count)), /*-- +Win */
        LogCameFrom(_S_0006 /* -- */,18)),LogCameFrom(_S_0001 /* */,17)));
  retnd_from();}

void Down_Win_Cnt(void) {
  // if (--Window_Count <=0) PostQuitMessage(0);
  // if (Window_Count>0xFFFF) {Window_Count -= 0x10000; return;}
  Window_Count--;
  coming_from("Down_Win_Cnt");
  if (DebugLogFile) // if (!Sys_Trace) // CameFrom logged by Asyn_Ms
    SystemDebugLog(_cat_(_S_0009 /*-- 0Win */,FormInt(Window_Count)));
  if (Window_Count <= 0)
    Asyn_Msg(CHR4("0Win"),0,0,0,_FrameWork_::MainProgram);
  retnd_from();}

Window Next_Windo(Window theWin) {
  if (theWin==NULL) return PIB_wins;
  return theWin->wWindo;}

int Valid_Window(int theWin) { // also rtns "handle" for name
  Window here = PIB_wins, yoWin = (Window)theWin;
  while (here != NULL) {
    if ((here==yoWin) || (ORD_4(here->wName) == theWin)) {
      if (here->wKind != CHR4("Wind")) if (here->wKind != CHR4("Dlog"))
        if (here->wKind != CHR4("mDlg")) return 0;
      if (here->HostInfo == 0) return 0;
      return (int)here;}
    here = here->wWindo;}
  return 0;}

Window FindWin_by32(Win_Window w32) {
  Window here = PIB_wins;
  while (here != NULL) {
    if (here->Win32Win() == w32) return here;
    here = here->wWindo;}
  return NULL;}

Win_Window GetWgtWinWin(Widgit wgt) {
  if (wgt) return wgt->Win32Win();
  return NULL;} // ~GetWgtWinWin

Widgit FindWgt_by32(Window theWin, Win_Window w32, Widgit sot) {
  Widgit theW = (Widgit)up__ptr(theWin->wChild);     // sot=NULL in only call
  while (theW != NULL) {
    if (sot==theW) return theW; // never hap
    if (theW->Win32Win() == w32) return theW;
    theW = Iter8Wigit(theW);}
  return NULL;} // ~FindWgt_by32

 } // (temply) end namespace  _FrameWork_

Char4 GetWindID(Window theWin) {
  if (theWin==NULL) return NoName;
  return theWin->wName; // if (Valid_Window(Window theWin)
  return NoName;}

String GetWinTitle(Window theWin) {
  if (theWin==NULL) return Null_Str;
  return up__ptr(theWin->theText);}

void SetWinTitle(Window theWin, String theTx) {
  if (theWin==NULL) return;
  if (_compare_(up__ptr(theWin->theText),up__ptr(theTx)) !=0)
    theWin->Set_Title(theTx);} // transfer ref-cnt

_Widgit_::_Widgit_(Window inW, Widgit par, String tx, Char4 kin,
      RectAngle rc = NULL, Win_Window aWin = NULL) {
  set_ary_size((void*)this,17,14);
  My__Type = Widgit__type;
  theText = tx; // transfer ref-cnt
  if (par != NULL) {
    if (inW == NULL) inW = par->wWindo;
    wParent = par;
    wLink = par->wChild;
    par->wChild = this;}
  if (inW != NULL) {
    inW->wNxID = Up4Char(inW->wNxID);
    wName = inW->wNxID;
    if (par == NULL) {
      wLink = inW->wChild;
      inW->wChild = this;}}
  wKind = kin;
  if (rc != NULL) {
    rTop = rc->rTop;
    rLeft = rc->rLeft;
    rBotm = rc->rBotm;
    rRite = rc->rRite;}
  else if (inW != NULL) {
    rBotm = inW->rBotm - inW->rTop;
    rRite = inW->rRite - inW->rLeft;}
  Win32set(aWin);
  wWindo = inW;}
_Widgit_::~_Widgit_() {
  Widgit par = NULL;  Widgit lnk = wParent;
  if (wParent==NULL) lnk = (Widgit) wWindo;
  if (lnk) par = lnk->wChild;
  while (par) {
    if (par==this) {
      if (par==lnk->wChild) lnk->wChild = par->wLink;
        else lnk->wLink = par->wLink;
      break;}
    lnk = par;
    par = par->wLink;}} // _Widgit_

////////////////////////////////////////////////////////////////////////

/// Utility Functions not elsewhere defined..

Char4 Unique_ProcessID(Char4 pnam4) { // used by compiled NewProgr
  Process allProgs = _FrameWork_::Ready_List;
  int bitz = ORD_(pnam4); int mask = (bitz&0x60606060)+0xE0E0E0E0
      | (((bitz^0xDFDFDFDF)+1)&0x7F7F7F7F)+0x1010101 | bitz+0x1010101 | bitz;
    mask = ((mask&0x80808080)<<1)-((mask>>7)&0x1010101); // FF in each non-char
  if (mask+1 ==0) pnam4 = CHR4("@000");
  else if (mask !=0) {
    if (mask<0) {
      bitz = (bitz&0xFFFFFF)+0x40000000; // "@" at top, if needed
      mask = mask&0xFFFFFF;}
    if ((mask&1) !=0) {
      bitz = MaskInts(bitz,0x303030,((mask+1)&(-mask-1))-1); // "000" at low end
      mask = mask&-((mask+1)&(-mask-1));}
    pnam4 = CHR4(MaskInts(bitz,0x5F5F5F5F,mask));} // "_" inside where needed
  if (allProgs != NULL) while (true) {
    if (allProgs->PIBprocID == pnam4) {
      pnam4 = Up4Char(pnam4);
      allProgs = _FrameWork_::Ready_List;
      continue;}
    allProgs = allProgs->PIBlink;
    if (allProgs == _FrameWork_::Ready_List) break;}
  return pnam4;} //~Unique_ProcessID

int GetTime(void) { // returns seconds since midnight 2000 Jan 01
  SYSTEMTIME now;
  GetLocalTime(&now);
  return _FrameWork_::Conver_Time(&now);} //~GetTime

int GetMilliSecs(void) { // returns milliseconds since midnight today
  SYSTEMTIME now;
  _Look_See_();
  GetLocalTime(&now);
  return (now.wHour*3600+now.wMinute*60+now.wSecond)*1000+now.wMilliseconds;}

namespace  _FrameWork_ { // resume

#ifdef MOS_System // these following not needed otherwise

Process Next_Prog(Process whom) {
  if (whom==NULL) return Ready_List;
  return whom->PIBlink;} //~Next_Prog

// low-level functions used by Sortit.. -- this is #ifdef'd out if no System

void Byte_Store(int* ary, int Ap, char xCh) { // might be String, but assume not
  char* theStr = (char*)ary; // caller must add extra +4 if String
  if (ary==NULL) return;           // doesn't dispose, but shouldn't need to..
  if ((ary[_fS_]&0xFF00) ==0) if (ary[_fS_]>0) ary[_fS_]--;
  if (Ap >= 0) if ((ary[_fS_+1]<<2)>Ap) theStr[Ap+_fS_*4+8] = xCh;}

boolean Dis_Order(int* ary, int Ap, int Bp) { // true if theStr[a]>theStr[b]
  unsigned char* theStr = (unsigned char*)ary; // assume it's a String,
  unsigned char xCh;  unsigned char zCh; // ..Ap,Bp relative to front of text
  if (ary==NULL) return false;
  if ((ary[_fS_]&0xFF00) ==0) if ((ary[_fS_]&255)>0) ary[_fS_]--;
  Ap = Ap+_fS_*4+12;                // doesn't dispose, but shouldn't need to
  Bp = Bp+_fS_*4+12;
  while (true) {
    xCh = theStr[Ap++];
    if (xCh=='\0') return false;
    zCh = theStr[Bp++];
    if (xCh == zCh) continue;
    xCh = Capitize(xCh);
    zCh = Capitize(zCh);
    if (xCh != zCh) return (xCh>zCh);}} //~Dis_Order

////////////////////////////////////////////////////////////////////////

// [Part 2] D&D code adapted from <http://www.catch22.net/tuts/dragdrop.asp>

String GetW32DrData(IDataObject* pDataObject) { // only from DragEnter
  int* /*LPDROPFILES*/ dropfi;
  STGMEDIUM stgmo; // adapted from J.Brown's DropData in DropTarget.cpp
  FORMATETC fmtetc = { CF_TEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
  String strn = Null_Str; // See if the dataobject has TEXT stored as a HGLOBAL
  if (pDataObject->QueryGetData(&fmtetc) == S_OK)
      if (pDataObject->GetData(&fmtetc, &stgmo) == S_OK) {
    // we asked for the data as a HGLOBAL, so access it appropriately
    strn = _Str_((char*)GlobalLock(stgmo.hGlobal));
    GlobalUnlock(stgmo.hGlobal);
    ReleaseStgMedium(&stgmo); // release the data using the COM API
    if (strn != Null_Str) return strn;}
  fmtetc.cfFormat = CF_HDROP; // try for a file path (I added this)..
  if (pDataObject->QueryGetData(&fmtetc) == S_OK)
      if (pDataObject->GetData(&fmtetc, &stgmo) == S_OK) {
    dropfi = (int*)GlobalLock(stgmo.hGlobal);
    if (dropfi) // dropfi->pFiles // only gets first file name..
      strn = NewStrText((char*)(((int)dropfi)+(*dropfi)),0,0x16280DDB);
      // strn = _Str_((char*)(((int)dropfi)+(*dropfi)));
    GlobalUnlock(stgmo.hGlobal);
    ReleaseStgMedium(&stgmo);}
  return strn;}

void DropData(HWND theWin, IDataObject* pDataObject) { // (unused)
  FORMATETC fmtetc = { CF_TEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
  STGMEDIUM stgmed;
  char* theData;
  // See if the dataobject contains any TEXT stored as a HGLOBAL
  if (pDataObject->QueryGetData(&fmtetc) == S_OK)
      if (pDataObject->GetData(&fmtetc, &stgmed) == S_OK) { // get the data
    // we asked for the data as a HGLOBAL, so access it appropriately
    theData = (char*)GlobalLock(stgmed.hGlobal);
    ///SetWindowText(theWin, (char*)theData);
    GlobalUnlock(stgmed.hGlobal);
    ReleaseStgMedium(&stgmed);}} // release the data using the COM API

class CDropTarget : public IDropTarget { // implements the IDropTarget interface
  public:
    // IUnknown implementation
    HRESULT __stdcall QueryInterface (REFIID iid, void** ppvObject);
    ULONG __stdcall AddRef (void);
    ULONG __stdcall Release (void);
  
    // IDropTarget implementation
    HRESULT __stdcall DragEnter (IDataObject* pDataObject,
        DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);
    HRESULT __stdcall DragOver (DWORD grfKeyState, POINTL pt, DWORD* pdwEffect);
    HRESULT __stdcall DragLeave (void);
    HRESULT __stdcall Drop (IDataObject* pDataObject, DWORD grfKeyState,
        POINTL pt, DWORD* pdwEffect);
  
    CDropTarget(HWND theWin); // Constructor
    ~CDropTarget();
  
  private: // internal helper functions..
    DWORD DropEffct(DWORD grfKeyState, POINTL pt, DWORD dwAllowed);
    bool QueryDataObject(IDataObject* pDataObject);
    LONG DT_RefCount; // Private member variables..
    HWND DT_hWind;
    // Window DT_myWin;
    bool DT_fAllowDrop;
    IDataObject* DT_pDataObject;}; // ~CDropTarget

CDropTarget::CDropTarget(HWND theWin) {
  DT_RefCount = 1;
  DT_hWind = theWin;
  // DT_myWin = FindWin_by32(theWin);
  DT_fAllowDrop = false;}
CDropTarget::~CDropTarget() {}

void PositionCaret(HWND hwndEdit, POINTL pt) {
  // Position the edit control's caret under the mouse
  DWORD curpos; 
  ScreenToClient(hwndEdit, (POINT*)&pt); // get character position of mouse
  curpos = (DWORD) SendMessage(hwndEdit,EM_CHARFROMPOS,0,MAKELPARAM(pt.x,pt.y));
  // set caret position
  SendMessage(hwndEdit, EM_SETSEL, LOWORD(curpos), LOWORD(curpos));}

HRESULT __stdcall CDropTarget::QueryInterface (REFIID iid, void** ppvObject) {
  if (iid == IID_IDropTarget || iid == IID_IUnknown) {
    AddRef();
    *ppvObject = this;
    return S_OK;}
  else {
    *ppvObject = 0;
    return E_NOINTERFACE;}}

ULONG __stdcall CDropTarget::AddRef(void) {
  return InterlockedIncrement(&DT_RefCount);}  

ULONG __stdcall CDropTarget::Release(void) {
  LONG count = InterlockedDecrement(&DT_RefCount);
  if (count == 0) {
    delete this;
    return 0;}
  else return count;}

bool CDropTarget::QueryDataObject(IDataObject* pDataObject) { // helper
  FORMATETC fmtetc = { CF_TEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
  // does the data object support CF_TEXT using a HGLOBAL?
  return (pDataObject->QueryGetData(&fmtetc) == S_OK);}

// from <oleidl.h> :
//   #define	DROPEFFECT_NONE	( 0 )
//   #define	DROPEFFECT_COPY	( 1 )
//   #define	DROPEFFECT_MOVE	( 2 )
//   #define	DROPEFFECT_LINK	( 4 )

DWORD CDropTarget::DropEffct(DWORD grfKeyState, POINTL pt, DWORD dwAllowed) {
  DWORD dwEffect = 0; // helper function
  // 1. check "pt" -> do we allow a drop at the specified coordinates?
  //   --> determined by caller, true if we got here
  // 2. work out that the drop-effect should be based on grfKeyState
  if (grfKeyState & MK_CONTROL) dwEffect = dwAllowed & DROPEFFECT_COPY;
  else if (grfKeyState & MK_SHIFT) dwEffect = dwAllowed & DROPEFFECT_MOVE;
  // 3. no key-modifiers were specified (or drop effect not allowed),
  //    so base the effect on those allowed by the dropsource
  if (dwEffect == 0) {
    if (dwAllowed & DROPEFFECT_COPY) dwEffect = DROPEFFECT_COPY;
    if (dwAllowed & DROPEFFECT_MOVE) dwEffect = DROPEFFECT_MOVE;}
  return dwEffect;} // ~DropEffct

HRESULT __stdcall CDropTarget::DragEnter(IDataObject* pDataObject,
      DWORD grfKeyState, POINTL pt, DWORD* pdwEffect) { // pt is abs coord
  int* CDP = ClipDragPkg; // does the dataobject contain data this window wants?
  DT_fAllowDrop = _System_::Analyze_DragStr(DT_hWind,GetW32DrData(pDataObject));
  if (DT_fAllowDrop)
      if (_System_::TrakDrag(DT_hWind,(Point)Pack2ints(pt.y,pt.x),null,0))
      if (ClipDragPkg[_fS_+2+7]&1) { // get drop effect based on keybd state..
        // CDP[7] is odd only if TrakDr->DDDH already over hotspot (drop target)
    *pdwEffect = DropEffct(grfKeyState, pt, *pdwEffect);
    SetFocus(DT_hWind);
    // Drag_Is_Busy = true; // StartDragon & TrakDrag both did it
    // PositionCaret(DT_hWind, pt);
    return S_OK;}
  *pdwEffect = DROPEFFECT_NONE;
  return S_OK;}

HRESULT __stdcall CDropTarget::DragOver(DWORD grfKeyState,
      POINTL pt, DWORD* pdwEffect) {
  if (DT_fAllowDrop)
      if (_System_::TrakDrag(DT_hWind,(Point)Pack2ints(pt.y,pt.x),null,0))
      if (ClipDragPkg[_fS_+2+7]&1) { // odd if TrakDr->DDDH sez over drop target
    *pdwEffect = DropEffct(grfKeyState, pt, *pdwEffect);
    // PositionCaret(DT_hWind, pt);
    return S_OK;}
  *pdwEffect = DROPEFFECT_NONE;
  return S_OK;}

HRESULT __stdcall CDropTarget::DragLeave(void) {
  if (!DT_fAllowDrop) return S_OK;
  IgnoreBool(_System_::TrakDrag(DT_hWind,Nowhere,null,0));
  if (PkgPending==3) _System_::Zap_TheDrag(3);
  return S_OK;}

HRESULT __stdcall CDropTarget::Drop(IDataObject* pDataObject,
      DWORD grfKeyState, POINTL pt, DWORD* pdwEffect) { // pt is abs coord
  PositionCaret(DT_hWind, pt);
  if (DT_fAllowDrop)
      if (_System_::TrakDrag(DT_hWind,(Point)Pack2ints(pt.y,pt.x),null,0))
        if (ClipDragPkg[_fS_+2+7]&1) {
    *pdwEffect = DropEffct(grfKeyState, pt, *pdwEffect);
    ClipDragPkg[_fS_+2+7] = (ClipDragPkg[_fS_+2+7]&~14)|((*pdwEffect&7)<<1);
    _System_::Drop_Here(DT_hWind,Pack2ints(pt.y,pt.x));}
  else *pdwEffect = DROPEFFECT_NONE;
  return S_OK;}

void RegisterDropWindow(HWND theWin, IDropTarget** ppDropTarget) {
  CDropTarget* pDropTarget = new CDropTarget(theWin);
  CoLockObjectExternal(pDropTarget, TRUE, FALSE); // acquire a strong lock
  RegisterDragDrop(theWin, pDropTarget); // tell OLE the window is a drop target
  *ppDropTarget = pDropTarget;}

void UnregisterDropWindow(HWND theWin, IDropTarget* pDropTarget) {
  RevokeDragDrop(theWin); // remove drag+drop
  CoLockObjectExternal(pDropTarget, FALSE, TRUE); // remove the strong lock
  pDropTarget->Release();} // release our own reference

 } // (temp'ly) end namespace  _FrameWork_ // end J.Brown's D&D code (140 LoC)

////////////////////////////////////////////////////////////////////////

/// Win32 Registry Access.. -- note: this is #ifdef'd out if no System

String GetRegistryItem(String RegName, String ItemName) {
  HKEY RegItem = (HKEY)HKEY_CURRENT_USER;      // RegName: "\ProgName\path"
  bool ok = false;
  String datum = Null_Str;
  DWORD RegSize;
  if (!ItemName) return datum;
  if (!RegName) return datum;
  if (CharAt(0,up__ptr(RegName)) == '\\') {
    RegItem = (HKEY)HKEY_LOCAL_MACHINE;
    RegName = _cat_("SOFTWARE",RegName);}
  RegSize = RegOpenKeyEx(RegItem,Text_Of(RegName),0,KEY_ALL_ACCESS,&RegItem);
  if (RegSize == ERROR_SUCCESS) {
    if (RegQueryValueEx(RegItem,Text_Of(ItemName),0,NULL,NULL,&RegSize)
        == ERROR_SUCCESS) {
      datum = _FrameWork_::NewStrText(NULL,RegSize,_BASE_+__LINE__);
      ok = (RegQueryValueEx(RegItem,Text_Of(ItemName),0,NULL,
          (LPBYTE)Text_Of(datum),&RegSize) == ERROR_SUCCESS);}
    RegSize = RegCloseKey(RegItem);
    if (_FrameWork_::SetActualStrLen(Text_Of(datum))) // make it so
      datum = Null_Str;
    if (ok) {
      if (CRLF_LEN == 2) datum = ReplacAll(Null_Str,_S_0010 /*\r*/,datum);
      if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(
          _cat_(" <GetReg> ",up__ptr(RegName)),","),up__ptr(ItemName)),
          " = '"),Substring(0,777,up__ptr(datum))),"'"),
          LogCameFrom(_S_0006 /* -- */,17)));}}
  if (!ok) {
    if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_(
        " <GetReg> ",up__ptr(RegName)),","),up__ptr(ItemName)),
        LogCameFrom(_S_0006 /* -- */,17))," (failed)"));
    if (datum) _FrameWork_::UpDownStr(datum,-1,_BASE_+__LINE__);
    datum = Null_Str;}
  if (ItemName) _FrameWork_::UpDownStr(ItemName,-1,_BASE_+__LINE__);
  _FrameWork_::UpDownStr(RegName,-1,_BASE_+__LINE__);
  return datum;} //~GetRegistryItem

void SaveRegistryItem(String datum, String RegName, String ItemName) {
  HKEY RegItem = (HKEY)HKEY_CURRENT_USER;      // RegName: "\ProgName\path"
  DWORD RegSize; DWORD Rx;
  if (!RegName) return;
  if (!ItemName) return;
  if (CharAt(0,up__ptr(RegName)) == '\\') {
    RegItem = (HKEY)HKEY_LOCAL_MACHINE;
    RegName = _cat_("SOFTWARE",RegName);}
  if (CRLF_LEN == 2) datum = ReplacAll(_Str_(CR_LF),_S_0011 /*\n*/,datum);
  if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_(
      _cat_(" <SaveReg> ",up__ptr(RegName)),","),up__ptr(ItemName)),
      " = '"),up__ptr(datum)),"'"),LogCameFrom(_S_0006 /* -- */,17)));
  Rx = RegCreateKeyEx(RegItem,Text_Of(RegName),0,NULL,0,KEY_ALL_ACCESS,
      NULL,&RegItem,&RegSize);
  if (Rx == ERROR_SUCCESS) {
    RegSize = RegSetValueEx(RegItem,Text_Of(ItemName),0,
        REG_SZ,(LPBYTE)Text_Of(datum),_len_(datum)+1);
    RegSize = RegCloseKey(RegItem);}
  if (ItemName) _FrameWork_::UpDownStr(ItemName,-1,_BASE_+__LINE__);
  if (RegName) _FrameWork_::UpDownStr(RegName,-1,_BASE_+__LINE__);
  if (datum)
    _FrameWork_::UpDownStr(datum,-1,_BASE_+__LINE__);} //~SaveRegistryItem

namespace  _FrameWork_ { // resume

void StartDragon(int flgs) { // (Win_Window theWin) // and stop when done
  int ix = 0; int tmp;
  String theTxt = Null_Str;
  DWORD dwResult; DWORD dwEffect;
  int* thePkg = ClipDragPkg;
  FORMATETC formtetc = { CF_TEXT, 0, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };
  STGMEDIUM storgmed = { TYMED_HGLOBAL, { 0 }, 0 };
  IDataObject* myDataObject;
  IDropSource* myDropSource;
  if (ClipDragPkg[4]<0) thePkg = (int*)int_2_ptr(ClipDragPkg[_fS_+2]); // mine
  if (ClipDragStr == Null_Str) {
    tmp = _System_::PkgDataOffset(up__ptr(thePkg),ORD("+L&N"));
#ifdef Bible_Trans // #def'd at top if BibleTrans or DocPrep is comp'd
    ix = _System_::PkgDataOffset(up__ptr(thePkg),ORD("+Bbl")); // rtns type offs
    if (ix>0)
      ClipDragStr = FormBiRef(Null_Str,thePkg[_fS_+2+ix+1],Null_Str); else
#endif // Bible_Trans
    if (tmp>0) {
      tmp = LoHalf(thePkg[_fS_+2+tmp+1]);
      ix = tmp>>9;
      tmp = tmp&511;
      if (ix==94) {
        tmp = tmp+512;
        ix = 93;}
      ClipDragStr = _cat_(_cat_(_Str_(ix),"."),_Str_(tmp));}
    else ClipDragStr = _S_0007 /*??*/;}
  down__ptr(thePkg);
  thePkg = NULL;
  if (DebugLogFile) if (Sys_Trace|FlushDBlog)
    SystemDebugLog(Int2Log(_S_0028 /*StartDrag #*/,PkgPending,
        Int2Log(_S_0001 /* */,ORD_4(GetWindID(SendingWin)),
        Int2Log(_S_0001 /* */,ClipDragPkg[_fS_+1],
        Int2Log(_S_0001 /* */,ClipDragPkg[_fS_+2+1],_cat_(_cat_(_cat_(
        FormTimeMS()," '"),Substring(0,25,up__ptr(ClipDragStr))),"'"))) )));
  // if (theWin) SetCapture(theWin);
  Drag_Is_Busy = true;
  if (CRLF_LEN == 2)
    theTxt = ReplacAll(_Str_(CR_LF),_S_0011 /*\n*/,up__ptr(ClipDragStr));
  else theTxt = up__ptr(ClipDragStr);
  storgmed.hGlobal = StringToHandle(Text_Of(theTxt));
  if (theTxt) _FrameWork_::UpDownStr(theTxt,-1,_BASE_+__LINE__);
  theTxt = Null_Str;
  CreateDropSource(&myDropSource);
  CreateDataObject(&formtetc,&storgmed,1,&myDataObject);
  try {
    dwResult = DoDragDrop(myDataObject,myDropSource,
        flgs|DROPEFFECT_COPY,&dwEffect); // DROPEFFECT_COPY=1, DROPEFFECT_MOVE=2
    if (dwResult == DRAGDROP_S_DROP) ix = dwEffect;}
  catch (...) {ix = -1;}
  myDataObject->Release();
  myDropSource->Release();
  // ReleaseCapture();
  ReleaseStgMedium(&storgmed); // cleanup
  Drag_Is_Busy = false;
  // if my drop is pending, can't dump data; else mark the pkg vacant..
  if (DebugLogFile) if (Sys_Trace|FlushDBlog|Drag_Trace) // D_T=T
    SystemDebugLog(Int2Log(_S_0027 /* (StopDrag) #*/,PkgPending,
        Int2Log(_S_0001 /* */,ORD_4(GetWindID(SendingWin)),
        Int2Log(_S_0001 /* */,ClipDragPkg[_fS_+1],
        Int2Log(_S_0001 /* */,ClipDragPkg[_fS_+2+1],FormTimeMS())) )));
  if (PkgPending<3) _System_::Zap_TheDrag(1);} // ~StartDragon

void SysCacheInv(int rno) {
  Log_Wait(ResFi_Lok,5);
  _System_::CacheInvalid8(NULL,-1,rno,NULL);
  Log_Signal(ResFi_Lok,5);}

#else // MOS_System

// already (still) in _FrameWork_ namespace

void SysCacheInv(int rno) {}

#endif // MOS_System

////////////////////////////////////////////////////////////////////////

void Log_This_Evt(int msg) { // called also from Sys
  Logged_Events[(Ev_Log_Ix++)&(Event_Log-1)] = msg;
  Logged_Events[Ev_Log_Ix&(Event_Log-1)] = -1;} // ~Log_This_Evt

// MsgBox and AskText..

BOOL CALLBACK MyDlgProc(HWND theWin, UINT uMsg, WPARAM wp, LPARAM lp) {
  int ix;
  char DlgResBuf[256];
  Log_This_Evt(uMsg&0xFFF|0xD000);
  switch (uMsg) {
  case WM_INITDIALOG: // 0x0110
    if (Res_Str) _FrameWork_::UpDownStr(Res_Str,-1,_BASE_+__LINE__);
    Res_Str = LineOf(1,up__ptr(Xfer_Str));
    Xfer_Str = DeleteLineOf(1,Xfer_Str);
    SetDlgItemText(theWin,IDC_AskLabel,Text_Of(Xfer_Str));
    SetDlgItemText(theWin,IDC_EdLn,Text_Of(Res_Str));
    Signal32(_FrameWork_::Goo_Lok);
    // SetWindowText(theWin,MsgBoxTitle); // dlog has no title
    SetFocus(GetDlgItem(theWin,IDC_EdLn));
    ix = _len_(Res_Str);
    if (ix>0) SendDlgItemMessage(theWin,IDC_EdLn,EM_SETSEL,0,ix);
    FrontedWin = theWin;
    BringWindowToTop(theWin);
    return false;
  case WM_COMMAND: // respond to button clicks.. // 0x0111
    switch (LOWORD(wp)) {
    case IDOK:
      ix = GetDlgItemText(theWin,IDC_EdLn,DlgResBuf,255);
      DlgResBuf[ix] = '\0';
      EndDialog(theWin,ix);
      if (Res_Str) _FrameWork_::UpDownStr(Res_Str,-1,_BASE_+__LINE__);
      Res_Str = _Str_(DlgResBuf);
      FrontedWin = NULL;
      return true;
    case IDCANCEL:
      EndDialog(theWin,-1);
      FrontedWin = NULL;
      return true;
    default: return false;}}
  return false;} // ~MyDlgProc

 } // (temporarily) end namespace  _FrameWork_

boolean Valid_LN(int ix, int nx) {
#ifdef Bible_Trans // #def'd if BibleTrans is comp'd, LNdomains vivi..
  if (ix >= 0) if (ix<94) if (nx>0) if (nx<LNdomains[_fS_+2+ix]) return true;
#endif // Bible_Trans
  return false;}

String AskText(String msg, String txt, int opt) {
  boolean remote = (GetCurrentThreadId() != Gooey_Thread_ID);
  if (remote || opt >= 0) Wait32(_FrameWork_::Goo_Lok);
  if (_FrameWork_::Xfer_Str)
    _FrameWork_::UpDownStr(_FrameWork_::Xfer_Str,-1,_BASE_+__LINE__);
  _FrameWork_::Xfer_Str = LineOf(1,_cat_(_cat_(txt,"\n"),up__ptr(msg)));
  txt = Null_Str;
  while (true) {
    if (remote) { // gotta do this in GUI thread, release, retake GooLok..
      opt = Do_Gooey(WEV_AskTx,ORD("AsTx"),0,0,opt|HiBit);
      txt = _FrameWork_::Xfer_Str; // take its ref-cnt
      _FrameWork_::Xfer_Str = Null_Str;
      Signal32(_FrameWork_::Goo_Lok);
      break;}
    if (DialogBox(_FrameWork_::Main_Context,MAKEINTRESOURCE(Ask_Text),
          _FrameWork_::theFrontWin,(DLGPROC)_FrameWork_::MyDlgProc) > 0) {
      txt = _FrameWork_::Res_Str; // transfer ref-cnt; GooLok not retaken
      _FrameWork_::Res_Str = Null_Str;}
    _FrameWork_::Fresh_Mods = true;
    if (opt<0) if (opt+opt >= 0) opt = opt&~HiBit;
    if (DebugLogFile)
      SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_("? ",
          _Str_(opt))," '"),up__ptr(msg)),"' = '"),up__ptr(txt)),"'"));
    break;}
  if (msg) _FrameWork_::UpDownStr(msg,-1,_BASE_+__LINE__);
  return txt;} // ~AskText

int MsgBox(String msg, Char4 icn, int opt) { // rtns MsgOK or MsgCancel or wh'ver
  // Display msg with icon icn and buttons as specified in opt.
  // Return button ID (formerly #) clicked by user
  int ix = 3, here = 8, tmp, bitz = 0, btnsAt = 0;
  if (GetCurrentThreadId() != Gooey_Thread_ID) { // gotta do this in GUI thread..
    Wait32(_FrameWork_::Goo_Lok);
    if (_FrameWork_::Xfer_Str)
      _FrameWork_::UpDownStr(_FrameWork_::Xfer_Str,-1,_BASE_+__LINE__);
    _FrameWork_::Xfer_Str = msg; // take its cnt
    opt = Do_Gooey(WEV_MsgBx,ORD("MsBx"),ORD_(icn),0,opt); // releases GooLok
    // Signal32(_FrameWork_::Goo_Lok);
    return opt;}
  if (DebugLogFile)
    SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_(_cat_("!",
        _Str4_(icn))," "),_Str_(opt))," '"),up__ptr(msg)),"'"));
  if (opt==0) {
    bitz = 1;
    btnsAt = 1;}
  else while (ix>0) { // ix is the btn position: 1..3
    tmp = (((opt>>here)&7)-1); // msg: OK=0, Cancel=1, No=2, Yes=3; not Resume=8
    if ((tmp&3)==tmp) if ((bitz&(1<<tmp))==0) { // nor Save=5, Discard=6, All=7
      bitz = bitz+(1<<tmp); // got this msg
      btnsAt = btnsAt+(ix<<(tmp<<1));} // btn posn of this msg
    ix--;
    here = here-4;}
  if ((bitz&14)==14) {
    here = MB_YESNOCANCEL;
    if (tmp==1) here = here+MB_DEFBUTTON3;
    else if (tmp==2) here = here+MB_DEFBUTTON2;}
  else if ((bitz&3)==3) {
    here = MB_OKCANCEL;
    if (tmp==1) here = here+MB_DEFBUTTON2;}
  else if ((bitz&12)==12) {
    here = MB_YESNO;
    if (tmp==2) here = here+MB_DEFBUTTON2;}
  else here = MB_OK; // if (bitz&1) else return 0;
  if (icn==QuestIcon) here = here+MB_ICONQUESTION;
  else if (icn==StopIcon) here = here+MB_ICONHAND+MB_TASKMODAL;
  else if (icn==InfoIcon) here = here+MB_ICONEXCLAMATION;
  else if (icn>NoName) here = here+MB_ICONASTERISK;
  _FrameWork_::Fresh_Mods = true;
  _FrameWork_::New_MsgBx = true;
  _FrameWork_::Log_This_Evt(0xDBFF);
  // using theFrontWin keeps MsBx on top even after DoTree fronts the tree win..
  here = MessageBox(_FrameWork_::theFrontWin,Text_Of(msg),
      _FrameWork_::MsgBoxTitle,here);
  _FrameWork_::Log_This_Evt(here|0xDB00);            // =ProgramName
  _FrameWork_::New_MsgBx = false;
  _FrameWork_::FrontedWin = NULL;
  if (msg) _FrameWork_::UpDownStr(msg,-1,_BASE_+__LINE__);
  switch (here) {
    case IDOK: return 1; // MsgOK; // btnsAt&3;
    case IDCANCEL: return 2; // MsgCancel; // (btnsAt>>2)&3;
    case IDYES: return 4; // MsgYes; // (btnsAt>>6)&3;
    case IDNO: return 3;} // MsgNo;} // (btnsAt>>4)&3;}
  return 0;} // ~MsgBox

////////////////////////////////////////////////////////////////////////

// Win32 event support..

void SetCursor(int whom, Window win, RectAngle rc) { // my MOS version..
  int prior = _FrameWork_::my_Cursor;
  if (win != NULL) if (whom >= 0) {                  // calls Win32 version..
    win->FoBgColo = Pack2ints(whom,win->FoBgColo);
    _FrameWork_::Cursor_Win = NULL;
    if (DebugLogFile) if (Drag_Trace|_FrameWork_::FlushDBlog) // D_T=T
      SystemDebugLog(_cat_(_cat_(_cat_("  *SetCurs* ",_Str_(whom))," "),
          _Str4_(GetWindID(win))));
    return;}
  if (prior == whom) return;
  if ((whom&0xF0000000) == HiBit) whom = LoHalf(whom); // from Sys, don't log it
  else if (Drag_Trace) if (DebugLogFile) if ((whom >= 0) || (prior !=0))
    SystemDebugLog(_cat_(_cat_(_cat_("  *SetCurs* ",_Str_(whom)),
        "/"),_Str_(prior)));
  _FrameWork_::my_Cursor = whom;
  if (whom<0) _FrameWork_::OldCursor = _FrameWork_::HourGlass;
  else if (whom==0) _FrameWork_::OldCursor = _FrameWork_::PlainArrow;
  else if (whom==1) _FrameWork_::OldCursor = _FrameWork_::Ibeam;
  else if (whom==2) _FrameWork_::OldCursor = _FrameWork_::CrossHair;
  else if (whom==3) _FrameWork_::OldCursor = _FrameWork_::DiagonalAro;
  else if (whom==4) _FrameWork_::OldCursor = _FrameWork_::EastWest;
  else if (whom==5) _FrameWork_::OldCursor = _FrameWork_::NorthSouth;
    else _FrameWork_::OldCursor = _FrameWork_::PlainArrow;
  SetCursor(_FrameWork_::OldCursor);} //~SetCursor

namespace  _FrameWork_ { // resume

void Zap_Cursor() {
  _FrameWork_::Cursor_Win = NULL;
  if (_FrameWork_::my_Cursor > 0) {
    _FrameWork_::my_Cursor = 0;
    _FrameWork_::OldCursor = _FrameWork_::PlainArrow;}
  SetCursor(_FrameWork_::PlainArrow);} // ~Zap_Cursor

void Refresh_Modifiers() {
  _Look_See_();
  if ((GetKeyState(VK_CAPITAL)&1) !=0)
    Modifier_Keys = Modifier_Keys|CapsLockKey;
  else Modifier_Keys = Modifier_Keys&~CapsLockKey;
  if (GetKeyState(VK_SHIFT)<0) Modifier_Keys = Modifier_Keys|ShiftKey;
    else Modifier_Keys = Modifier_Keys&~ShiftKey;
  if (GetKeyState(VK_CONTROL)<0) Modifier_Keys = Modifier_Keys|ControlKey;
    else Modifier_Keys = Modifier_Keys&~ControlKey;
  if (GetKeyState(VK_APPS)<0) Modifier_Keys = Modifier_Keys|AppMenuKey;
    else Modifier_Keys = Modifier_Keys&~AppMenuKey;
  Fresh_Mods = false;} //~Refresh_Modifiers

char WinKey2ascii(char theKey) {
  WORD nuKeys[4];
  nuKeys[0] = 0;
  nuKeys[1] = 0;
  nuKeys[2] = 0;
  nuKeys[3] = 0;
  vKeyStates[theKey&255] = 255;
  if ((Modifier_Keys&ShiftKey) !=0) vKeyStates[VK_SHIFT] = 255;
  if (ToAscii((UINT)theKey,0,(LPBYTE)vKeyStates,nuKeys,0) != 1)
    nuKeys[0] = 0;
  vKeyStates[VK_SHIFT] = 0;
  vKeyStates[theKey&255] = 0;
  return (char)(nuKeys[0]&255);} //~WinKey2ascii

boolean ShowHourGlass(Win_Window theWin) {
  Window myWin = FindWin_by32(theWin);
  if (myWin == NULL) return false;
  if (myWin->wMoreInfo !=0) SetCursor(HourGlass);
  else if (OldCursor) SetCursor(OldCursor);
    else return false;
  return true;} // ~ShowHourGlass

LRESULT CantPaint(HWND theWin, PAINTSTRUCT* Ppst, Char4 why) {
  HDC graf = BeginPaint(theWin,Ppst);
  EndPaint(theWin,Ppst);
    if (DebugLogFile)
      SystemDebugLog(_cat_("? ---- CantPaint ",_Str_(why)));
  return 0;} // ~CantPaint

LRESULT CALLBACK Wind_WinProc(HWND theWin, UINT msg, WPARAM wp, LPARAM lp) {
  int ix = 0; int nx = 0; int zx; int hor; int ver; int wPrm = (int)wp;
  HDC graf;
  PAINTSTRUCT pst;
  DRAWITEMSTRUCT* dis;
  POINT wpt;
  Widgit wgt;
  Char4 whom;
  Window myWin;
  Process theProc;
  String theStr = Null_Str;
  unsigned char* TcanPtr;
  char ctitle[64];
  _RectAngle_ wnRect; // RECT wnRect;
  _Look_See_();
  set_ary_size((void*)(&wnRect),-6,13);
  Log_This_Evt(msg); // Logged_Events[(Ev_Log_Ix++)&(Event_Log-1)] = msg;
  // Logged_Events[Ev_Log_Ix&(Event_Log-1)] = -1; // visual flag to mark edge
  if (msg>Windo_Event) if (msg<WEV_NoHigher) {
    // Valid8_Event((Event)lp);
    return (LRESULT)Do_WinEvent(msg,(Event)lp);}
  switch (msg) {
  case WM_COMMAND: // mostly menu stuff here.. //                        0x0111
    coming_from("Wind_WinProc");
    if (lp==0) { // menu
      ix = wp-Menu_Comm_base;
      if (Pending_Event != NULL) if (ix<0) { // process waiting for popup..
        // Valid8_Event(Pending_Event);
        Pending_Event->EvInfo = -1-ix;
        Pending_Event = NULL;
        retnd_from();
        return 0;}
      // if (Popup_Result<0) { // process waiting for popup..
      //   if (ix<0) { // this is a popup selection..
      //     Popup_Result = -ix;
      //     return 0;}
      //   Popup_Result = 0;}
      if (ix<0) break;
      if (ix >= Num_Menus) break;
      myWin = FindWin_by32(theWin);
      if (myWin==NULL) break;
      whom = Menu_Comms[_fS_+2+ix]; // .say;
      Do_Menu_Comm(whom,myWin,Proc4ch(myWin->wOwner));}
    else if (HiWord(wp) == BN_CLICKED) {
      myWin = FindWin_by32(theWin);
      if (myWin==NULL) break;
      wgt = FindWgt_by32(myWin,(Win_Window)lp,NULL); // up-ref'd
      // wgt = FindThisWgt(wp&0xFFFF,"",myWin);
      if (wgt==NULL) break;
      if (wgt->wFlags&wManaged) if (myWin->wNxID == CHR4("PrgB")) {
        down__ptr(wgt);
        Hiden_Die(myWin);
        retnd_from();
        return 0;}
      ClikPt = Mouse_Locn; // cuz we don't get a click
      ix = HiWord(Modifier_Keys)&31;
      whom = GetWindID(myWin);
      if (ix !=0) Asyn_Msg(CHR4("ModK"),(int)ClikPt,ix,ORD_(whom),
          Proc4ch(myWin->wOwner));
      if (DebugLogFile) if (FlushDBlog|!Sys_Trace) SystemDebugLog(_cat_(
          _cat_(_cat_(_cat_(_cat_(_cat_(_cat_("-- Clik ", FormInt((int)ClikPt)),
          " "),_Str4_(wgt->wName))," "),_Str4_(whom)),
          " "),_Str4_(myWin->wOwner)));
      Asyn_Msg(CHR4("Clik"),(int)ClikPt,ORD_(wgt->wName),ORD_(whom),
          Proc4ch(myWin->wOwner));
      down__ptr(wgt);}
    else break;
    retnd_from();
    return 0;
  case WM_CHAR: // got data key (ignored for now) /// ---- (TCHAR) for unicode
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    break;
  case WM_KEYDOWN: // got keystroke
    coming_from("Wind_WinProc");
    // OEMscanCode = lp; // unneeded
    // Fresh_Mods = true; // hopefully ditto
    ix = wp&255;                          // Do_KeyDown doesn't do these..
    if (ix==VK_SHIFT) Modifier_Keys = Modifier_Keys|ShiftKey;
    else if (ix==VK_CONTROL) Modifier_Keys = Modifier_Keys|ControlKey;
    else if (ix==VK_LWIN) Modifier_Keys = Modifier_Keys|WinKey;
    else if (ix==VK_RWIN) Modifier_Keys = Modifier_Keys|WinKey;
    else if (ix==VK_APPS) Modifier_Keys = Modifier_Keys|AppMenuKey;
    else if (ix==VK_ESCAPE) Modifier_Keys = Modifier_Keys|(CapsLockKey<<5);
    else if (ix==VK_CAPITAL) Modifier_Keys = Modifier_Keys|CapsLockKey;
    else if (Do_KeyDown(theWin,ix)) ix = 0;
    retnd_from();
    if (ix>0) break;
    return 0;
  case WM_KEYUP: // modifiers: lock:0, shft:1, ctrl:2
    coming_from("Wind_WinProc");
    ix = wp&255;
    if (ix==VK_SHIFT) Modifier_Keys = Modifier_Keys&~ShiftKey;
    else if (ix==VK_CONTROL) Modifier_Keys = Modifier_Keys&~ControlKey;
    else if (ix==VK_LWIN) Modifier_Keys = Modifier_Keys&~WinKey;
    else if (ix==VK_RWIN) Modifier_Keys = Modifier_Keys&~WinKey;
    else if (ix==VK_APPS) Modifier_Keys = Modifier_Keys&~AppMenuKey;
    else if (ix==VK_ESCAPE) Modifier_Keys = Modifier_Keys&~(CapsLockKey<<5);
    else if (ix==VK_CAPITAL) if ((GetKeyState(VK_CAPITAL)&1) ==0)
      Modifier_Keys = Modifier_Keys&~CapsLockKey;
    break;
  case WM_ACTIVATE: // got new front window..
    coming_from("Wind_WinProc");
    if ((wPrm&0xFFFF) == WA_ACTIVE) if (theWin != NULL)
      if (theWin != DoxClik_Win) DoxClik_Win = NULL;
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    myWin = FindWin_by32(theWin);
    if (myWin==NULL) break;
    Windo_Activ8(myWin,wPrm);
    // SetFocus(theWin); // makes everything fail
    break;
//case WM_MENURBUTTONUP: // dunno when these happen
//  break;
  case WM_INITMENU:
    if (false) if (Clik_Trace) if (DebugLogFile)
      Menu_Logger((HMENU)wPrm,2,_S_0012 /*WM_INITMENU*/);
    break;
  case WM_MENUSELECT: // if selected, this happens before WM_EXITMENULOOP
    coming_from("Wind_WinProc");
    ix = Menu_Comm_base-1-LoHalf(wPrm);
    // if (Menu_Preselect>Menu_Hi_Chek) ... (deleted, didn't work very well
    break;
  case WM_ENTERMENULOOP:
    coming_from("Wind_WinProc");
    Menu_Is_Open = true;
    Zap_Cursor();
    break;
  case WM_EXITMENULOOP: // this happens when menu done, before WM_COMMAND
    coming_from("Wind_WinProc");
    Menu_Is_Open = false;
    if (Pending_Event != NULL) Pending_Event->EvDatum = 0; // PopReleas looks
    // if (Pending_Event != NULL) PopRelease(0);
    break;
#ifdef MOS_System
  case WM_NCLBUTTONDOWN: // click in "non-content" (frame/scrollbar)..
    coming_from("Wind_WinProc");
    Mouse_Buttons = Mouse_Buttons|HiBit; // client needs this
    wpt.x = LOWORD(lp); // capture possible scrollbar thumb position
    wpt.y = HIWORD(lp);
    // ClientToScreen(theWin,&wpt); // already is
    ScroRefLoc = (Point)Pack2ints(wpt.y,wpt.x); // absolute
    // wpt.x = 0; // save also window origin (unneed, Sys can get it)
    // wpt.y = 0;
    // ClientToScreen(theWin,&wpt);
    DoxClik_Win = NULL;
    break; // ..then let default happen
  case WM_NCMOUSEMOVE:
    coming_from("Wind_WinProc");
    _System_::Frame_Cursor(theWin,lp);
    break;
  case WM_NCRBUTTONDOWN:
    coming_from("Wind_WinProc");
    Mouse_Buttons = Mouse_Buttons|0x20000000;
    DoxClik_Win = NULL;
    break;
  case WM_NCMBUTTONDOWN:
    coming_from("Wind_WinProc");
    Mouse_Buttons = Mouse_Buttons|0x40000000;
    DoxClik_Win = NULL;
    break;
// #else // MOS_System
//  Zap_Cursor();
#endif // MOS_System
  case WM_MOUSEMOVE:
  case WM_LBUTTONDOWN:  case WM_LBUTTONUP:   case WM_LBUTTONDBLCLK:
  case WM_RBUTTONDOWN:  case WM_RBUTTONUP:   case WM_RBUTTONDBLCLK:
  case WM_MBUTTONDOWN:  case WM_MBUTTONUP:   case WM_MBUTTONDBLCLK:
  case WM_NCLBUTTONUP:  case WM_NCRBUTTONUP: case WM_NCMBUTTONUP:
    switch (msg) {
    // case WM_MOUSEMOVE:
    //   nx = 0; // already =0
    //   break;
    case WM_LBUTTONDOWN:  case WM_RBUTTONDOWN:  case WM_MBUTTONDOWN:
      nx = 1;
      break;
    case WM_LBUTTONDBLCLK:  case WM_RBUTTONDBLCLK:  case WM_MBUTTONDBLCLK:
      nx = 2;
      break;
    case WM_LBUTTONUP:   case WM_RBUTTONUP:   case WM_MBUTTONUP:
      nx = -1;
      break;
    case WM_NCLBUTTONUP: case WM_NCRBUTTONUP: case WM_NCMBUTTONUP:
      DoxClik_Win = NULL;
      nx = -2;
      break;}
    coming_from("Wind_WinProc");
    wpt.x = LOWORD(lp);
    wpt.y = HIWORD(lp);
    ClientToScreen(theWin,&wpt);
    Mouse_Locn = (Point)Pack2ints(wpt.y,wpt.x);
    if (wp&MK_CONTROL) ix = ControlKey;
    if (wp&MK_SHIFT) ix = ix+ShiftKey;
    if (wp&MK_LBUTTON) ix = ix+HiBit;
    if (wp&MK_RBUTTON) ix = ix+0x20000000;
    if (wp&MK_MBUTTON) ix = ix+0x40000000;
    // if (ix !=0) if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    Mouse_Buttons = (Mouse_Buttons&(0xFFFFFFF-ControlKey-ShiftKey))+ix;
    if (DebugLogFile) if (Clik_Trace|FlushDBlog) if (nx !=0)
      SystemDebugLog(_cat_(_cat_(_cat_(_cat_(_cat_("%% Click ",FormInt(nx)),
          " "),FormInt(lp))," "),FormInt(Mouse_Buttons)));
    if (nx>0) DoxClik_Win = theWin;
    if ((Mouse_Buttons&0x08000000) !=0) break; // CxMn sent & pending
    // if ((Mouse_Buttons&0xE0000000)==0) {
    //   if (false) if (nx==0) break;} // no longer ignore unclicked rollovers
    if (nx>0) { // any kind of click..
      ClikPt = Mouse_Locn; // absolute
      if (Tix_100ms<0) Tix_100ms = -1;} // if (theWin==GooeyWin)
    if (FlushClix>0) if ((Mouse_Buttons&0xE0000000) !=0) break;
    if (nx != -2) if (!Mouse_InDocX(theWin,nx)) break;
    retnd_from();
    return 0;
  case WM_VSCROLL:
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    if (!Scroll_Some(theWin,SB_VERT,(int)wp)) break;
    retnd_from();
    return 0;
  case WM_HSCROLL:
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    if (!Scroll_Some(theWin,SB_HORZ,(int)wp)) break;
    retnd_from();
    return 0;
  case WM_MOVE:
    wpt.x = LOWORD(lp);
    wpt.y = HIWORD(lp);
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    myWin = Rectify_MyWin(theWin,0);
    if (myWin==NULL) break;
    Asyn_Msg(CHR4("MovW"),0,Pack2ints(wpt.y,wpt.x),
        ORD_(GetWindID(myWin)),Proc4ch(myWin->wOwner));
    retnd_from();
    return 0;
  case WM_SIZE:
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    if (!Windo_Resized(theWin)) break;
    retnd_from();
    return 0;
  case WM_CLOSE:
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(0); // huh? lost menu
    myWin = FindWin_by32(theWin);
    if (myWin==NULL) break;
    if (DebugLogFile) if (FlushDBlog|!Sys_Trace)
      SystemDebugLog(_cat_(_cat_(_cat_("-- CloW ",
          _Str4_(GetWindID(myWin)))," "),_Str4_(myWin->wOwner)));
    Asyn_Msg(CHR4("CloW"),0,0,ORD_(GetWindID(myWin)),Proc4ch(myWin->wOwner));
    retnd_from();
    return 0;
  case WM_PAINT: // this also happens after a menu is released almost always
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(-1);
    myWin = FindWin_by32(theWin);
    if (myWin==NULL) break; /// return CantPaint(theWin,&pst,"Win0");
    if (myWin->wNxID != DocX4) if (myWin->wNxID != Imag4)
      if (myWin->wNxID != TxtD4) break;
    wgt = myWin->Get_Wgt(_wChild); // now up-ref'd
    if (wgt==NULL) break; /// return CantPaint(theWin,&pst,"fdw0");
    if (!Windo_Painting(theWin,&wnRect)) { // sets myScreen
      down__ptr(wgt);
      break;}
    // if (myWin->wMoreInfo !=0) un_Pacify(myWin);
    ver = wnRect.rTop; // = vert scroll in pixels; BR not used
    hor = wnRect.rLeft; // NOT rev'd T/L, cuz from T2
    zx = myScrnTall-1; // needed for hor>0; else SetDIBitsToDev fails to copy
    ix = myScrnWide-hor; // effective right edge of image
    MyBitMap.BitMapStuff.biWidth = myScrnWide;
    MyBitMap.BitMapStuff.biHeight = zx; // myScrnTall;
    graf = BeginPaint(theWin,&pst);
    GetClientRect(theWin,_FrameWork_::Win32Rect(&wnRect)); // BR = actual size
    // brusk = (HBRUSH) GetStockObject(WHITE_BRUSH); // dunno if this leaks mem?
    if (wnRect.rBotm>ix) { // V/H rev'd in Win32: win wider than image..
      wnRect.rTop = ix;
      FillRect(graf,_FrameWork_::Win32Rect(&wnRect),StockWhiteBrush);
      wnRect.rTop = 0;}
    wnRect.rLeft = zx-ver; // used to fill bottom if needed
    //  if (DebugLogFile) SystemDebugLog(String("  SetDIBits ")+wnRect.rRite+","
    //    + myScrnTall+"..."+DIB_RGB_COLORS);
    nx = hor+_fS_*4+8+24;  // +24 skips over my tares at front
      // +hor does scroll, but wraps off end
    ix = SetDIBitsToDevice(graf,0,0,ix,zx,0,0,ver,zx,
        (unsigned char*)(myScreen+nx),theBitMap,DIB_RGB_COLORS);
    if (wnRect.rTop<wnRect.rBotm) 
      FillRect(graf,_FrameWork_::Win32Rect(&wnRect),StockWhiteBrush);
    // if (ix==0) ix = GetLastError();
    nx = (wnRect.rBotm&-4)-18;
    zx = wnRect.rRite-17;
    // if (fdw->HotSpots != NULL) if (fdw->HotHit !=0)
    if (Drag_Is_Busy) if (Get_HotRect(theWin,wgt,&wnRect)) {
      ix = wnRect.rTop; // gotta reverse V/H for Win32..
      wnRect.rTop = wnRect.rLeft;
      wnRect.rLeft = ix;
      ix = wnRect.rBotm;
      wnRect.rBotm = wnRect.rRite;
      wnRect.rRite = ix;
      InvertRect(graf,_FrameWork_::Win32Rect(&wnRect));}
    // down__ptr(wgt); // Get_HotRec did
    ix = myWin->wFlags;
    if ((ix&wiClikIn) !=0) { // add trashcan..
      // if ((ix&(wiDragble|wiDropble)) == (wiDragble|wiDropble))
      //   if (myWin->wNxID == Imag4) {
      if (ix&(1<<wiUsrBitShft))
        TcanPtr = (unsigned char*)(((int)FullCan)+8+_fS_*4+24);
      else TcanPtr = (unsigned char*)(((int)eTrsCan)+8+_fS_*4+24);
      MyBitMap.BitMapStuff.biWidth = 16;
      MyBitMap.BitMapStuff.biHeight = 16;
      ix = SetDIBitsToDevice(graf,nx,zx,16,16,0,0,
          0,16,TcanPtr,theBitMap,DIB_RGB_COLORS);}
    EndPaint(theWin,&pst);
      ///if (DebugLogFile) SystemDebugLog(String("**"));
    unPacifyWin(myWin);
    retnd_from();
    return 0;
  case WM_DRAWITEM:
    coming_from("Wind_WinProc");
    myWin = FindWin_by32(theWin);
    if (myWin==NULL) break;
    if (myWin->wNxID != CHR4("PrgB")) break;
    dis = (DRAWITEMSTRUCT*)lp;
    // graf = dis->hDC;
    // wnRect = dis->rcItem;
    ix = dis->rcItem.left;
    nx = dis->rcItem.right;
    wnRect.rBotm = nx; // Win32 reverses T/L, B/R..
    wnRect.rLeft = dis->rcItem.top;
    wnRect.rRite = dis->rcItem.bottom;
    nx = Get_Progress_Pix(myWin,nx-ix);
    wnRect.rTop = nx+ix;
    if (wnRect.rTop<wnRect.rBotm) // this is all about horiz posn..
      FillRect(dis->hDC,_FrameWork_::Win32Rect(&wnRect),PreProgBrush);
    wnRect.rBotm = wnRect.rTop;
    wnRect.rTop = ix;
    if (wnRect.rTop<wnRect.rBotm)
      FillRect(dis->hDC,_FrameWork_::Win32Rect(&wnRect),ProgressBrush);
    FrameRect(dis->hDC,&(dis->rcItem),StockBlackPen);
    retnd_from();
    return (LRESULT)TRUE; // (LRESULT)?
  case WM_SETCURSOR:
    coming_from("Wind_WinProc");
    if (!ShowHourGlass(theWin)) break;
    retnd_from();
    return (LRESULT)TRUE;
  case WM_DROPFILES:
    //if (DragQueryFile((HDROP)wp,-1,NULL,0)>0)
    //  if (DragQueryFile((HDROP)wp,0,aStr,99)>0)
    //    MessageBox(NULL,aStr,AppName,0);
    return 0;
  case WM_TIMER:
    coming_from("Wind_WinProc");
    if (Pending_Event != NULL) PopRelease(-1); // in case nobody else notices
    Tix_100ms++;
    See_Panic(ORD("Time"));
    See_Panic(Tix_100ms);
    Tenth_Seconds = (Tenth_Seconds+1)|0xE0000000;
    Fresh_Mods = true;
#ifdef MOS_System
    if ((Tenth_Seconds&3)==0) // if (theFrontWin != NULL)
      _System_::Carat_Blink_Chk(true); // also does CallOften()
    if (n_Timers) _System_::Delaying();
    // Tix_Now++;
    // if (Tix_Now >= 36000*24) _System_::RollDate();
    if ((Mouse_Buttons&0xE8000000) == 0x08000000) {
      Mouse_Buttons = Mouse_Buttons&~0x08000000; // so not send CxMn twice
      _System_::Clear_Hilites();}
#endif // MOS_System
    myWin = Pacify_wins;
    if (myWin) if (myWin->wMoreInfo !=0) {
      ix = GetMilliSecs();
      if (ix>myWin->wMoreInfo) {
        theProc = Proc4ch(myWin->wOwner);       // if (!(theProc->Izzy_Busy()))
        if (false) if (Valid_Process(theProc)) if (myWin->wNxID == Imag4)
          Asyn_Msg(CHR4("Imag"),0,0,ORD_(GetWindID(myWin)),theProc); // got lost
        myWin->wMoreInfo = MaskInts(ix+1536,myWin->wMoreInfo,255);
        ix = myWin->wMoreInfo&255;
        theStr = GetWinTitle(myWin);
        zx = _len_(theStr);
        if (zx==ix) {
          theStr = _cat_(up__ptr(theStr)," ..");
          ShowHourGlass(myWin->Win32Win());}
        else theStr = _cat_(up__ptr(theStr),".");
        if (DebugLogFile)
          SystemDebugLog(_cat_(_cat_("  ... ",up__ptr(theStr)),FormTimeMS()));
        myWin->Set_Title(theStr); // take its cnt
        if (zx>ix+33) {
          if (DebugLogFile) if (FlushDBlog|!Sys_Trace)
            SystemDebugLog(_cat_(_cat_(_cat_("-- CloW .. ",
                 _Str4_(GetWindID(myWin)))," "),_Str4_(myWin->wOwner)));
          Asyn_Msg(CHR4("CloW"),0,0,ORD_(GetWindID(myWin)),
              Proc4ch(myWin->wOwner));}}}
    if (Tix_100ms<0) if (Tix_100ms+Tix_100ms>0) Tix_100ms = 1;
    if (Tix_100ms==0) {
      if (Window_Count>0) {
        FrontedWin = NULL;
        myWin = FindWin_by32(GooeyWin); // null if no splash
        if (myWin != NULL) myWin->wFlags = myWin->wFlags&~wiVisble;
        ShowWindow(GooeyWin,SW_HIDE);
        Asyn_Msg(CHR4("SplX"),0,0,0,_FrameWork_::MainProgram);}
      else Tix_100ms = -1;}
    if (FlushClix>0) FlushClix--;
    retnd_from();
    return 0;
  case WM_SHOWWINDOW: // catch MsgBx on its way by (MB doesn't come here)..
    coming_from("Wind_WinProc");
    if (!New_MsgBx) break;
    if (GetWindowText(theWin,ctitle,60) != 12) break;
    if (strcmp(ctitle,MsgBoxTitle) !=0) break;
    Log_This_Evt(0xDB99);
    FrontedWin = theWin;
    New_MsgBx = false;
    break;
  case WM_CREATE:
  case WM_DESTROY:
  default:
    coming_from("Wind_WinProc");
    break;} // let default happen
  retnd_from();
  return DefWindowProc(theWin,msg,wp,lp);} // ~Wind_WinProc

////////////////////////////////////////////////////////////////////////

// Initialization (InitializeAl)..

void StartGooey() {
  if (GooeyWin) return;
  _FrameWork_::Program_Name = ProgramName;
  strcpy(MsgBoxTitle,ProgramName);
  strcat(MsgBoxTitle," Message");
#ifdef Splash // #defined in Fonts.h, no longer #included by C_Turk,Csystem
  HasSplash = _System_::Create_Splash((int*)Splasher);
  // HasSplash = _FrameWork_::GooeyWin;
  FrontedWin = HasSplash;
#endif // Splash
  if (GooeyWin == NULL) GooeyWin = CreateWindow(ProgramName,ProgramName,
      WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
      32,NULL,NULL,Main_Context,NULL);
  if (GooeyWin != NULL)
    SetTimer(GooeyWin,1,100,(TIMERPROC)NULL);} //~StartGooey

boolean InitializeAll(HINSTANCE hx, bool& GotOle) {
  int ix; int rx = 0; int gx = 0; int bx = 0; int colo;
  Gooey_Thread_ID = GetCurrentThreadId();
  NewSem32(MoveOK,1," MoveOK");
  NewSem32(Strn_Lok,1," StrnLok");
  NewSem32(ResFi_Lok,1," ResFiLok");
  NewSem32(DebugLok,1," DebugLok");
  NewSem32(Panic_Lok,1," PanicLok");
  NewSem32(Even_Lok,1," EvenLok");
  NewSem32(Goo_Lok,1," GooLok");
  NewSem32(User_Lok,1," UserLok");
  set_ary_size((void*)eTrsCan,-(((int)sizeof(eTrsCan))/sizeof(int)-2-_fS_),1);
  set_ary_size((void*)FullCan,-(((int)sizeof(FullCan))/sizeof(int)-2-_fS_),1);
  MyBitMap.BitMapStuff.biSize = sizeof(BITMAPINFOHEADER);
  MyBitMap.BitMapStuff.biPlanes = 1;
  MyBitMap.BitMapStuff.biBitCount = 8;
  MyBitMap.BitMapStuff.biCompression = BI_RGB;
  MyBitMap.BitMapStuff.biSizeImage = 0;
  MyBitMap.BitMapStuff.biXPelsPerMeter = 0;
  MyBitMap.BitMapStuff.biYPelsPerMeter = 0;
  MyBitMap.BitMapStuff.biClrUsed = 216;
  MyBitMap.BitMapStuff.biClrImportant = 0;
  for (ix=0; ix<256; ix++) vKeyStates[ix] = 0;
  for (ix=0; ix<216; ix++) { // initialize color table..
    colo = (((((rx*51)<<8)+gx*51)<<8)+bx*51);
    if (bx>0) if (bx<5) colo = colo+25; // brighten the gamma a little..
    if (gx>0) if (gx<5) colo = colo+(25<<8);
    if (rx>0) if (rx<5) colo = colo+(25<<16);
    MyBitMap.ColorTbl[ix] = colo;
    rx++;
    if (rx==6) {
      gx++;
      rx = 0;
      if (gx==6) {
        bx++;
        gx = 0;}}}
  HourGlass = LoadCursor(NULL,IDC_WAIT);
  CrossHair = LoadCursor(NULL,IDC_CROSS);
  Ibeam = LoadCursor(NULL,IDC_IBEAM);
  PlainArrow = LoadCursor(NULL,IDC_ARROW);
  EastWest = LoadCursor(NULL,IDC_SIZEWE);
  NorthSouth = LoadCursor(NULL,IDC_SIZENS);
  DiagonalAro = LoadCursor(NULL,IDC_SIZENWSE);
  Wind_type.style = 0;
  Wind_type.lpfnWndProc = Wind_WinProc;
  Wind_type.cbClsExtra = 0;
  Wind_type.cbWndExtra = 0;
  Wind_type.hInstance = hx;
  //Wind_type.hIcon = LoadIcon(NULL,IDI_APPLICATION);
  Wind_type.hIcon = LoadIcon(hx,MAKEINTRESOURCE(App_Icon));
  Wind_type.hCursor = PlainArrow;
  Wind_type.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  Wind_type.lpszMenuName = NULL;
  Wind_type.lpszClassName = ProgramName;
  if (RegisterClass(&Wind_type) ==0) return false;
  StockWhiteBrush = (HBRUSH) GetStockObject(WHITE_BRUSH);
  StockBlackPen = (HBRUSH) GetStockObject(BLACK_PEN);
  PreProgBrush = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  ProgressBrush = (HBRUSH) GetStockObject(DKGRAY_BRUSH);
  Modifier_Keys = 0;
  Refresh_Modifiers();
  // NoName = CHR4("    "); // now #def'd
  // DocX4 = CHR4("DocX");
  // Imag4 = CHR4("Imag");
  // PrgB4 = CHR4("PrgB");
  // TxtD4 = CHR4("TxtD");
  // Typ4 = CHR4("Type");
  // Next_Win_ID = CHR4("#000");
#ifdef Debug_Trace
#ifdef Debug_Trace_File // could be #def'd in main app
  DebugLogFile = OpenInDir(Debug_Trace_File,WriteOnly,NULL);
#else
  DebugLogFile = OpenInDir(_Str_(Debug_Trace),WriteOnly,NULL);
#endif // Debug_Trace_File
  if (DebugLogFile) SystemDebugLog(_cat_(_cat_(_cat_(_cat_("---- ",
      ProgramName)," -- "),FormDateTime(GetTime(),0))," ----"));
#endif // Debug_Trace
  GotOle = (OleInitialize(0) == S_OK); // Initialize COM and OLE
#ifdef MOS_System // clip stuff not defined otherwise
  set_ary_size((void*)ClipDragPkg,-ClpDrgPkSz,1);
  // FILL0(ClipDragPkg,0,ClpDrgPkSz); // ClipDragPkg[_fS_+1] = ClpDrgPkSz;
  _System_::System_Inits((int*)eTrsCan,(int*)FullCan); // in C_Turk,Csystem
#else
  StartGooey();
#endif // MOS_System
  return true;} // ~InitializeAll

void Do_Global_Inits() { // called from 1st object const'r, before main() runs
  if (_my_Global_Inits_) return;
  _my_Global_Inits_++;
  _String_Log_Count_ = -1;
  C_Turk_inits();
#ifdef MOS_System
  Csystem_inits();
#endif // MOS_System
  } // ~Do_Global_Inits


 } // (final) end namespace  _FrameWork_

Process _T2F_Process_::Resume() {return NULL;} // stub: dunno what it does

void _T2F_Process_::T2F_Quit() {
  if (PIBprocID == Null4) return;
  while (_FrameWork_::Fetch_Event(NULL,this)) {} // release waiting evs
  PIBprocID = Null4;
  if (_FrameWork_::MainProgram == this) {
    _FrameWork_::MainProgram = NULL;
    ExitProcess(0);}
  else ExitThread(0);} //~T2F_Quit

// _T2F_Process_::~_T2F_Process_() {T2F_Quit();} // destructor no longer used

////////////////////////////////////////////////////////////////////////

// WinMain..

int WINAPI WinMain(HINSTANCE hx, HINSTANCE px, PSTR cx, int sho) {
  // Win32 startup procedure, calls MOS_main() after initializing
  bool GotOle = false;
  MSG  theEvent;
  _FrameWork_::Main_Context = hx;
  if (!_FrameWork_::InitializeAll(hx,GotOle)) {
    MessageBox(NULL,"Oops",ProgramName,0);
    return 0;}
  // GotOle = (OleInitialize(0) == S_OK); // Initialize COM and OLE

  // MessageBox(NULL,"Hello",ProgramName,0); // this one works

#ifndef MOS_System // C_Turk,Csystem does this after its inits..
  _FrameWork_::MainProgram = NewProgram(ProgramName,NULL,ProgramName,NULL);
#endif // MOS_System

  while (GetMessage(&theEvent,NULL,0,0)) {
    _Look_See_();
    TranslateMessage(&theEvent);
    DispatchMessage(&theEvent);} //~while

  if (_FrameWork_::MainProgram != NULL) // shouldn't happen, but just in case..
    _FrameWork_::Quit_Proc(_FrameWork_::MainProgram);
  if (DebugLogFile) FileClose(DebugLogFile);
  DebugLogFile = NULL;
  if (GotOle) { // do the following when we actually quit...
    OleUninitialize();}

  return 0;} // ~WinMain

void _Look_See_() { // called often, my own variable watcher
  int* SeeThis = 0; // put address into _See_Look_ (copied here) to watch it
  bool isPtr = false; // =true to see if a pointer got disposed
  static int* Watching = 0;  static int itsValue = 0;  static int deRefd = 0;
  if (SeeThis==0) if (_See_Look_ !=0) SeeThis = (int*)_See_Look_;
  if (SeeThis !=0) Watching = SeeThis;
  if (Watching) {
    if (*Watching != itsValue) // to stop when it changes,
      itsValue = *Watching; // ..break on this line
    if (isPtr) if (itsValue) if (*((int*)itsValue) != deRefd)
      deRefd = *((int*)itsValue);}} // ..or here to check ptr dispose

#ifdef __MSL__ // for CW linker
  int main() {WinMain(NULL,NULL,NULL,0);}
#endif // __MSL__

#endif // FrameWork_Body

#undef _BASE_ // now undefine everything we #def'd..

#ifdef Debug_Trace
#undef Debug_Trace
#endif // Debug_Trace

#undef Post_Trace
#undef Sys_Trace
#undef SigWait_Trace
#undef _Str_Logit_
#undef _Str_unLog_
// #undef _Strings_Log_ // C_Turk uses it
#undef PathSize
#undef App_Icon
#undef Ask_Text
#undef IDC_EdLn
#undef IDC_AskLabel
#undef Int_CAST
#undef Fi_Find_32
#undef FlagMask
#undef File_Destructor
// #undef BaseM_LineHgt // commented out..
// #undef Draw_Trace // commented out in SysNames.h
#undef WinFlagsOffs // #def'd in SysNames.h but not used

#undef PEEK_OFTEN

// #ifndef _C_Turk__H_
// #undef WinFile // used in C_Turk..
// #undef Zap_File_w32
// #undef C_string
// #endif // ndef _C_Turk__H_

// #undef FrameWork_Body

#ifndef _Cstuff__S_ // these are needed (but not visible) in Csystem ..
#ifndef _Csystem__H_
#undef w32RECT
#undef wPOINT
#undef FILL_0
// #undef int_2_ptr
// #undef ptr_2_int
#undef EXTRACT_Cstr
#undef MAKE_Cstr
#undef Literal_Cstr
// #undef Win_Window
#undef Cast_Proc
#undef Proc_Cast

#undef _rTop
#undef _rLeft
#undef _rBotm
#undef _rRite
#undef _wKind
#undef _wName
#undef _wFlags
#undef _wLink
#undef _wParent
#undef _wChild
#undef _wWindo
#undef _FoBgColo
#undef _theText
#undef _MoInfo
#undef _HostInfo
#undef _wOwner
#undef _wNxID
#undef _wFocus
#undef _wTextVH
#undef _wUserData
// #undef _wMoreInfo // used in ShoImagPkg/Start_WinPacify
#undef _wCoverR

#undef Sem_32
#undef NewSem32
// #undef Signal32 // used in Processes/SynchroTake/-Done..
// #undef Wait32

#undef Windo_Event
#undef WEV_HidenShoWgt
#undef WEV_Delay
#undef WEV_MsgBx
#undef WEV_AskTx
#undef WEV_CheckMenu
#undef WEV_AddMenu
#undef WEV_UndoMenu
#undef WEV_NewMenBar
#undef WEV_PopMenu
#undef WEV_NewWindow
#undef WEV_CloseWind
#undef WEV_ShowWind
#undef WEV_WindowAcc
#undef WEV_HideWind
#undef WEV_InvalRect
#undef WEV_DocScroll
#undef WEV_WigitDraw
#undef WEV_IniWidgit
#undef WEV_PkgDunn
#undef WEV_DragonDrop
#undef WEV_Splsh
#undef WEV_NoHigher

#undef Do_Gooey
#undef Gooey_Do
#undef Panic_Log
#undef Event_Log
#undef See_Panic

#undef Drag_Trace
#undef Menu_LineHeight
#undef Menu_Comm_base
#undef Max_Menus
#undef _Crash_and_Burn_
// #undef DebugLogFile // used in ShoImagPkg/Start_WinPacify
#endif // _Csystem__H_
#endif // _Cstuff__S_

#undef CR_LF
#undef CRLF_LEN

#endif // MOS_FrameWork

////////////////////////////////////////////////////////////////////////

// Global definitions..
// Object stuff..
// Utility functions..
/// array/pointer management routines..
/// 4-character-as-int (Char4) type, intrinsic to Turk/2..
// Global declarations used in WinMain/InitializeAl..
// Opaque File type, implemented as a pointer to a _File_ class (data)..
// DragonDrop data (still inside _FrameWork_ namespace)..
/// ref-counted String type, intrinsic to Turk/2..
/// Opaque File type, implemented as a pointer to a _File_ class..
/// Process management stuff..
/// Predefined Event class, implemented as a pointer to class _Event_
// DragonDrop functions (still inside _FrameWork_ namespace)..
/// Opaque Window type, implemented as a pointer to WindInfo class (from T2C)..
/// Utility Functions not elsewhere defined..
// [Part 2] D&D code adapted from <http://www.catch22.net/tuts/dragdrop.asp>
/// Win32 Registry Access.. -- note: this is #ifdef'd out if no System
// MsgBox and AskText..
// Win32 event support..
// Initialization (InitializeAl)..
// Compiled T2 functions..
// WinMain..
// now undefine everything we #def'd..

////////////////////////////////////////////////////////////////////////
